This file contains information about GCC releases which has been generated
automatically from the online release notes.  It covers releases of GCC
(and the former EGCS project) since EGCS 1.0, on the line of development
that led to GCC 3. For information on GCC 2.8.1 and older releases of GCC 2,
see ONEWS.

======================================================================
http://gcc.gnu.org/gcc-12/index.html
                             GCC 12 Release Series

   May 6, 2022

   The GCC developers are pleased to announce the release of GCC 12.1.

   This release is a major release, containing new features (as well as
   many other improvements) relative to GCC 11.x.

Release History

   GCC 12.1
          May 6, 2022 ([1]changes, [2]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [3]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [4]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [5]GCC project
   web site or contact the [6]GCC development mailing list.

   To obtain GCC please use [7]our mirror sites or [8]our version control
   system.


    For questions related to the use of GCC, please consult these web
    pages and the [9]GCC manuals. If that fails, the
    [10]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [11]gcc@gcc.gnu.org. All of [12]our lists have public
    archives.

   Copyright (C) [13]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [14]maintained by the GCC team. Last modified
   2022-05-06[15].

References

   1. http://gcc.gnu.org/gcc-12/changes.html
   2. http://gcc.gnu.org/onlinedocs/12.1.0/
   3. http://gcc.gnu.org/gcc-12/buildstat.html
   4. http://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Contributors.html
   5. http://gcc.gnu.org/index.html
   6. mailto:gcc@gcc.gnu.org
   7. http://gcc.gnu.org/mirrors.html
   8. http://gcc.gnu.org/git.html
   9. https://gcc.gnu.org/onlinedocs/
  10. mailto:gcc-help@gcc.gnu.org
  11. mailto:gcc@gcc.gnu.org
  12. https://gcc.gnu.org/lists.html
  13. https://www.fsf.org/
  14. https://gcc.gnu.org/about.html
  15. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-12/changes.html
                             GCC 12 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 12. You may also want to check out our [1]Porting
   to GCC 12 page and the [2]full GCC documentation.

Caveats

     * An ABI incompatibility between C and C++ when passing or returning
       by value certain aggregates containing zero width bit-fields has
       been discovered on various targets. As mentioned in [3]PR102024,
       since the [4]PR42217 fix in GCC 4.5 the C++ front-end has been
       removing zero width bit-fields from the internal representation of
       the aggregates after the layout of those aggregates, but the C
       front-end kept them, so passing e.g. struct S { float a; int : 0;
       float b; } or struct T { float c; int : 0; } by value could differ
       between C and C++. Starting with GCC 12 the C++ front-end no longer
       removes those bit-fields from the internal representation and per
       clarified psABI some targets have been changed, so that they either
       ignore those bit-fields in the argument passing by value decisions
       in both C and C++, or they always take them into account. x86-64,
       ARM and AArch64 will always ignore them (so there is a C ABI
       incompatibility between GCC 11 and earlier with GCC 12 or later),
       PowerPC64 ELFv2 and S/390 always take them into account (so there
       is a C++ ABI incompatibility, GCC 4.4 and earlier compatible with
       GCC 12 or later, incompatible with GCC 4.5 through GCC 11). RISC-V
       has changed the handling of these already starting with GCC 10. As
       the ABI requires, MIPS takes them into account handling function
       return values so there is a C++ ABI incompatibility with GCC 4.5
       through 11. For function arguments on MIPS, refer to [5]the MIPS
       specific entry. GCC 12 on the above targets will report such
       incompatibilities as warnings or other diagnostics unless
       -Wno-psabi is used.
     * C: Computed gotos require a pointer type now.
     * C++: Two non-standard std::pair constructors have been deprecated.
       These allowed the use of an rvalue and a literal 0 to construct a
       pair containing a move-only type and a pointer. The nullptr keyword
       should be used to initialize the pointer member instead of a
       literal 0, as this is portable to other C++ implementations.
     * The configuration option --enable-libstdcxx-allocator no longer
       supports the bitmap, mt, and pool arguments. Those configurations
       had been broken for some time.
     * Fortran: OpenMP code using the omp_lib.h include file can no longer
       be compiled with -std=f95 but now requires at least -std=f2003.
       Alternatively, use the omp_lib module, which still supports
       -std=f95 and is recommended to be used instead in general.
     * OpenMP offloading to Intel MIC has been deprecated and will be
       removed in a future release.
     * The cr16 target with the cr16-*-* configuration has been obsoleted
       and will be removed in a future release.
     * The hppa[12]*-*-hpux10* and hppa[12]*-*-hpux11* configurations
       targeting 32-bit PA-RISC with HP-UX have been obsoleted and will be
       removed in a future release.
     * The m32c*-*-rtems* configuration has been obsoleted and will be
       removed in a future release.
     * The support for the m32r-*-linux*, m32rle-*-linux*,
       m68k*-*-openbsd* and vax-*-openbsd* configurations has been
       removed.
     * STABS: Support for emitting the STABS debugging format is
       deprecated and will be removed in the next release. All ports now
       default to emit DWARF (version 2 or later) debugging info or are
       obsoleted.
     * The optimization level -Ofast now implies
       -fno-semantic-interposition.

General Improvements

     * Vectorization is enabled at -O2 which is now equivalent to the
       original -O2 -ftree-vectorize -fvect-cost-model=very-cheap. Note
       that default vectorizer cost model has been changed which used to
       behave as -fvect-cost-model=cheap were specified.
     * GCC now supports the [6]ShadowCallStack sanitizer, which can be
       enabled using the command-line option
       [7]-fsanitize=shadow-call-stack. This sanitizer currently only
       works on AArch64 targets and it requires an environment in which
       all code has been compiled with -ffixed-r18. Its primary initial
       user is the Linux kernel.

New Languages and Language specific improvements

     * OpenMP
          + OpenMP 5.0 support has been extended: The close map modifier
            and the affinity clause are now supported. In addition Fortran
            gained additionally the following features which were
            available in C and C++ before: declare variant is now
            available, depobj, mutexinoutset and iterator can now also be
            used with the depend clause, defaultmap has been updated for
            OpenMP 5.0, and the loop directive and combined directives
            involving the master directive have been added.
          + The following OpenMP 5.1 features have been added: support for
            expressing OpenMP directives as C++ 11 attributes, the masked
            and scope construct, the nothing and error directives, and
            using primary with the proc_bind clause and OMP_PROC_BIND
            environment variable, the reproducible and unconstrained
            modifiers to the order clause, and, for C/C++ only, the align
            and allocator modifiers to the allocate clause and the atomic
            extensions are now available. The OMP_PLACE environment
            variable supports the OpenMP 5.1 features. In addition the
            OMP_NUM_TEAMS and OMP_TEAMS_THREAD_LIMIT environment variables
            and their associated API routines are now supported as well as
            the memory-allocation routines added for Fortran and extended
            for C/C++ in OpenMP 5.1. In Fortran code, strictly structured
            blocks can be used.
          + The [8]OpenMP Implementation Status can be found in the
            libgomp manual.
     * The new warning flag -Wopenacc-parallelism was added for OpenACC.
       It warns about potentially suboptimal choices related to OpenACC
       parallelism.
     * The offload target code generation for OpenMP and OpenACC can now
       be better adjusted using the new [9]-foffload-options= flag and the
       pre-existing but now documented [10]-foffload= flag.

  Ada

     * Ada 2022
          + Added the -gnat2022 flag to indicate strict Ada 2022
            compliance. The old -gnat2020 flag is now deprecated.
          + Support for Big Numbers (Annex G) has seen continuous
            improvements. It is now considered complete. It is compatible
            with SPARK, i.e. can be used from SPARK code.
          + Continuous improvements to the Ada 2022 standard since GCC 11.
          + Greatly improved compile time support. More functions can now
            have the with Static aspect and can be used in more contexts.
     * Ada 2022 extensions. The use of the -gnatX flag is necessary to
       access these features as they are not considered stable or
       standard.
          + Fixed lower bound for unconstrained arrays.
               o type Matrix is array (Natural range 0 .. <>, Natural
                 range 0 .. <>) of Integer; is now valid.
               o Subtypes can also specify a lower bound: subtype String_1
                 is String (1 .. <>);. Boundaries from slices will "slide"
                 to the correct lower bound of the subtype.
          + Generalized Object.Operand notation. The follwing code is now
            valid V.Add_Element(42);, with V being a vector, for example.
          + Additional when constructs. Keywords return, goto and raise
            can now use when in addition to the existing exit when. The
            following expression is therefore now valid raise
            Constraint_Error with "Element is null" when Element = null;
          + Pattern matching
               o The case statement has been extended to cover records and
                 arrays as well as finer grained casing on scalar types.
                 In the future it is expected to provide more compile time
                 guarantees when accessing discriminated fields. Case
                 exhaustion is supported for pattern matching. An example
                 would be
type Sign is (Neg, Zero, Pos);

function Multiply (S1, S2 : Sign) return Sign is
  (case (S1, S2) is
     when (Neg, Neg) | (Pos, Pos) => Pos,
     when (Zero, <>) | (<>, Zero) => Zero,
     when (Neg, Pos) | (Pos, Neg) => Neg);

     * gnatfind and gnatxref, which were already deprecated, have been
       removed.
     * Greatly expanded code covered by contracts. Thanks to this work,
       there are now several Ada standard libraries fully proven in SPARK
       which means they have no runtime nor logical errors. They are
       mostly numeric and string handling libraries.
     * Enable return-slot optimization for Pure functions.
     * General optimizations, improvements and additions to the standard
       library. Performance, correctness and in some cases stability was
       improved. Memory pools have also seen some minor enhancements.
     * Improvements to embedded-RTOS targets such as RTEMS, VxWorks and
       QNX. Older targets were removed or cleaned.
     * Added some [11]hardening features.

  C family

     * Support for __builtin_shufflevector compatible with the clang
       language extension was added.
     * Support for attribute unavailable was added.
     * A new built-in function, __builtin_assoc_barrier, was added. It can
       be used to inhibit re-association of floating-point expressions.
     * Support for __builtin_dynamic_object_size compatible with the clang
       language extension was added.
     * New warnings:
          + [12]-Wbidi-chars warns about potentially misleading UTF-8
            bidirectional control characters. The default is
            -Wbidi-chars=unpaired ([13]PR103026)
          + [14]-Warray-compare warns about comparisons between two
            operands of array type ([15]PR97573)
     * Enhancements to existing warnings:
          + [16]-Wattributes has been extended so that it's possible to
            use -Wno-attributes=ns::attr or -Wno-attributes=ns:: to
            suppress warnings about unknown scoped attributes (in C++11
            and C2X). Similarly, #pragma GCC diagnostic ignored_attributes
            "vendor::attr" can be used to achieve the same effect
            ([17]PR101940)

  C

     * Some new features from the upcoming C2X revision of the ISO C
       standard are supported with -std=c2x and -std=gnu2x. Some of these
       features are also supported as extensions when compiling for older
       language versions. In addition to the features listed, some
       features previously supported as extensions and now added to the C
       standard are enabled by default in C2X mode and not diagnosed with
       -std=c2x -Wpedantic.
          + Digit separators (as in C++) are supported for C2X.
          + The #elifdef and #elifndef preprocessing directives are now
            supported.
          + The printf and scanf format checking with [18]-Wformat now
            supports the %b format specified by C2X for binary integers,
            and the %B format recommended by C2X for printf.

  C++

     * Several C++23 features have been implemented:
          + [19]P1938R3, if consteval ([20]PR100974)
          + [21]P0849R8, auto(x): decay-copy in the language
            ([22]PR103049)
          + [23]P2242R3, Non-literal variables (and labels and gotos) in
            constexpr functions ([24]PR102612)
          + [25]P2334R1, Support for preprocessing directives elifdef and
            elifndef ([26]PR102616)
          + [27]P2360R0, Extend init-statement to allow alias-declaration
            ([28]PR102617)
          + [29]P2128R6, Multidimensional subscript operator
          + [30]DR 2397, auto specifier for pointers and references to
            arrays ([31]PR100975)
     * Several C++ Defect Reports have been resolved, e.g.:
          + [32]DR 960, Covariant functions and lvalue/rvalue references
          + [33]DR 1227, Mixing immediate and non-immediate contexts in
            deduction failure
          + [34]DR 1315, Restrictions on non-type template arguments in
            partial specializations
          + [35]DR 2082, Referring to parameters in unevaluated operands
            of default arguments
          + [36]DR 2351, void{}
          + [37]DR 2374, Overly permissive specification of enum
            direct-list-initialization
          + [38]DR 2397, auto specifier for pointers and references to
            arrays
          + [39]DR 2446, Questionable type-dependency of concept-ids
     * New command-line option -fimplicit-constexpr can be used to make
       inline functions implicitly constexpr ([40]git)
     * New command-line option -ffold-simple-inlines can be used to fold
       calls to certain trivial inline functions (currently std::move,
       std::forward, std::addressof and std::as_const). In contrast to
       inlining such calls, folding means that no intermediate code or
       debug information will be generated for them; this minimizes the
       abstraction penalty incurred for using these functions versus using
       the fundamental operations from which they're defined (e.g.
       std::move versus static_cast). This flag is enabled by default when
       -fno-inline is not active.
     * Deduction guides can be declared at class scope ([41]PR79501)
     * [42]-Wuninitialized warns about using uninitialized variables in
       member initializer lists ([43]PR19808)
     * [44]-Wint-in-bool-context is now disabled when instantiating a
       template ([45]git)
     * Stricter checking of attributes on friend declarations: if a friend
       declaration has an attribute, that declaration must be a
       definition. Moreover, a C++11 attribute cannot appear in the middle
       of the decl-specifier-seq. ([46]PR99032)
     * New warning options for C++ language mismatches:
       -Wc++11-extensions, -Wc++14-extensions, -Wc++17-extensions,
       -Wc++20-extensions, and -Wc++23-extensions. They are enabled by
       default and can be used to control existing pedwarns about
       occurrences of new C++ constructs in code using an old C++ standard
       dialect.
     * New warning [47]-Wmissing-requires warns about missing requires
       ([48]git)
     * The existing std::is_constant_evaluated in if warning was extended
       to warn in more cases ([49]PR100995)
     * [50]-Waddress has been enhanced so that it now warns about, for
       instance, comparing the address of a nonstatic member function to
       null ([51]PR102103)
     * Errors about narrowing are no longer hidden if they occur in system
       headers
     * Ordered comparison of null pointers is now rejected ([52]PR99701)
     * Anonymous structs with bases are now rejected ([53]git)
     * The compiler rejects taking the address of an immediate member
       function ([54]PR102753)
     * The compiler has support for C++20
       __cpp_lib_is_pointer_interconvertible and
       __cpp_lib_is_layout_compatible to help the C++ library implement
       [55]P0466, Layout-compatibility and Pointer-interconvertibility
       Traits ([56]PR101539)
     * Memory usage of constraint subsumption has been improved
       ([57]PR100828)
     * constinit thread_local variables are optimized better
       ([58]PR101786)
     * Support for C++17 std::hardware_destructive_interference_size was
       added, along with the [59]-Winterference-size warning ([60]git)
     * Many bugs in the CTAD handling have been fixed ([61]PR101344,
       [62]PR101883, [63]PR89062, [64]PR101233, [65]PR88252, [66]PR86439,
       [67]PR98832, [68]PR102933 ...)
     * Two-stage name lookup for dependent operator expressions has been
       corrected ([69]PR51577)
     * Several issues with constrained variable templates have been fixed
       ([70]PR98486)
     * The compiler performs less instantiating when doing speculative
       constant evaluation ([71]git)
     * Various diagnostic improvements; e.g., a more precise caret
       location for pointer-to-member expressions
     * The new -fconstexpr-fp-except flag allows IEC559 floating point
       exceptions in constant-expressions.

    Runtime Library (libstdc++)

     * Improved experimental C++20 support, including:
          + std::vector, std::basic_string, std::optional, and
            std::variant can be used in constexpr functions.
          + std::make_shared for arrays with default initialization, and
            std::atomic<std::shared_ptr<T>>.
          + Layout-compatibility and pointer-interconvertibility traits.
     * Improved experimental C++23 support, including:
          + Monadic operations for std::optional.
          + std::move_only_function
          + <spanstream>
          + std::basic_string::resize_and_overwrite
          + std::unique_ptr can be used in constexpr functions.
          + <stacktrace> (not built by default, requires linking to an
            extra library).
          + <stdatomic.h>
          + std::invoke_r
          + constexpr std::type_info::operator==

  Fortran

     * WG5/N1942, "TS 29113 Further Interoperability of Fortran with C",
       is now fully supported. In addition to implementing previously
       missing functionality, such as support for character arguments of
       length greater than one in functions marked bind(c) and gaps in the
       handling for assumed-rank arrays, numerous other bugs have been
       fixed, and an extensive set of new conformance test cases has been
       added.
     * GCC 12 now uses OPERATION as the name of the function to the
       CO_REDUCE intrinsic for the pairwise reduction, thus conforming to
       the Fortran 2018 standard. Previous versions used OPERATOR which
       conforms to TS 18508.
     * On POWER systems which support it, the -mabi=ieeelongdouble option
       now selects the IEEE 128-bit floating point format for
       REAL(KIND=16). R16_IBM and R16_IEEE have been added to the
       -fconvert option, the CONVERT specifyer of the OPEN statement and
       the GFORTRAN_CONVERT_UNIT environment variable.

libgccjit

     * The libgccjit API gained 30 new entry points:
          + 17 new "reflection" entrypoints for querying functions and
            types ([72]LIBGCCJIT_ABI_16)
          + [73]gcc_jit_lvalue_set_tls_model for supporting thread-local
            variables ([74]LIBGCCJIT_ABI_17)
          + [75]gcc_jit_lvalue_set_link_section for setting the link
            section of global variables, analogous to
            [76]__attribute__((section(".section")))
            ([77]LIBGCCJIT_ABI_18)
          + 4 new entrypoints for initializing global variables and
            creating constructors for rvalues ([78]LIBGCCJIT_ABI_19)
          + Support for sized integer types, including 128-bit integers
            and helper functions for such types ([79]LIBGCCJIT_ABI_20)
          + [80]gcc_jit_context_new_bitcast for reinterpreting the bits of
            an rvalue as a different type ([81]LIBGCCJIT_ABI_21)
          + [82]gcc_jit_lvalue_set_register_name for setting a specific
            register for a variable ([83]LIBGCCJIT_ABI_22)
          + [84]gcc_jit_context_set_bool_print_errors_to_stderr
            ([85]LIBGCCJIT_ABI_23)
          + 2 new entrypoints for setting the alignment of a variable
            ([86]LIBGCCJIT_ABI_24)
     * libgccjit has gained support for the use of various atomic builtins
       ([87]PR96066, [88]PR96067)
     * [89]gcc_jit_context_new_cast is now able to handle truncation and
       extension between different integer types ([90]PR95498)

New Targets and Target Specific Improvements

  AArch64 & arm

     * Newer revisions of the Arm Architecture are supported as arguments
       to the -march option: armv8.7-a, armv8.8-a, armv9-a.
     * The Arm Cortex-A510 CPU is now supported through the cortex-a510
       argument to the -mcpu and -mtune options.
     * GCC can now auto-vectorize operations performing sign-differing
       dot-product operations, taking advantage of instructions in the
       Advanced SIMD (AArch64/AArch32) and SVE (AArch64) instruction sets.

  AArch64

     * A number of new CPUs are supported through the -mcpu and -mtune
       options (GCC identifiers in parentheses).
          + Ampere-1 (ampere1).
          + Arm Cortex-A710 (cortex-a710).
          + Arm Cortex-X2 (cortex-x2).
     * The 64-byte atomic load/store intrinsics to accelerator memory from
       the [91]2020 Arm Architecture extensions are supported through the
       +ls64 option extension.
     * Initial code generation support is supported for hardware
       instructions used to accelerate the memcpy,memmove and memset
       standard functions. These instructions can be generated when
       compiling with the +mopsoption extension.
     * The ACLE Advanced SIMD intrinsics accessible through the arm_neon.h
       header have been significantly reimplemented and generate
       higher-performing code than previous GCC versions.
     * The option -mtune=neoverse-512tvb is added to tune for Arm Neoverse
       cores that have a total vector bandwidth of 512 bits. Please refer
       to the documentation for more details.

  AMD Radeon (GCN)

     * Debug experience with ROCGDB has been improved.
     * Support for the type __int128_t/integer(kind=16) was added.
     * For offloading, the limitation of using only one wavefront per
       compute unit (CU) has been lifted. Up to 40 workgroups per CU and
       16 wavefronts per workgroup are supported (up to a limit of 40
       wavefronts in total, per CU). Additionally, the number of used
       wavefronts and workgroups was tuned for performance.

  arm

     * Support is added for accessing the stack canary value via the TLS
       register through the -fstack-protector-guard=tls and
       -mstack-protector-guard-offset= options. This intended for use in
       Linux kernel development. Please refer to the documentation for
       more details.

  BPF

     * Support for CO-RE (compile-once, run-everywhere) has been added to
       the BPF backend. CO-RE allows to compile portable BPF programs that
       are able to run among different versions of the Linux kernel.

  IA-32/x86-64

     * New ISA extension support for Intel AVX512-FP16 was added.
       AVX512FP16 intrinsics are available via the -mavx512fp16 compiler
       switch.
     * For both C and C++ the _Float16 type is supported on x86 systems
       with SSE2 enabled. Without {-mavx512fp16}, all operations will be
       emulated in software and float instructions.
     * Mitigation against straight line speculation (SLS) for function
       return and indirect jump is supported via
       -mharden-sls=[none|all|return|indirect-jmp].
     * Add CS prefix to call and jmp to indirect thunk with branch target
       in r8-r15 registers via -mindirect-branch-cs-prefix.
     * Always use global offset table (GOT) to access external data and
       function symbols when the new -mno-direct-extern-access
       command-line option is specified.

  MIPS

     * The ABI passing arguments containing zero-width fields (for
       example, C/C++ zero-width bit-fields, GNU C/C++ zero-length arrays,
       and GNU C empty structs) has changed. Now a zero-width field will
       not prevent an aligned 64-bit floating-point field next to it from
       being passed through FPR. This is compatible with LLVM, but
       incompatible with previous GCC releases. GCC 12 on MIPS will report
       such incompatibilities as an inform unless -Wno-psabi is used.
     * The ABI returning values containing C++17 empty bases has changed.
       Now an empty base will not prevent an aggregate containing only one
       or two floating-point fields from being returned through FPR. This
       is compatible with GCC 6 and earlier, but incompatible with GCC 7
       through 11. GCC 12 on MIPS will report such incompatibilities as an
       inform unless -Wno-psabi is used.

  NVPTX

     * The -march flag has been added. The -misa flag is now considered an
       alias of the -march flag.
     * Support for PTX ISA target architectures sm_53, sm_70, sm_75 and
       sm_80 has been added. These can be specified using the -march flag.
     * The default PTX ISA target architecture has been set back to sm_30,
       to fix support for sm_30 boards.
     * The -march-map flag has been added. The -march-map value will be
       mapped to an valid -march flag value. For instance,
       -march-map=sm_50 maps to -march=sm_35. This can be used to specify
       that generated code is to be executed on a board with at least some
       specific compute capability, without having to know the valid
       values for the -march flag.
     * The -mptx flag has been added to specify the PTX ISA version for
       the generated code; permitted values are 3.1 (matches previous GCC
       versions), 6.0, 6.3, and 7.0. If not specified, the used version is
       the minimal version required for -march but at least 6.0.
     * An mptx-3.1 multilib was added. This allows using older drivers
       which do not support PTX ISA version 6.0.
     * The new __PTX_SM__ predefined macro allows code to check the PTX
       ISA target architecture being targeted by the compiler.
     * The new __PTX_ISA_VERSION_MAJOR__ and __PTX_ISA_VERSION_MINOR__
       predefined macros allows code to check the PTX ISA version being
       targeted by the compiler.

  PowerPC / PowerPC64 / RS6000

     * The internal implementation of Power's target-specific built-in
       functions has been rewritten to be easier and less error-prone to
       maintain. Every attempt has been made to ensure that the new
       behavior matches the old behavior, but inevitably some bugs can be
       expected. Please report any problems via [92]GCC Bugzilla.
     * The built-in functions __builtin_get_texasr, __builtin_get_texasru,
       __builtin_get_tfhar, __builtin_get_tfiar, __builtin_set_texasr,
       __builtin_set_texasru, __builtin_set_tfhar, and __builtin_set_tfiar
       now behave as documented in all supported configurations. On prior
       releases, the arguments and return values of these functions were
       treated as unsigned long long instead of as unsigned long, when the
       options -m32 -mpowerpc64 were in effect.
     * The overloaded built-in functions vec_cntlz_lsbb and vec_cnttz_lsbb
       now behave as documented. On prior releases, these built-in
       functions had incorrect semantics on little-endian targets.

  PRU

     * The [93]__regio_symbol variable qualifier has been added. It allows
       easier access in C programs to the __R30 and __R31 CPU I/O
       registers.

  RISC-V

     * Default ISA spec version was bump to 20191213, more detail see this
       [94]announcement
     * New ISA extension support for zba, zbb, zbc, zbs was added.
     * New ISA extension support for vector and scalar crypto was added,
       only support architecture testing marco and -march= parsing.
     * The option -mtune=thead-c906 is added to tune for T-HEAD c906
       cores.

Operating Systems

Improvements to Static Analyzer

     * The analyzer has gained a [95]-Wanalyzer-use-of-uninitialized-value
       warning, similar to [96]-Wuninitialized and
       [97]-Wmaybe-uninitialized, but based on an interprocedural
       path-sensitive analysis ([98]PR95006).
       Such warnings are not disabled by the new
       [99]-ftrivial-auto-var-init (see below), as the latter is
       considered a mitigation option.
     * [100]-Wanalyzer-write-to-const and
       [101]-Wanalyzer-write-to-string-literal will now check for
       [102]__attribute__ ((access, ....)) on calls to externally-defined
       functions, and complain about read-only regions pointed to by
       arguments marked with a write_only or read_write attribute
       ([103]PR104793).
     * The analyzer's "taint" mode, activated by
       [104]-fanalyzer-checker=taint (in addition to [105]-fanalyzer), has
       gained four new taint-based warnings:
          + [106]-Wanalyzer-tainted-allocation-size for e.g.
            attacker-controlled malloc and alloca,
          + [107]-Wanalyzer-tainted-divisor for detecting where an
            attacker can inject a divide-by-zero,
          + [108]-Wanalyzer-tainted-offset for attacker-controlled pointer
            offsets,
          + [109]-Wanalyzer-tainted-size for attacker-controlled values
            being used as a size parameter to calls to memset or to
            functions marked with [110]__attribute__ ((access, ....)).
       The existing [111]-Wanalyzer-tainted-array-index has been reworded
       to talk about "attacker-controlled" rather than "tainted" values,
       for consistency with the new warnings.
       A new [112]__attribute__ ((tainted_args)) has been added to the C
       and C++ frontends, usable on functions, and on function pointer
       callback fields in structs. The analyzer's taint mode will treat
       all parameters and buffers pointed to by parameters of such
       functions as being attacked-controlled, such as for annotating
       system calls in an operating system kernel as being an "attack
       surface".
     * The analyzer now respects [113]__attribute__((const)): it will
       treat such functions as returning the same value when given the
       same inputs ([114]PR104434), and as having no side effects
       ([115]PR104576).
     * The analyzer is now able to split its analysis into multiple
       execution paths in places where there isn't a split in the control
       flow graph. For example, it now handles realloc calls by splitting
       the execution path into three possible outcomes for the call:
          + failure, returning NULL
          + success, growing the buffer in-place without moving it
          + success, allocating a new buffer, copying the content of the
            old buffer to it, and freeing the old buffer
     * The analyzer's interprocedural path exploration logic is now able
       to track calls through function pointers.
     * The analyzer now makes the assumption that if we know PTR is
       non-NULL, then (PTR + OFFSET) is also non-NULL. This isn't strictly
       true, but eliminates false positives in practice ([116]PR101962).
     * The analyzer has gained some initial support for inline assembler
       code. This is extremely limited, and is purely to help suppress
       false positives when analyzing the Linux kernel, which makes heavy
       use of inline assembler ([117]PR101570).
     * The way the analyzer tracks the state of memory along an execution
       path has been improved in various ways for GCC 12:
          + An optimization for representing bulk updates to memory (e.g.
            zero fills) has been removed as it never worked well. In GCC
            12 it has been replaced with a simpler and more accurate
            approach, eliminating many false positives ([118]PR95006).
          + Various optimizations have been added, speeding up the
            analysis on a particularly problematic source file from 4
            minutes down to 17 seconds ([119]PR104943, [120]PR104954, and
            [121]PR104955).
          + The analyzer now tracks the sizes of dynamically-allocated
            regions, both on the heap (via malloc etc) and stack (via
            alloca), though none of the analyzer warnings make use of this
            yet in GCC 12.
     * The analyzer's handling of switch statements has been rewritten,
       fixing various bugs.

Other significant improvements

  Eliminating uninitialized variables

     * GCC can now [122]initialize all stack variables implicitly,
       including padding. This is intended to eliminate all classes of
       uninitialized stack variable flaws. Lack of explicit initialization
       will still warn when [123]-Wuninitialized is active. For best
       debugging, use of the new command-line option
       [124]-ftrivial-auto-var-init=pattern can be used to fill variables
       with a repeated 0xFE pattern, which tends to illuminate many bugs
       (e.g. pointers receive invalid addresses, sizes and indices are
       very large). For best production results, the new command-line
       option [125]-ftrivial-auto-var-init=zero can be used to fill
       variables with 0x00, which tends to provide a safer state for bugs
       (e.g. pointers are NULL, strings are NUL filled, and sizes and
       indices are 0).

  Debugging formats

     * GCC can now generate debugging information in [126]CTF, a
       lightweight debugging format that provides information about C
       types and the association between functions and data symbols and
       types. This format is designed to be embedded in ELF files and to
       be very compact and simple. A new command-line option -gctf enables
       the generation of CTF.
     * GCC can now generate debugging information in BTF. This is a
       debugging format mainly used in BPF programs and the Linux kernel.
       The compiler can generate BTF for any target, when enabled with the
       command-line option -gbtf

GCC 12.1

   This is the [127]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 12.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [128]GCC manuals. If that fails, the
    [129]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [130]gcc@gcc.gnu.org. All of [131]our lists have public
    archives.

   Copyright (C) [132]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [133]maintained by the GCC team. Last modified
   2022-05-06[134].

References

   1. http://gcc.gnu.org/gcc-12/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/PR102024
   4. https://gcc.gnu.org/PR42217
   5. http://gcc.gnu.org/gcc-12/changes.html#mips_zero_width_fields
   6. https://clang.llvm.org/docs/ShadowCallStack.html
   7. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Instrumentation-Options.html#index-fsanitize_003dshadow-call-stack
   8. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/libgomp/OpenMP-Implementation-Status.html
   9. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/C-Dialect-Options.html#index-foffload-options
  10. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/C-Dialect-Options.html#index-foffload
  11. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gnat_rm/Security-Hardening-Features.html#Security-Hardening-Features
  12. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wbidi-chars
  13. https://gcc.gnu.org/PR103026
  14. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Warray-compare
  15. https://gcc.gnu.org/PR97573
  16. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wattributes
  17. https://gcc.gnu.org/PR101940
  18. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wformat
  19. https://wg21.link/p1938
  20. https://gcc.gnu.org/PR100974
  21. https://wg21.link/p0849
  22. https://gcc.gnu.org/PR103049
  23. https://wg21.link/p2242
  24. https://gcc.gnu.org/PR102612
  25. https://wg21.link/p2334
  26. https://gcc.gnu.org/PR102616
  27. https://wg21.link/p2360
  28. https://gcc.gnu.org/PR102617
  29. https://wg21.link/p2128
  30. https://wg21.link/cwg2397
  31. https://gcc.gnu.org/PR100975
  32. https://wg21.link/cwg960
  33. https://wg21.link/cwg1227
  34. https://wg21.link/cwg1315
  35. https://wg21.link/cwg2082
  36. https://wg21.link/cwg2351
  37. https://wg21.link/cwg2374
  38. https://wg21.link/cwg2397
  39. https://wg21.link/cwg2446
  40. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=87c2080b
  41. https://gcc.gnu.org/PR79501
  42. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wuninitialized
  43. https://gcc.gnu.org/PR19808
  44. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wint-in-bool-context
  45. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=3a2b12bc
  46. https://gcc.gnu.org/PR99032
  47. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wmissing-requires
  48. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=e18e56c7
  49. https://gcc.gnu.org/PR100995
  50. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Waddress
  51. https://gcc.gnu.org/PR102103
  52. https://gcc.gnu.org/PR99701
  53. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=3ead06c1
  54. https://gcc.gnu.org/PR102753
  55. https://wg21.link/p0466
  56. https://gcc.gnu.org/PR101539
  57. https://gcc.gnu.org/PR100828
  58. https://gcc.gnu.org/PR101786
  59. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Winterference-size
  60. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=76b75018
  61. https://gcc.gnu.org/PR101344
  62. https://gcc.gnu.org/PR101883
  63. https://gcc.gnu.org/PR89062
  64. https://gcc.gnu.org/PR101233
  65. https://gcc.gnu.org/PR88252
  66. https://gcc.gnu.org/PR86439
  67. https://gcc.gnu.org/PR98832
  68. https://gcc.gnu.org/PR102933
  69. https://gcc.gnu.org/PR51577
  70. https://gcc.gnu.org/PR98486
  71. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=1595fe44
  72. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-16
  73. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_lvalue_set_tls_model
  74. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-17
  75. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_lvalue_set_link_section
  76. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Variable-Attributes.html#index-section-variable-attribute
  77. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-18
  78. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-19
  79. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-20
  80. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_context_new_bitcast
  81. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-21
  82. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_lvalue_set_register_name
  83. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-22
  84. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/contexts.html#c.gcc_jit_context_set_bool_print_errors_to_stderr
  85. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-23
  86. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/compatibility.html#libgccjit-abi-24
  87. https://gcc.gnu.org/PR96066
  88. https://gcc.gnu.org/PR96067
  89. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/jit/topics/expressions.html#c.gcc_jit_context_new_cast
  90. https://gcc.gnu.org/PR95498
  91. https://community.arm.com/arm-community-blogs/b/architectures-and-processors-blog/posts/arm-a-profile-architecture-developments-2020
  92. https://gcc.gnu.org/bugzilla/
  93. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Named-Address-Spaces.html#PRU-Named-Address-Spaces
  94. https://groups.google.com/a/groups.riscv.org/g/sw-dev/c/aE1ZeHHCYf4
  95. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-use-of-uninitialized-value
  96. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wuninitialized
  97. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wmaybe-uninitialized
  98. https://gcc.gnu.org/PR95006
  99. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 100. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-const
 101. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-string-literal
 102. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html
 103. https://gcc.gnu.org/PR104793
 104. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer-checker
 105. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-fanalyzer
 106. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-allocation-size
 107. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-divisor
 108. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-offset
 109. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-size
 110. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html
 111. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-tainted-array-index
 112. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html#index-tainted_005fargs-function-attribute
 113. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Common-Function-Attributes.html#index-const-function-attribute
 114. https://gcc.gnu.org/PR104434
 115. https://gcc.gnu.org/PR104576
 116. https://gcc.gnu.org/PR101962
 117. https://gcc.gnu.org/PR101570
 118. https://gcc.gnu.org/PR95006
 119. https://gcc.gnu.org/PR104943
 120. https://gcc.gnu.org/PR104954
 121. https://gcc.gnu.org/PR104955
 122. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 123. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Warning-Options.html#index-Wuninitialized
 124. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 125. https://gcc.gnu.org/onlinedocs/gcc-12.1.0/gcc/Optimize-Options.html#index-ftrivial-auto-var-init
 126. https://ctfstd.org/
 127. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=12.0
 128. https://gcc.gnu.org/onlinedocs/
 129. mailto:gcc-help@gcc.gnu.org
 130. mailto:gcc@gcc.gnu.org
 131. https://gcc.gnu.org/lists.html
 132. https://www.fsf.org/
 133. https://gcc.gnu.org/about.html
 134. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-11/index.html
                             GCC 11 Release Series

   April 21, 2022

   The GCC developers are pleased to announce the release of GCC 11.3.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 11.2 relative to previous releases of GCC.

Release History

   GCC 11.3
          April 21, 2022 ([1]changes, [2]documentation)

   GCC 11.2
          July 28, 2021 ([3]changes, [4]documentation)

   GCC 11.1
          April 27, 2021 ([5]changes, [6]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [7]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [8]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [9]GCC project
   web site or contact the [10]GCC development mailing list.

   To obtain GCC please use [11]our mirror sites or [12]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [13]GCC manuals. If that fails, the
    [14]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [15]gcc@gcc.gnu.org. All of [16]our lists have public
    archives.

   Copyright (C) [17]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [18]maintained by the GCC team. Last modified
   2022-04-21[19].

References

   1. http://gcc.gnu.org/gcc-11/changes.html
   2. http://gcc.gnu.org/onlinedocs/11.3.0/
   3. http://gcc.gnu.org/gcc-11/changes.html
   4. http://gcc.gnu.org/onlinedocs/11.2.0/
   5. http://gcc.gnu.org/gcc-11/changes.html
   6. http://gcc.gnu.org/onlinedocs/11.1.0/
   7. http://gcc.gnu.org/gcc-11/buildstat.html
   8. http://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Contributors.html
   9. http://gcc.gnu.org/index.html
  10. mailto:gcc@gcc.gnu.org
  11. http://gcc.gnu.org/mirrors.html
  12. http://gcc.gnu.org/git.html
  13. https://gcc.gnu.org/onlinedocs/
  14. mailto:gcc-help@gcc.gnu.org
  15. mailto:gcc@gcc.gnu.org
  16. https://gcc.gnu.org/lists.html
  17. https://www.fsf.org/
  18. https://gcc.gnu.org/about.html
  19. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-11/changes.html
                             GCC 11 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 11. You may also want to check out our [1]Porting
   to GCC 11 page and the [2]full GCC documentation.

Caveats

     * The default mode for C++ is now -std=gnu++17 instead of
       -std=gnu++14. Note that [3]C++17 changes to template template
       parameter matching can be disabled independently of other features
       with -fno-new-ttp-matching.
     * When building GCC itself, the host compiler must now support C++11,
       rather than C++98. In particular bootstrapping GCC 11 using an
       older version of GCC requires a binary of GCC 4.8 or later, rather
       than of GCC 3.4 or later as was the case for bootstrapping GCC 10.
     * Naming and location of auxiliary and dump output files changed. If
       you compile multiple input files in a single command, if you enable
       Link Time Optimization, or if you use -dumpbase, -dumpdir,
       -save-temps=*, and you expect any file other than the primary
       output file(s) to be created as a side effect, watch out for
       improvements and a few surprises. See [4]the patch, particularly
       its textual description, for more details about the changes.
     * -gsplit-dwarf no longer enables debug info generation on its own
       but requires a separate -g for this.
     * The libstdc++ configure option --enable-cheaders=c_std is
       deprecated and will be removed in a future release. It should be
       possible to use --enable-cheaders=c_global (the default) with no
       change in behaviour.
     * The front end for compiling BRIG format of Heterogeneous System
       Architecture Intermediate Language (HSAIL) has been deprecated and
       will likely be removed in a future release.
     * Some short options of the gcov tool have been renamed: -i to -j and
       -j to -H.

General Improvements

     * [5]ThreadSanitizer improvements to support alternative runtimes and
       environments. The [6]Linux Kernel Concurrency Sanitizer (KCSAN) is
       now supported.
          + Add --param tsan-distinguish-volatile to optionally emit
            instrumentation distinguishing volatile accesses.
          + Add --param tsan-instrument-func-entry-exit to optionally
            control if function entries and exits should be instrumented.
     * In previous releases of GCC, the "column numbers" emitted in
       diagnostics were actually a count of bytes from the start of the
       source line. This could be problematic, both because of:
          + multibyte characters (requiring more than one byte to encode),
            and
          + multicolumn characters (requiring more than one column to
            display in a monospace font)
       For example, the character π ("GREEK SMALL LETTER PI (U+03C0)")
       occupies one column, and its UTF-8 encoding requires two bytes; the
       character 🙂 ("SLIGHTLY SMILING FACE (U+1F642)") occupies two
       columns, and its UTF-8 encoding requires four bytes.
       In GCC 11 the column numbers default to being column numbers,
       respecting multi-column characters. The old behavior can be
       restored using a new option [7]-fdiagnostics-column-unit=byte.
       There is also a new option [8]-fdiagnostics-column-origin=,
       allowing the pre-existing default of the left-hand column being
       column 1 to be overridden if desired (e.g. for 0-based columns).
       The output of [9]-fdiagnostics-format=json has been extended to
       supply both byte counts and column numbers for all source
       locations.
       Additionally, in previous releases of GCC, tab characters in the
       source would be emitted verbatim when quoting source code, but be
       prefixed with whitespace or line number information, leading to
       misalignments in the resulting output when compared with the actual
       source. Tab characters are now printed as an appropriate number of
       spaces, using the [10]-ftabstop option (which defaults to 8 spaces
       per tab stop).
     * Introduce [11]Hardware-assisted AddressSanitizer support. This
       sanitizer currently only works for the AArch64 target. It helps
       debug address problems similarly to [12]AddressSanitizer but is
       based on partial hardware assistance and provides probabilistic
       protection to use less RAM at run time. [13]Hardware-assisted
       AddressSanitizer is not production-ready for user space, and is
       provided mainly for use compiling the Linux Kernel.
       To use this sanitizer the command line arguments are:
          + -fsanitize=hwaddress to instrument userspace code.
          + -fsanitize=kernel-hwaddress to instrument kernel code.
     * For targets that produce DWARF debugging information GCC now
       defaults to [14]DWARF version 5 (with the exception of VxWorks and
       Darwin/Mac OS X which default to version 2 and AIX which defaults
       to version 4). This can produce up to 25% more compact debug
       information compared to earlier versions.
       To take full advantage of DWARF version 5 GCC needs to be built
       against binutils version 2.35.2 or higher. When GCC is built
       against earlier versions of binutils GCC will still emit DWARF
       version 5 for most debuginfo data, but will generate version 4
       debug line tables (even when explicitly given -gdwarf-5).
       The following debug information consumers can process DWARF version
       5:
          + GDB 8.0, or higher
          + valgrind 3.17.0
          + elfutils 0.172, or higher (for use with systemtap,
            dwarves/pahole, perf and libabigail)
          + dwz 0.14
       Programs embedding libbacktrace are urged to upgrade to the version
       shipping with GCC 11.
       To make GCC 11 generate an older DWARF version use -g together with
       -gdwarf-2, -gdwarf-3 or -gdwarf-4.
     * Vectorizer improvements:
          + The straight-line code vectorizer now considers the whole
            function when vectorizing and can handle opportunities
            crossing CFG merges and backedges.
     * A series of conditional expressions that compare the same variable
       can be transformed into a switch statement if each of them contains
       a comparison expression. Example:
        int IsHTMLWhitespace(int aChar) {
          return aChar == 0x0009 || aChar == 0x000A ||
                 aChar == 0x000C || aChar == 0x000D ||
                 aChar == 0x0020;
        }

       This statement can be transformed into a switch statement and then
       expanded into a bit-test.
     * New command-line options:
          + [15]-fbit-tests, enabled by default, can be used to enable or
            disable switch expansion using bit-tests.
     * Inter-procedural optimization improvements:
          + A new IPA-modref pass was added to track side effects of
            function calls and improve precision of points-to-analysis.
            The pass can be controlled by the [16]-fipa-modref option.
          + The identical code folding pass (controlled by [17]-fipa-icf)
            was significantly improved to increase the number of unified
            functions and to reduce compile-time memory use.
          + IPA-CP (Interprocedural constant propagation) heuristics
            improved its estimation of potential usefulness of known loop
            bounds and strides by taking the estimated frequency of these
            loops into account.
     * Link-time optimization improvements:
          + The LTO bytecode format was optimized for smaller object files
            and faster streaming.
          + Memory allocation of the linking stage was improved to reduce
            peak memory use.
     * Profile driven optimization improvements:
          + Using [18]-fprofile-values, was improved by tracking more
            target values for e.g. indirect calls.
          + GCOV data file format outputs smaller files by representing
            zero counters in a more compact way.

New Languages and Language specific improvements

     * GCC 11 adds support for non-rectangular loop nests in OpenMP
       constructs and the allocator routines of [19]OpenMP 5.0, including
       initial allocate clause support in C/C++. The OMP_TARGET_OFFLOAD
       environment variable and the active-levels routines are now
       supported. For C/C++, the declare variant and map support has been
       extended. For Fortran, OpenMP 4.5 is now fully supported and OpenMP
       5.0 support has been extended, including the following features
       which were before only available in C and C++: order(concurrent),
       device_type, memorder-clauses for flush, lastprivate with
       conditional modifier, atomic construct and reduction clause
       extensions of OpenMP 5.0, if clause with simd and cancel modifiers,
       target data without map clause, and limited support for the
       requires construct.
     * Version 2.6 of the [20]OpenACC specification continues to be
       maintained and improved in the C, C++ and Fortran compilers. See
       the [21]implementation status section on the OpenACC wiki page and
       the [22]run-time library documentation for further information.

  C family

     * New attributes:
          + The [23]no_stack_protector attribute has been added to mark
            functions which should not be instrumented with stack
            protection (-fstack-protector).
          + The existing [24]malloc attribute has been extended so that it
            can be used to identify allocator/deallocator API pairs. A
            pair of new [25]-Wmismatched-dealloc and
            [26]-Wmismatched-new-delete warnings will complain about
            mismatched calls, and [27]-Wfree-nonheap-object about
            deallocation calls with pointers not obtained from allocation
            functions. Additionally, the static analyzer will use these
            attributes when checking for leaks, double-frees,
            use-after-frees, and similar issues.
     * New warnings:
          + [28]-Wmismatched-dealloc, enabled by default, warns about
            calls to deallocation functions with pointers returned from
            mismatched allocation functions.
          + [29]-Wsizeof-array-div, enabled by -Wall, warns about
            divisions of two sizeof operators when the first one is
            applied to an array and the divisor does not equal the size of
            the array element.
          + [30]-Wstringop-overread, enabled by default, warns about calls
            to string functions reading past the end of the arrays passed
            to them as arguments. In prior GCC releases most instances of
            his warning are diagnosed by -Wstringop-overflow.
          + [31]-Wtsan, enabled by default, warns about unsupported
            features in ThreadSanitizer (currently
            std::atomic_thread_fence).
     * Enhancements to existing warnings:
          + [32]-Wfree-nonheap-object detects many more instances of calls
            to deallocation functions with pointers not returned from a
            dynamic memory allocation function.
          + [33]-Wmaybe-uninitialized diagnoses passing pointers or
            references to uninitialized memory to functions taking
            const-qualified arguments.
          + [34]-Wuninitialized detects reads from uninitialized
            dynamically allocated memory.
     * For ELF targets that support the GNU or FreeBSD OSABIs, the used
       attribute will now save the symbol declaration it is applied to
       from linker garbage collection.
       To support this behavior, used symbols that have not been placed in
       specific sections (e.g. with the section attribute, or the
       -f{function,data}-sections options) will be placed in new, unique
       sections.
       This functionality requires Binutils version 2.36 or later.

  C

     * Several new features from the upcoming C2X revision of the ISO C
       standard are supported with -std=c2x and -std=gnu2x. Some of these
       features are also supported as extensions when compiling for older
       language versions. In addition to the features listed, some
       features previously supported as extensions and now added to the C
       standard are enabled by default in C2X mode and not diagnosed with
       -std=c2x -Wpedantic.
          + The BOOL_MAX and BOOL_WIDTH macros are provided in <limits.h>.
          + As in C++, function definitions no longer need to give names
            for unused function parameters.
          + The expansions of the true and false macros in <stdbool.h>
            have changed so that they have type bool.
          + The [[nodiscard]] standard attribute is now supported.
          + The __has_c_attribute preprocessor operator is now supported.
          + Macros INFINITY, NAN, FLT_SNAN, DBL_SNAN, LDBL_SNAN,
            DEC_INFINITY, DEC_NAN, and corresponding signaling NaN macros
            for _FloatN, _FloatNx and _DecimalN types, are provided in
            <float.h>. There are also corresponding built-in functions
            __builtin_nansdN for decimal signaling NaNs.
          + Macros FLT_IS_IEC_60559, DBL_IS_IEC_60559 and
            LDBL_IS_IEC_60559 are provided in <float.h>.
          + The feature test macro __STDC_WANT_IEC_60559_EXT__ is
            supported by <float.h>.
          + Labels may appear before declarations and at the end of a
            compound statement.
     * New warnings:
          + [35]-Warray-parameter, enabled by -Wall, warns about
            redeclarations of functions with ordinary array arguments
            declared using inconsistent forms. The warning also enables
            the detection of the likely out of bounds accesses in calls to
            such functions with smaller arrays.
          + [36]-Wvla-parameter, enabled by -Wall, warns redeclarations of
            functions with variable length array arguments declared using
            inconsistent forms or with mismatched bounds. The warning also
            enables the detection of the likely out of bounds accesses in
            calls to such functions with smaller arrays.

  C++

     * The default mode has been changed to -std=gnu++17.
     * Several C++20 features have been implemented:
          + the compiler now supports consteval virtual functions
          + P2082R1, Fixing CTAD for aggregates
          + P0593R6, Pseudo-destructors end object lifetimes
          + P1907R1, Inconsistencies with non-type template parameters
            (complete implementation)
          + P1975R0, Fixing the wording of parenthesized
            aggregate-initialization
          + P1009R2, Array size deduction in new-expressions
          + P1099R5, using enum
          + Modules, Requires -fmodules-ts and some aspects are
            incomplete. Refer to [37]C++ 20 Status
     * The C++ front end has experimental support for some of the upcoming
       C++23 draft features with the -std=c++23, -std=gnu++23, -std=c++2b
       or -std=gnu++2b flags, including
          + P0330R8, Literal Suffix for (signed) size_t.
       For a full list of new features, see [38]the C++ status page.
     * Several C++ Defect Reports have been resolved, e.g.:
          + DR 625, Use of auto as a template-argument
          + DR 1512, Pointer comparison vs qualification conversions
          + DR 1722, Should lambda to function pointer conversion function
            be noexcept?
          + DR 1914, Duplicate standard attributes
          + DR 2032, Default template-arguments of variable templates
          + DR 2289, Uniqueness of decomposition declaration names
          + DR 2237, Can a template-id name a constructor?
          + DR 2303, Partial ordering and recursive variadic inheritance
          + DR 2369, Ordering between constraints and substitution
          + DR 2450, braced-init-list as a template-argument
     * G++ now performs better access checking in templates ([39]PR41437).
     * reinterpret_casts in constexpr evaluation are now checked more
       completely ([40]PR95307).
     * The diagnostic for static_assert has been improved: the compiler
       now shows the expression including its template arguments (if there
       were any), and can point to the failing clause if the condition
       comprised of any logical AND operators ([41]PR97518).
     * New warnings:
          + [42]-Wctad-maybe-unsupported, disabled by default, warns about
            performing class template argument deduction on a type with no
            deduction guides.
          + [43]-Wrange-loop-construct, enabled by -Wall, warns when a
            range-based for-loop is creating unnecessary and expensive
            copies.
          + [44]-Wdeprecated-enum-enum-conversion, enabled by default in
            C++20, warns about deprecated arithmetic conversions on
            operands of enumeration types, as outlined in
            [depr.arith.conv.enum].
          + [45]-Wdeprecated-enum-float-conversion, enabled by default in
            C++20, warns about deprecated arithmetic conversions on
            operands where one is of enumeration type and the other is of
            a floating-point type, as outlined in [depr.arith.conv.enum].
          + [46]-Wmismatched-new-delete, enabled by -Wall, warns about
            calls to C++ operator delete with pointers returned from
            mismatched forms of operator new or from other mismatched
            allocation functions.
          + [47]-Wvexing-parse, enabled by default, warns about the most
            vexing parse rule: the cases when a declaration looks like a
            variable definition, but the C++ language requires it to be
            interpreted as a function declaration.
     * Enhancements to existing warnings:
          + [48]-Wnonnull considers the implicit this argument of every
            C++ nonstatic member function to have been implicitly declared
            with attribute nonnull and triggers warnings for calls where
            the pointer is null.

    Runtime Library (libstdc++)

     * Improved C++17 support, including:
          + std::from_chars and std::to_chars for floating-point types.
     * Improved experimental C++20 support, including:
          + Calendar additions to <chrono>. Thanks to Cassio Neri for
            optimizations.
          + std::bit_cast
          + std::source_location
          + Atomic wait and notify operations.
          + <barrier>, <latch>, and <semaphore>
          + <syncstream>
          + Efficient access to basic_stringbuf's buffer.
          + Heterogeneous lookup in unordered containers.
     * Experimental C++23 support, including:
          + contains member functions for strings, thanks to Paul Fee.
          + std::to_underlying, std::is_scoped_enum
     * Experimental support for Data-Parallel Types (simd) from the
       Parallelism 2 TS, thanks to Matthias Kretz.
     * Faster std::uniform_int_distribution, thanks to Daniel Lemire.

  D

     * New features:
          + A new bottom type typeof(*null) has been added to represent
            run-time errors and non-terminating functions. This also
            introduces a new standard alias for the type named noreturn,
            and is implicitly imported into every module.
          + Printf-like and scanf-like functions are now detected by
            prefixing them with pragma(printf) for printf-like functions
            or pragma(scanf) for scanf-like functions.
          + The __traits() expression now supports the extensions
            isDeprecated, isDisabled, isFuture, isModule, isPackage,
            child, isReturnOnStack, isZeroInit, getTargetInfo,
            getLocation, hasPostblit, isCopyable, getVisibility, and
            totype.
          + An expression-based contract syntax has been added to the
            language.
          + Function literals can now return a value by reference with the
            ref keyword.
          + A new syntax is available to declare aliases to function types
            using the alias syntax based on the assignment operator.
          + New types __c_complex_float, __c_complex_double,
            __c_complex_real, and __c_wchar_t have been added for
            interfacing with C and C++ code, and are available from the
            core.stdc.config module.
          + User-defined attributes can now be used to annotate enum
            members, alias declarations, and function parameters.
          + Templates alias parameters can now be instantiated with basic
            types such as int or void function().
          + The mixin construct can now be used as types in the form
            mixin(string) var.
          + The mixin construct can now take an argument list, same as
            pragma(msg).
     * New intrinsics:
          + Bitwise rotate intrinsics core.bitop.rol and core.bitop.ror
            have been added.
          + Byte swap intrinsic core.bitop.byteswap for swapping bytes in
            a 2-byte ushort has been added.
          + Math intrinsics available from core.math now have overloads
            for float and double types.
          + Volatile intrinsics core.volatile.volatileLoad and
            core.volatile.volatileStore have been moved from the
            core.bitop module.
     * New attributes:
          + The following GCC attributes are now recognized and available
            from the gcc.attributes module with short-hand aliases for
            convenience:
               o @attribute("alloc_size", arguments) or
                 @alloc_size(arguments).
               o @attribute("always_inline") or @always_inline.
               o @attribute("used") or @used.
               o @attribute("optimize", arguments) or
                 @optimize(arguments).
               o @attribute("cold") or @cold.
               o @attribute("noplt") or @noplt.
               o @attribute("target_clones", arguments) or
                 @target_clones(arguments).
               o @attribute("no_icf") or @no_icf.
               o @attribute("noipa") or @noipa.
               o @attribute("symver", arguments) or @symver(arguments).
          + New aliases have been added to gcc.attributes for
            compatibility with ldc.attributes.
               o The @allocSize(arguments) attribute is the same as
                 @alloc_size(arguments), but uses a 0-based index for
                 function arguments.
               o The @assumeUsed attribute is an alias for
                 @attribute("used").
               o The @fastmath attribute is an alias for
                 @optimize("Ofast").
               o The @naked attribute is an alias for @attribute("naked").
                 This attribute may not be available on all targets.
               o The @restrict attribute has been added to specify that a
                 function parameter is to be restrict-qualified in the C99
                 sense of the term.
               o The @optStrategy(strategy) attribute is an alias for
                 @optimize("O0") when the strategy is "none", otherwise
                 @optimize("Os") for the "optsize" and "minsize"
                 strategies.
               o The @polly attribute is an alias for
                 @optimize("loop-parallelize-all").
               o The @section(name) attribute is an alias for
                 @attribute("section", name).
               o The @target(arguments) attribute is an alias for
                 attribute("target", arguments).
               o The @weak attribute is an alias for @attribute("weak").
     * New language options:
          + -fweak-templates, added to control whether declarations that
            can be defined in multiple objects should be emitted as weak
            symbols. The default is to emit all symbols with extern
            linkage as weak, unless the target lacks support for weak
            symbols.
          + -Wdeprecated, this option is now enabled by default.
          + -Wextra, this option now turns on all warnings that are not
            part of the core D language front-end - -Waddress,
            -Wcast-result, -Wunknown-pragmas.
          + -Wvarargs, added to turn on warnings about questionable usage
            of the va_start intrinsic.
     * Deprecated and removed features:
          + Compiler-recognized attributes are now made available from the
            gcc.attributes module, the former module gcc.attribute has
            been deprecated and will be removed in a future release.
          + The @attribute("alias") attribute has been removed, as it had
            been superseded by pragma(mangle).
          + The @attribute("forceinline") attribute has been removed and
            renamed to @always_inline.
          + __vector types that are not supported in hardware are now
            rejected at compile-time. Previously all vector types were
            accepted by the compiler and emulated when target support was
            absent.
          + The extern(Pascal) linkage attribute has been removed.
          + The deprecation phase for -ftransition=import and
            -ftransition=checkimports is finished. These switches no
            longer have an effect and are now removed. Symbols that are
            not visible in a particular scope will no longer be found by
            the compiler.
          + It is now an error to use private variables selectively
            imported from other modules. Due to a bug, some imported
            private members were visible from other modules, violating the
            specification.
          + The -fweak compiler switch has been removed, as it existed
            only for testing.

  Fortran

     * Added DEPRECATED to !GCC$'s attributes directive.

  Go

     * GCC 11 provides a complete implementation of the Go 1.16.3 user
       packages.

libgccjit

     * libgccjit was marked as merely "Alpha" quality when [49]originally
       added in GCC 5. Given that we have maintained [50]API and ABI
       compatibility since then and it is in use by various projects, we
       have removed that caveat.
     * libgccjit can now be built for MinGW
     * The libgccjit API gained 10 new entry points:
          + [51]gcc_jit_global_set_initializer
          + 9 entrypoints for [52]directly embedding asm statements into a
            compile, analogous to inline asm in the C front end

New Targets and Target Specific Improvements

  AArch64 & arm

     * A number of new CPUs are supported through arguments to the -mcpu
       and -mtune options in both the arm and aarch64 backends (GCC
       identifiers in parentheses):
          + Arm Cortex-A78 (cortex-a78).
          + Arm Cortex-A78AE (cortex-a78ae).
          + Arm Cortex-A78C (cortex-a78c).
          + Arm Cortex-X1 (cortex-x1).
          + Arm Neoverse V1 (neoverse-v1).
          + Arm Neoverse N2 (neoverse-n2).
     * GCC can now auto-vectorize operations performing addition,
       subtraction, multiplication and the accumulate/subtract variants on
       complex numbers, taking advantage of the Advanced SIMD instructions
       in the Armv8.3-a (AArch64/AArch32), SVE (AArch64), SVE2 (AArch64)
       and MVE (AArch32 M-profile) instruction sets.

  AArch64

     * In addition to the above, the following AArch64-only CPUs are now
       supported:
          + Fujitsu A64FX (a64fx).
          + Arm Cortex-R82 (cortex-r82).
     * The AArch64 Armv8-R architecture is now supported through the
       -march=armv8-r option.
     * Mitigation against the [53]Straight-line Speculation vulnerability
       is supported with the -mharden-sls= option. Please refer to the
       documentation for usage instructions.
     * The availability of Advanced SIMD intrinsics available through the
       arm_neon.h header is improved and GCC 11 supports the full set of
       intrinsics defined by ACLE Q3 2020.

  AMD Radeon (GCN)

     * Initial support for gfx908 GPUs has been added.

  arm

     * Initial auto-vectorization is now available when targeting the MVE
       instruction set.
     * GCC can now make use of the Low Overhead Branch instruction in
       Armv8.1-M to optimize loop counters and checks.
     * The -mcpu=cortex-m55 option now supports the extensions +nomve and
       +nomve.fp to control generation of MVE and MVE floating-point
       instructions.

  IA-32/x86-64

     * New ISA extension support for Intel TSXLDTRK was added to GCC.
       TSXLDTRK intrinsics are available via the -mtsxldtrk compiler
       switch.
     * New ISA extension support for Intel SERIALIZE was added to GCC.
       SERIALIZE intrinsics are available via the -mserialize compiler
       switch.
     * New ISA extension support for Intel HRESET was added to GCC. HRESET
       intrinsics are available via the -mhreset compiler switch.
     * New ISA extension support for Intel UINTR was added to GCC. UINTR
       intrinsics are available via the -muintr compiler switch.
     * New ISA extension support for Intel KEYLOCKER was added to GCC.
       KEYLOCKER intrinsics are available via the -mkeylocker compiler
       switch.
     * New ISA extension support for Intel AMX-TILE, AMX-INT8, AMX-BF16
       was added to GCC. AMX-TILE, AMX-INT8, AMX-BF16 intrinsics are
       available via the -mamx-tile, -mamx-int8, -mamx-bf16 compiler
       switches.
     * New ISA extension support for Intel AVX-VNNI was added to GCC.
       AVX-VNNI intrinsics are available via the -mavxvnni compiler
       switch.
     * GCC now supports the Intel CPU named Sapphire Rapids through
       -march=sapphirerapids. The switch enables the MOVDIRI, MOVDIR64B,
       AVX512VP2INTERSECT, ENQCMD, CLDEMOTE, SERIALIZE, PTWRITE, WAITPKG,
       TSXLDTRK, AMT-TILE, AMX-INT8, AMX-BF16, and AVX-VNNI ISA
       extensions.
     * GCC now supports the Intel CPU named Alderlake through
       -march=alderlake. The switch enables the CLDEMOTE, PTWRITE,
       WAITPKG, SERIALIZE, KEYLOCKER, AVX-VNNI, and HRESET ISA extensions.
     * GCC now supports the Intel CPU named Rocketlake through
       -march=rocketlake. Rocket Lake is based on Icelake client and minus
       SGX.
     * GCC now supports AMD CPUs based on the znver3 core via
       -march=znver3.
     * GCC now supports micro-architecture levels defined in the x86-64
       psABI via -march=x86-64-v2, -march=x86-64-v3 and -march=x86-64-v4.

  Nios II

     * The options -mcustom-insn=N no longer produce compiler warnings if
       the custom instruction is not generated due to missing optimization
       options such as -fno-math-errno, -ffinite-math-only, or
       -funsafe-math-optimizations. These warnings were not consistently
       emitted for all custom instructions.
     * The -mcustom-fpu-cfg=fph2 option has been added to enable the
       custom instructions supported by the Nios II Floating Point
       Hardware 2 Component.

  NVPTX

     * The -misa default has changed from sm_30 to sm_35.
     * The -m32 compiler switch has been removed.
     * The -msoft-stack-reserve-local format has been fixed. Previously,
       it accepted -msoft-stack-reserve-local<n>. It now accepts
       -msoft-stack-reserve-local=<n>.

  S/390, System z, IBM Z Systems

     * The behavior when compiling with -fexcess-precision=standard (e.g.,
       implied by -std=c99) on s390(x) targets can now be controlled at
       configure time with the flag --enable-s390-excess-float-precision.
       When enabled, GCC will maintain previous behavior and evaluate
       float expressions in double precision, which aligns with the
       definition of float_t as double. With the flag disabled, GCC will
       always evaluate float expressions in single precision. In native
       builds and cross compiles that have target libc headers, GCC will
       by default match the definition of float_t in the installed glibc.

  RISC-V

     * Support address sanitizer for RISC-V.
     * Support big-endian for RISC-V, thanks to Marcus Comstedt.
     * Implement new style of architecture extension test macros: each
       architecture extension has a corresponding feature test macro,
       which can be used to test its existence and version information.
     * Legacy architecture extension test macros like __riscv_atomic are
       deprecated, but will still be supported for at least 2 release
       cycles.
     * Support IFUNC for riscv*-*-linux*.
     * Add new option -misa-spec=* to control ISA spec version. This
       controls the default version of each extensions. It defaults to
       2.2.
     * Introduce the --with-multilib-generator configure time option. This
       allows for flexible config multi-lib settings. Its syntax is the
       same as RISC-V's multilib-generator.
     * Extend the sytax for multilib-generator, support expansion operator
       * to reduce the complexity of complicated multi-lib re-use rules.
     * Support -mcpu=* option aligned with RISC-V clang/LLVM. It sets the
       pipeline model and architecture extensions, like -mtune=* plus
       -march=*.
     * Support for TLS stack protector canary access, thanks to Cooper Qu.
     * Support __builtin_thread_pointer for RISC-V.
     * Introduce shorten_memrefs optimization, which reduces the code size
       for memory access, thanks to Craig Blackmore.

Operating Systems

  AIX

     * GCC for AIX can be built as a 64 bit application and the runtime is
       built as FAT libraries containing both 32 bit and 64 bit objects.
     * Support AIX Vector Extended ABI with -mabi=vec-extabi.
     * Thread-Local uninitiated data placed in local common section.
     * Use thread-safe access in ctype.
     * Link with libc128.a when long-double-128 enabled.

Improvements to Static Analyzer

     * The implementation of how program state is tracked within
       [54]-fanalyzer has been completely rewritten for GCC 11, fixing
       numerous bugs, and allowing for the analyzer to scale to larger C
       source files.
     * The analysis of allocations and deallocations has been generalized
       beyond malloc and free.
          + As preliminary work towards eventually supporting C++, the
            malloc/free checking will also check new/delete and
            new[]/delete[]. However, C++ is not yet properly supported by
            [55]-fanalyzer (for example, exception-handling is
            unimplemented).
          + As noted above, the existing [56]malloc attribute has been
            extended so that it can be used to identify
            allocator/deallocator API pairs. The analyzer will use these
            attributes when checking for leaks, double-frees,
            use-after-frees, and similar issues.
          + A new [57]-Wanalyzer-mismatching-deallocation warning has been
            added, covering such mismatches as using scalar delete rather
            vector delete[].
     * The analyzer has gained warnings
       [58]-Wanalyzer-shift-count-negative,
       [59]-Wanalyzer-shift-count-overflow, [60]-Wanalyzer-write-to-const,
       and [61]-Wanalyzer-write-to-string-literal, all enabled by default
       when [62]-fanalyzer is enabled.
     * The analyzer can now be extended by GCC plugins, allowing for
       domain-specific path-sensitive warnings. An example of using a
       [63]GCC plugin to check for misuses of CPython's global interpreter
       lock can be seen in the test suite
     * The analyzer has gained new debugging options
       [64]-fdump-analyzer-json and [65]-fno-analyzer-feasibility.

Other significant improvements

     * GCC has gained a new environment variable
       [66]GCC_EXTRA_DIAGNOSTIC_OUTPUT which can be used by IDEs to
       request machine-readable fix-it hints without needing to adjust
       build flags.

GCC 11.1

   This is the [67]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 11.2

   This is the [68]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 11.3

   This is the [69]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 11.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    x86-64

     * The x86-64 ABI of passing and returning structure with a 64-bit
       single precision vector changed in GCC 11.1 when 3DNOW is disabled.
       Disabling 3DNOW no longer changes how they are passed nor returned.
       This ABI change is now diagnosed with -Wpsabi.
     * Mitigation against straight line speculation (SLS) for function
       return and indirect jump is supported via
       -mharden-sls=[none|all|return|indirect-jmp].
     * Add CS prefix to call and jmp to indirect thunk with branch target
       in r8-r15 registers via -mindirect-branch-cs-prefix.


    For questions related to the use of GCC, please consult these web
    pages and the [70]GCC manuals. If that fails, the
    [71]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [72]gcc@gcc.gnu.org. All of [73]our lists have public
    archives.

   Copyright (C) [74]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [75]maintained by the GCC team. Last modified
   2022-04-21[76].

References

   1. http://gcc.gnu.org/gcc-11/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://wg21.link/p0522r0
   4. https://gcc.gnu.org/pipermail/gcc-patches/2020-May/546494.html
   5. https://github.com/google/sanitizers/wiki/ThreadSanitizerCppManual
   6. https://www.kernel.org/doc/html/latest/dev-tools/kcsan.html
   7. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-column-unit
   8. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-column-origin
   9. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  10. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Preprocessor-Options.html#index-ftabstop
  11. https://clang.llvm.org/docs/HardwareAssistedAddressSanitizerDesign.html
  12. https://github.com/google/sanitizers/wiki/AddressSanitizer
  13. https://clang.llvm.org/docs/HardwareAssistedAddressSanitizerDesign.html
  14. https://dwarfstd.org/doc/DWARF5.pdf
  15. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Code-Gen-Options.html#index-fno-bit-tests
  16. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Optimize-Options.html#index-fipa-modref
  17. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Optimize-Options.html#index-fipa-ocf
  18. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Optimize-Options.html#index-fprofile-values
  19. https://www.openmp.org/specifications/
  20. https://www.openacc.org/
  21. https://gcc.gnu.org/wiki/OpenACC/Implementation Status#status-11
  22. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/libgomp/Enabling-OpenACC.html
  23. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Common-Function-Attributes.html#index-no_005fstack_005fprotector-function-attribute
  24. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Common-Function-Attributes.html#index-malloc-function-attribute
  25. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wmismatched-dealloc
  26. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wmismatched-new-delete
  27. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wfree-nonheap-object
  28. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wmismatched-dealloc
  29. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wsizeof-array-div
  30. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wstringop-overread
  31. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wtsan
  32. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wfree-nonheap-object
  33. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wmaybe-uninitialized
  34. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wuninitialized
  35. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Warray-parameter
  36. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wvla-parameter
  37. http://gcc.gnu.org/projects/cxx-status.html#cxx20
  38. http://gcc.gnu.org/projects/cxx-status.html#cxx23
  39. https://gcc.gnu.org/PR41437
  40. https://gcc.gnu.org/PR95307
  41. https://gcc.gnu.org/PR97518
  42. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wctad-maybe-unsupported
  43. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wrange-loop-construct
  44. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdeprecated-enum-enum-conversion
  45. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdeprecated-enum-float-conversion
  46. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wmismatched-new-delete
  47. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wvexing-parse
  48. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Warning-Options.html#index-Wnonnull
  49. http://gcc.gnu.org/gcc-5/changes.html#jit
  50. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/jit/topics/compatibility.html
  51. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/jit/topics/expressions.html#c.gcc_jit_global_set_initializer
  52. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/jit/topics/asm.html
  53. https://developer.arm.com/support/arm-security-updates/speculative-processor-vulnerability/downloads/straight-line-speculation
  54. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html
  55. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html
  56. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Common-Function-Attributes.html#index-malloc-function-attribute
  57. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-mismatching-deallocation
  58. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-shift-count-negative
  59. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-shift-count-overflow
  60. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-const
  61. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-Wanalyzer-write-to-string-literal
  62. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html
  63. https://gcc.gnu.org/git/?p=gcc.git;a=commitdiff;h=66dde7bc64b75d4a338266333c9c490b12d49825
  64. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-fdump-analyzer-json
  65. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Static-Analyzer-Options.html#index-fno-analyzer-feasibility
  66. https://gcc.gnu.org/onlinedocs/gcc-11.1.0/gcc/Environment-Variables.html#index-GCC_005fEXTRA_005fDIAGNOSTIC_005fOUTPUT
  67. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.0
  68. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.2
  69. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=11.3
  70. https://gcc.gnu.org/onlinedocs/
  71. mailto:gcc-help@gcc.gnu.org
  72. mailto:gcc@gcc.gnu.org
  73. https://gcc.gnu.org/lists.html
  74. https://www.fsf.org/
  75. https://gcc.gnu.org/about.html
  76. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-10/index.html
                             GCC 10 Release Series

   April 8, 2021

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 10.3.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 10.2 relative to previous releases of GCC.

Release History

   GCC 10.3
          April 8, 2021 ([2]changes, [3]documentation)

   GCC 10.2
          July 23, 2020 ([4]changes, [5]documentation)

   GCC 10.1
          May 7, 2020 ([6]changes, [7]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [8]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [9]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [10]GCC
   project web site or contact the [11]GCC development mailing list.

   To obtain GCC please use [12]our mirror sites or [13]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [14]GCC manuals. If that fails, the
    [15]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [16]gcc@gcc.gnu.org. All of [17]our lists have public
    archives.

   Copyright (C) [18]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [19]maintained by the GCC team. Last modified
   2021-07-28[20].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-10/changes.html
   3. http://gcc.gnu.org/onlinedocs/10.3.0/
   4. http://gcc.gnu.org/gcc-10/changes.html
   5. http://gcc.gnu.org/onlinedocs/10.2.0/
   6. http://gcc.gnu.org/gcc-10/changes.html
   7. http://gcc.gnu.org/onlinedocs/10.1.0/
   8. http://gcc.gnu.org/gcc-10/buildstat.html
   9. http://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Contributors.html
  10. http://gcc.gnu.org/index.html
  11. mailto:gcc@gcc.gnu.org
  12. http://gcc.gnu.org/mirrors.html
  13. http://gcc.gnu.org/git.html
  14. https://gcc.gnu.org/onlinedocs/
  15. mailto:gcc-help@gcc.gnu.org
  16. mailto:gcc@gcc.gnu.org
  17. https://gcc.gnu.org/lists.html
  18. https://www.fsf.org/
  19. https://gcc.gnu.org/about.html
  20. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-10/changes.html
                             GCC 10 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 10. You may also want to check out our [1]Porting
   to GCC 10 page and the [2]full GCC documentation.

Caveats

     * An ABI incompatibility between C++14 and C++17 has been fixed. On
       some targets a class with a zero-sized subobject would be passed
       incorrectly when compiled as C++17 or C++20. See the [3]C++ notes
       below for more details.
     * The deprecated Profile Mode and array_allocator extensions have
       been removed from libstdc++.
     * The non-standard std::__is_nullptr_t type trait is deprecated and
       will be removed from libstdc++ in a future release. The standard
       trait std::is_null_pointer should be instead.
     * The minimum version of the [4]MPFR library required for building
       GCC has been increased to version 3.1.0 (released 2011-10-03).
     * The automatic template instantiation at link time (-frepo) has been
       removed.
     * The --param allow-store-data-races internal parameter has been
       removed in favor of a new official option -fallow-store-data-races.
       While default behavior is unchanged and the new option allows to
       correctly maintain a per compilation unit setting across link-time
       optimization, alteration of the default via --param
       allow-store-data-races will now be diagnosed and build systems have
       to be adjusted accordingly.
     * Offloading to Heterogeneous System Architecture Intermediate
       Language (HSAIL) has been deprecated and will likely be removed in
       a future release.
     * The type of the std::iterator base class of
       std::istreambuf_iterator was changed in C++98 mode to be consistent
       with C++11 and later standards. See the [5]libstdc++ notes below
       for more details.

General Improvements

     * New built-in functions:
          + The [6]__has_builtin built-in preprocessor operator can be
            used to query support for built-in functions provided by GCC
            and other compilers that support it.
          + __builtin_roundeven for the corresponding function from
            ISO/IEC TS 18661.
     * New command-line options:
          + [7]-fallocation-dce removes unneeded pairs of new and delete
            operators.
          + [8]-fprofile-partial-training can now be used to inform the
            compiler that code paths not covered by the training run
            should not be optimized for size.
          + [9]-fprofile-reproducible controls level of reproducibility of
            profile gathered by [10]-fprofile-generate. This makes it
            possible to rebuild program with same outcome which is useful,
            for example, for distribution packages.
          + [11]-fprofile-prefix-path can be used in combination with
            -fprofile-generate=profile_dir and -fprofile-use=profile_dir
            to inform GCC where the base directory of build source tree is
            in case it differs between instrumentation and optimized
            builds.
          + [12]-fanalyzer enables a new static analysis pass and
            associated warnings. This pass performs a time-consuming
            exploration of paths through the code in the hope of detecting
            various common errors, such as double-free bugs. This option
            should be regarded as experimental in this release. In
            particular, analysis of non-C code is unlikely to work.
     * Inter-procedural optimization improvements:
          + The inter-procedural scalar replacement of aggregates
            (IPA-SRA) pass was re-implemented to work at link-time and can
            now also remove computing and returning unused return values.
          + [13]-finline-functions is now enabled at -O2 and was retuned
            for better code size versus runtime performance trade-offs.
            Inliner heuristics was also significantly sped up to avoid
            negative impact to -flto -O2 compile times.
          + Inliner heuristics and function cloning can now use
            value-range information to predict effectivity of individual
            transformations.
          + During link-time optimization the C++ One Definition Rule is
            used to increase precision of type based alias analysis.
     * Link-time optimization improvements:
          + A new binary [14]lto-dump has been added. It dumps various
            information about LTO bytecode object files.
          + The parallel phase of the LTO can automatically detect a
            running make's jobserver or fall back to number of available
            cores.
          + The LTO bytecode can be compressed with the [15]zstd
            algorithm. The configure script automatically detects zstd
            support.
          + Most --param values can now be specified at translation unit
            granularity. This includes all parameters controlling the
            inliner and other inter-procedural optimizations. Unlike
            earlier releases, GCC 10 will ignore parameters controlling
            optimizations specified at link-time and apply parameters
            specified at compile-time in the same manner as done for
            optimization flags.
     * Profile driven optimization improvements:
          + Profile maintenance during compilation and hot/cold code
            partitioning have been improved.
          + Using [16]-fprofile-values, an instrumented binary can track
            multiple values (up to 4) for e.g. indirect calls and provide
            more precise profile information.

New Languages and Language-Specific Improvements

     * Version 2.6 of the [17]OpenACC specification is now supported in
       the C, C++ and Fortran compilers. See the [18]implementation status
       section on the OpenACC wiki page and the [19]run-time library
       documentation for further information.
     * GCC 10 adds a number of newly implemented [20]OpenMP 5.0 features
       on top of the GCC 9 release such as conditional lastprivate clause,
       scan and loop directives, order(concurrent) and use_device_addr
       clauses support, if clause on simd construct or partial support for
       the declare variant directive, getting closer to full support of
       the OpenMP 5.0 standard.
     * OpenMP and OpenACC now support [21]offloading to AMD Radeon (GCN)
       GPUs; supported are the third-generation Fiji (fiji) and the
       fifth-generation VEGA 10/VEGA 20 (gfx900 or gfx906).

  C family

     * New attributes:
          + The access function and type attribute has been added to
            describe how a function accesses objects passed to it by
            pointer or reference, and to associate such arguments with
            integer arguments denoting the objects' sizes. The attribute
            is used to enable the detection of invalid accesses by
            user-defined functions, such as those diagnosed by
            -Wstringop-overflow.
          + The symver attribute can be used to bind symbols to specific
            version nodes on ELF platforms. This is preferred to using
            inline assembly with GNU as symver directive because the
            latter is not compatible with link-time optimizations.
     * New warnings:
          + [22]-Wstring-compare, enabled by -Wextra, warns about equality
            and inequality expressions between zero and the result of a
            call to either strcmp and strncmp that evaluate to a constant
            as a result of the length of one argument being greater than
            the size of the array pointed to by the other.
          + [23]-Wzero-length-bounds, enabled by -Warray-bounds, warns
            about accesses to elements of zero-length arrays that might
            overlap other members of the same object.
     * Enhancements to existing warnings:
          + [24]-Warray-bounds detects more out-of-bounds accesses to
            member arrays as well as accesses to elements of zero-length
            arrays.
          + [25]-Wformat-overflow makes full use of string length
            information computed by the strlen optimization pass.
          + [26]-Wrestrict detects overlapping accesses to dynamically
            allocated objects.
          + [27]-Wreturn-local-addr diagnoses more instances of return
            statements returning addresses of automatic variables.
          + [28]-Wstringop-overflow detects more out-of-bounds stores to
            member arrays including zero-length arrays, dynamically
            allocated objects and variable length arrays, as well as more
            instances of reads of unterminated character arrays by string
            built-in functions. The warning also detects out-of-bounds
            accesses by calls to user-defined functions declared with the
            new attribute access.
          + [29]-Warith-conversion re-enables warnings from -Wconversion,
            -Wfloat-conversion, and -Wsign-conversion that are now off by
            default for an expression where the result of an arithmetic
            operation will not fit in the target type due to promotion,
            but the operands of the expression do fit in the target type.
     * Extended characters in identifiers may now be specified directly in
       the input encoding (UTF-8, by default), in addition to the UCN
       syntax (\uNNNN or \UNNNNNNNN) that is already supported:

static const int π = 3;
int get_naïve_pi() {
  return π;
}

  C

     * Several new features from the upcoming C2X revision of the ISO C
       standard are supported with -std=c2x and -std=gnu2x. Some of these
       features are also supported as extensions when compiling for older
       language versions. In addition to the features listed, some
       features previously supported as extensions and now added to the C
       standard are enabled by default in C2X mode and not diagnosed with
       -std=c2x -Wpedantic.
          + The [[]] attribute syntax is supported, as in C++. Existing
            attributes can be used with this syntax in forms such as
            [[gnu::const]]. The standard attributes [[deprecated]],
            [[fallthrough]] and [[maybe_unused]] are supported.
          + UTF-8 character constants using the u8'' syntax are supported.
          + <float.h> defines macros FLT_NORM_MAX, DBL_NORM_MAX and
            LDBL_NORM_MAX.
          + When decimal floating-point arithmetic is supported, <float.h>
            defines macros DEC32_TRUE_MIN, DEC64_TRUE_MIN and
            DEC128_TRUE_MIN, in addition to the macros that were
            previously only defined if __STDC_WANT_DEC_FP__ was defined
            before including <float.h>.
          + In C2X mode, empty parentheses in a function definition give
            that function a type with a prototype for subsequent calls;
            other old-style function definitions are diagnosed by default
            in C2X mode.
          + The strftime format checking supports the %OB and %Ob formats.
          + In C2X mode, -fno-fp-int-builtin-inexact is enabled by
            default.
     * GCC now defaults to -fno-common. As a result, global variable
       accesses are more efficient on various targets. In C, global
       variables with multiple tentative definitions now result in linker
       errors. With -fcommon such definitions are silently merged during
       linking.

  C++

     * Several C++20 features have been implemented:
          + Concepts, including P0734R0, P0857R0, P1084R2, P1141R2,
            P0848R3, P1616R1, P1452R2
          + P1668R1, Permitting Unevaluated inline-assembly in constexpr
            Functions
          + P1161R3, Deprecate a[b,c]
          + P0848R3, Conditionally Trivial Special Member Functions
          + P1091R3, Extending structured bindings
          + P1143R2, Adding the constinit keyword
          + P1152R4, Deprecating volatile
          + P0388R4, Permit conversions to arrays of unknown bound
          + P0784R7, constexpr new
          + P1301R4, [[nodiscard("with reason")]]
          + P1814R0, class template argument deduction for alias templates
          + P1816R0, class template argument deduction for aggregates
          + P0960R3, Parenthesized initialization of aggregates
          + P1331R2, Allow trivial default initialization in constexpr
            contexts
          + P1327R1, Allowing dynamic_cast and polymorphic typeid in
            constexpr contexts
          + P0912R5, Coroutines (requires -fcoroutines)
     * Several C++ Defect Reports have been resolved, e.g.:
          + DR 1560, lvalue-to-rvalue conversion in ?:
          + DR 1813, __is_standard_layout for a class with repeated bases
          + DR 2094, volatile scalars are trivially copyable,
          + DR 2096, constraints on literal unions
          + DR 2413, typename in conversion-function-ids
          + DR 2352, Similar types and reference binding
          + DR 1601, Promotion of enumeration with fixed underlying type
          + DR 330, Qualification conversions and pointers to arrays of
            pointers
          + DR 1307, Overload resolution based on size of array
            initializer-list
          + DR 1710, Missing template keyword in class-or-decltype
     * New warnings:
          + [30]-Wmismatched-tags, disabled by default, warns about
            declarations of structs, classes, and class templates and
            their specializations with a class-key that does not match
            either the definition or the first declaration if no
            definition is provided. The option is provided to ease
            portability to Windows-based compilers.
          + [31]-Wredundant-tags, disabled by default, warns about
            redundant class-key and enum-key in contexts where the key can
            be eliminated without causing an syntactic ambiguity.
     * G++ can now detect modifying constant objects in constexpr
       evaluation (which is undefined behavior).
     * G++ no longer emits bogus -Wsign-conversion warnings with explicit
       casts.
     * Narrowing is now detected in more contexts (e.g., case values).
     * Memory consumption of the compiler has been reduced in constexpr
       evaluation.
     * The noexcept-specifier is now properly treated as a complete-class
       context as per [class.mem].
     * The attribute deprecated can now be used on namespaces too.
     * The ABI of passing and returning certain C++ classes by value
       changed on several targets in GCC 10, including [32]AArch64,
       [33]ARM, [34]PowerPC ELFv2, [35]S/390 and [36]Itanium. These
       changes affect classes with a zero-sized subobject (an empty base
       class, or data member with the [[no_unique_address]] attribute)
       where all other non-static data members have the same type (this is
       called a "homogeneous aggregate" in some ABI specifications, or if
       there is only one such member, a "single element"). In -std=c++17
       and -std=c++20 modes, classes with an empty base class were not
       considered to have a single element or to be a homogeneous
       aggregate, and so could be passed differently (in the wrong
       registers or at the wrong stack address). This could make code
       compiled with -std=c++17 and -std=c++14 ABI incompatible. This has
       been corrected and the empty bases are ignored in those ABI
       decisions, so functions compiled with -std=c++14 and -std=c++17 are
       now ABI compatible again. Example: struct empty {}; struct S :
       empty { float f; }; void f(S);. Similarly, in classes containing
       non-static data members with empty class types using the C++20
       [[no_unique_address]] attribute, those members weren't ignored in
       the ABI argument passing decisions as they should be. Both of these
       ABI changes are now diagnosed with -Wpsabi.

    Runtime Library (libstdc++)

     * Improved experimental C++2a support, including:
          + Library concepts in <concepts> and <iterator>.
          + Constrained algorithms in <ranges>, <algorithm>, and <memory>
            (thanks to Patrick Palka).
          + New algorithms shift_left and shift_right (thanks to Patrick
            Palka).
          + std::span (thanks to JeanHeyd Meneide).
          + Three-way comparisons in <compare> and throughout the library.
          + Constexpr support in <algorithm> and elsewhere (thanks to
            Edward Smith-Rowland).
          + <stop_token> and std::jthread (thanks to Thomas Rodgers).
          + std::atomic_ref and std::atomic<floating point>.
          + Integer comparison functions (cmp_equal, cmp_less etc.).
          + std::ssize, std::to_array.
          + std::construct_at, std::destroy, constexpr std::allocator.
          + Mathematical constants in <numbers>.
     * Support for RDSEED in std::random_device.
     * Reduced header dependencies, leading to faster compilation for some
       code.
     * The std::iterator base class of std::istreambuf_iterator was
       changed in C++98 mode to be consistent with C++11 and later
       standards. This is expected to have no noticeable effect except in
       the unlikely case of a class which has potentially overlapping
       subobjects of type std::istreambuf_iterator<C> and another iterator
       type with a std::iterator<input_iterator_tag, C, ...> base class.
       The layout of such a type might change when compiled as C++98.
       [37]Bug 92285 has more details and concrete examples.

  D

     * Support for static foreach has been implemented.
     * Aliases can now be created directly from any __traits that return
       symbols or tuples. Previously, an AliasSeq was necessary in order
       to alias their return.
     * It is now possible to detect the language ABI specified for a
       struct, class, or interface using __traits(getLinkage, ...).
     * Support for core.math.toPrec intrinsics has been added. These
       intrinsics guarantee the rounding to specific floating-point
       precisions at specified points in the code.
     * Support for pragma(inline) has been implemented. Previously the
       pragma was recognized, but had no effect on the compilation.
     * Optional parentheses in asm operands are deprecated and will be
       removed in a future release.
     * All content imported files are now included in the make dependency
       list when compiling with -M.
     * Compiler recognized attributes provided by the gcc.attribute module
       will now take effect when applied to function prototypes as well as
       when applied to full function declarations.
     * Added a --enable-libphobos-checking configure option to control
       whether run-time checks are compiled into the D runtime library.
     * Added a --with-libphobos-druntime-only configure option to indicate
       whether to build only the core D runtime library, or both the core
       and standard libraries into libphobos.

  Fortran

     * use_device_addr of version 5.0 of the [38]OpenMP specification is
       now supported. Note that otherwise OpenMP 4.5 is partially
       supported in the Fortran compiler; the largest missing item is
       structure element mapping.
     * The default buffer size for I/O using unformatted files has been
       increased to 1048576. The buffer size for can now be set at runtime
       via the environment variables GFORTRAN_FORMATTED_BUFFER_SIZE and
       GFORTRAN_UNFORMATTED_BUFFER_SIZE for formatted and unformatted
       files, respectively.
     * Mismatches between actual and dummy argument lists in a single file
       are now rejected with an error. Use the new option
       -fallow-argument-mismatch to turn these errors into warnings; this
       option is implied with -std=legacy. -Wargument-mismatch has been
       removed.
     * The handling of a BOZ literal constant has been reworked to provide
       better conformance to the Fortran 2008 and 2018 standards. In these
       Fortran standards, a BOZ literal constant is a typeless and
       kindless entity. As a part of the rework, documented and
       undocumented extensions to the Fortran standard now emit errors
       during compilation. Some of these extensions are permitted with the
       -fallow-invalid-boz option, which degrades the error to a warning
       and the code is compiled as with older gfortran.
     * At any optimization level except-Os, gfortran now uses inline
       packing for arguments instead of calling a library routine. If the
       source contains a large number of arguments that need to be
       repacked, code size or time for compilation can become excessive.
       If that is the case, -fno-inline-arg-packing can be used to disable
       inline argument packing.
     * Legacy extensions:
          + For formatted input/output, if the explicit widths after the
            data-edit descriptors I, F and G have been omitted, default
            widths are used.
          + A blank format item at the end of a format specification, i.e.
            nothing following the final comma, is allowed. Use the option
            -fdec-blank-format-item; this option is implied with -fdec.
          + The existing support for AUTOMATIC and STATIC attributes has
            been extended to allow variables with the AUTOMATIC attribute
            to be used in EQUIVALENCE statements. Use -fdec-static; this
            option is implied by -fdec.
          + Allow character literals in assignments and DATA statements
            for numeric (INTEGER, REAL, or COMPLEX) or LOGICAL variables.
            Use the option -fdec-char-conversions; this option is implied
            with -fdec.
          + DEC comparisons, i.e. allow Hollerith constants to be used in
            comparisons with INTEGER, REAL, COMPLEX and CHARACTER
            expressions. Use the option -fdec.
     * Character type names in errors and warnings now include len in
       addition to kind; * is used for assumed length. The kind is omitted
       if it is the default kind. Examples: CHARACTER(12), CHARACTER(6,4).
     * CO_BROADCAST now supports derived type variables including objects
       with allocatable components. In this case, the optional arguments
       STAT= and ERRMSG= are currently ignored.
     * The handling of module and submodule names has been reworked to
       allow the full 63-character length mandated by the standard.
       Previously symbol names were truncated if the combined length of
       module, submodule, and function name exceeded 126 characters. This
       change therefore breaks the ABI, but only for cases where this 126
       character limit was exceeded.

  Go

     * GCC 10 provides a complete implementation of the Go 1.14.6 user
       packages.

libgccjit

     * The libgccjit API gained four new entry points:
          + [39]gcc_jit_version_major, [40]gcc_jit_version_minor, and
            [41]gcc_jit_version_patchlevel for programmatically checking
            the libgccjit version from client code, and
          + [42]gcc_jit_context_new_bitfield

New Targets and Target Specific Improvements

  AArch64 & arm

     * The AArch64 and arm ports now support condition flag output
       constraints in inline assembly, as indicated by the
       __GCC_ASM_FLAG_OUTPUTS__. On arm this feature is only available for
       A32 and T32 targets. Please refer to the documentation for more
       details.

  AArch64

     * There have been several improvements related to the Scalable Vector
       Extension (SVE):
          + The SVE ACLE types and intrinsics are now supported. They can
            be accessed using the header file arm_sve.h.
          + It is now possible to create fixed-length SVE types using the
            arm_sve_vector_bits attribute. For example:
#if __ARM_FEATURE_SVE_BITS==512
typedef svint32_t vec512 __attribute__((arm_sve_vector_bits(512)));
typedef svbool_t pred512 __attribute__((arm_sve_vector_bits(512)));
#endif
          + -mlow-precision-div, -mlow-precision-sqrt and
            -mlow-precision-recip-sqrt now work for SVE.
          + -msve-vector-bits=128 now generates vector-length-specific
            code for little-endian targets. It continues to generate
            vector-length-agnostic code for big-endian targets, just as
            previous releases did for all targets.
          + The vectorizer is now able to use extending loads and
            truncating stores, including gather loads and scatter stores.
          + The vectorizer now compares the cost of vectorizing with SVE
            and vectorizing with Advanced SIMD and tries to pick the best
            one. Previously it would always use SVE if possible.
          + If a vector loop uses Advanced SIMD rather than SVE, the
            vectorizer now considers using SVE to vectorize the left-over
            elements (the “scalar tail” or “epilog”).
          + Besides these specific points, there have been many general
            improvements to the way that the vectorizer uses SVE.
     * The -mbranch-protection=pac-ret option now accepts the optional
       argument +b-key extension to perform return address signing with
       the B-key instead of the A-key.
     * The option -moutline-atomics has been added to aid deployment of
       the Large System Extensions (LSE) on GNU/Linux systems built with a
       baseline architecture targeting Armv8-A. When the option is
       specified code is emitted to detect the presence of LSE
       instructions at runtime and use them for standard atomic
       operations. For more information please refer to the documentation.
     * The Transactional Memory Extension is now supported through ACLE
       intrinsics. It can be enabled through the +tme option extension
       (for example, -march=armv8.5-a+tme).
     * A number of features from Armv8.5-A are now supported through ACLE
       intrinsics. These include:
          + The random number instructions that can be enabled through the
            (already present in GCC 9.1) +rng option extension.
          + Floating-point intrinsics to round to integer instructions
            from Armv8.5-A when targeting -march=armv8.5-a or later.
          + Memory Tagging Extension intrinsics enabled through the
            +memtag option extension.
     * Similarly, the following Armv8.6-A features are now supported
       through ACLE intrinsics:
          + The bfloat16 extension. This extension is enabled
            automatically when Armv8.6-A is selected (such as by
            -march=armv8.6-a). It can also be enabled for Armv8.2-A and
            later using the +bf16 option extension.
          + The Matrix Multiply extension. This extension is split into
            three parts, one for each supported data type:
               o Support for 8-bit integer matrix multiply instructions.
                 This extension is enabled automatically when Armv8.6-A is
                 selected. It can also be enabled for Armv8.2-A and later
                 using the +i8mm option extension.
               o Support for 32-bit floating-point matrix multiply
                 instructions. This extension can be enabled using the
                 +f32mm option extension, which also has the effect of
                 enabling SVE.
               o Support for 64-bit floating-point matrix multiply
                 instructions. This extension can be enabled using the
                 +f64mm option extension, which likewise has the effect of
                 enabling SVE.
     * SVE2 is now supported through ACLE intrinsics and (to a limited
       extent) through autovectorization. It can be enabled through the
       +sve2 option extension (for example, -march=armv8.5-a+sve2).
       Additional extensions can be enabled through +sve2-sm4, +sve2-aes,
       +sve2-sha3 and +sve2-bitperm.
     * Support has been added for the following processors (GCC
       identifiers in parentheses):
          + Arm Cortex-A77 (cortex-a77).
          + Arm Cortex-A76AE (cortex-a76ae).
          + Arm Cortex-A65 (cortex-a65).
          + Arm Cortex-A65AE (cortex-a65ae).
          + Arm Cortex-A34 (cortex-a34).
          + Marvell ThunderX3 (thunderx3t110).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a77 or -mtune=cortex-a65ae or as
       arguments to the equivalent target attributes and pragmas.

  arm

     * Support for the FDPIC ABI has been added. It uses 64-bit function
       descriptors to represent pointers to functions, and enables code
       sharing on MMU-less systems. The corresponding target triple is
       arm-uclinuxfdpiceabi, and the C library is uclibc-ng.
     * Support has been added for the Arm EABI on NetBSD through the
       arm*-*-netbsdelf-*eabi* triplet.
     * The handling of 64-bit integer operations has been significantly
       reworked and improved leading to improved performance and reduced
       stack usage when using 64-bit integral data types. The option
       -mneon-for-64bits is now deprecated and will be removed in a future
       release.
     * Support has been added for the following processors (GCC
       identifiers in parentheses):
          + Arm Cortex-A77 (cortex-a77).
          + Arm Cortex-A76AE (cortex-a76ae).
          + Arm Cortex-M35P (cortex-m35p).
          + Arm Cortex-M55 (cortex-m55).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a77 or -mtune=cortex-m35p.
     * Support has been extended for the ACLE [43]data-processing
       intrinsics to include 32-bit SIMD, saturating arithmetic, 16-bit
       multiplication and other related intrinsics aimed at DSP algorithm
       optimization.
     * Support for -mpure-code in Thumb-1 (v6m) has been added: this
       M-profile feature is no longer restricted to targets with MOVT. For
       example, -mcpu=cortex-m0 now supports this option.
     * Support for the [44]Armv8.1-M Mainline Architecture has been added.
          + Armv8.1-M Mainline can be enabled by using the
            -march=armv8.1-m.main command-line option.
     * Support for the [45]MVE beta ACLE intrinsics has been added. These
       intrinsics can be enabled by including the arm_mve.h header file
       and passing the +mve or +mve.fp option extensions (for example:
       -march=armv8.1-m.main+mve).
     * Support for the Custom Datapath Extension beta ACLE [46]intrinsics
       has been added.
     * Support for Armv8.1-M Mainline Security Extensions architecture has
       been added. The -mcmse option, when used in combination with an
       Armv8.1-M Mainline architecture (for example: -march=armv8.1-m.main
       -mcmse), now leads to the generation of improved code sequences
       when changing security states.

  AMD Radeon (GCN)

     * The code generation and in particular the vectorization support has
       been much improved.

  ARC

     * The interrupt service routine functions save all used registers,
       including extension registers and auxiliary registers used by Zero
       Overhead Loops.
     * Improve code size by using multiple short instructions instead of a
       single long mov or ior instruction when its long immediate constant
       is known.
     * Fix usage of the accumulator register for ARC600.
     * Fix issues with uncached attribute.
     * Remove -mq-class option.
     * Improve 64-bit integer addition and subtraction operations.

  AVR

     * Support for the XMEGA-like devices

     ATtiny202, ATtiny204, ATtiny402, ATtiny404, ATtiny406, ATtiny804,
     ATtiny806, ATtiny807, ATtiny1604, ATtiny1606, ATtiny1607, ATmega808,
     ATmega809, ATmega1608, ATmega1609, ATmega3208, ATmega3209,
     ATmega4808, ATmega4809
       has been added.
     * A new command-line option -nodevicespecs has been added. It allows
       to provide a custom device-specs file by means of

     avr-gcc -nodevicespecs -specs=my-spec-file <options>
       and without the need to provide options -B and -mmcu=. See [47]AVR
       command-line options for details. This feature is also available in
       GCC 9.3+ and GCC 8.4+.
     * New command-line options -mdouble=[32,64] and -mlong-double=[32,64]
       have been added. They allow to choose the size (in bits) of the
       double and long double types, respectively. Whether or not the
       mentioned layouts are available, whether the options act as a
       multilib option, and the default for either option are controlled
       by the new [48]AVR configure options --with-double= and
       --with-long-double=.
     * A new configure option --with-libf7= has been added. It controls to
       which level avr-libgcc provides 64-bit floating point support by
       means of [49]Libf7.
     * A new configure option --with-double-comparison= has been added.
       It's unlikely you need to set this option by hand.

  IA-32/x86-64

     * Support to expand __builtin_roundeven into the appropriate SSE 4.1
       instruction has been added.
     * New ISA extension support for Intel ENQCMD was added to GCC. ENQCMD
       intrinsics are available via the -menqcmd compiler switch.
     * GCC now supports the Intel CPU named Cooperlake through
       -march=cooperlake. The switch enables the AVX512BF16 ISA
       extensions.
     * GCC now supports the Intel CPU named Tigerlake through
       -march=tigerlake. The switch enables the MOVDIRI MOVDIR64B
       AVX512VP2INTERSECT ISA extensions.

  MIPS

     * The mips*-*-linux* targets now mark object files with appropriate
       GNU-stack note, facilitating use of non-executable stack hardening
       on GNU/Linux. The soft-float targets have this feature enabled by
       default, while for hard-float targets it is required for GCC to be
       configured with --with-glibc-version=2.31 against glibc 2.31 or
       later.

  PowerPC / PowerPC64 / RS6000

     * Many vector builtins have been listed as deprecated in the
       [50]64-Bit ELF V2 ABI Specification for quite a number of years.
       The vector builtins listed in Tables A.8 through A.10 are now
       deprecated for GCC 10, and will likely be removed from support in
       GCC 11. Note that this does not result in any loss of function.
       These deprecated builtins generally provide somewhat nonsensical
       argument lists (for example, mixing signed, unsigned, and bool
       vector arguments arbitrarily), or are duplicate builtins that are
       inconsistent with the expected naming scheme. We expect that this
       will be unlikely to affect much if any code, and any required code
       changes will be trivial.

  PRU

     * A new back end targeting TI PRU I/O processors has been contributed
       to GCC.

  RISC-V

     * The riscv*-*-* targets now require GNU binutils version 2.30 or
       later, to support new assembly instructions produced by GCC.

  V850

     * The ABI for V850 nested functions has been changed. Previously the
       V850 port used %r20 for the static chain pointer, now the port uses
       %r19. This corrects a long standing latent bug in the v850 port
       where a call to a nested function would unexpectedly change the
       value in %r20.

Operating Systems

Improvements for plugin authors

     * GCC diagnostics can now have a chain of events associated with
       them, describing a path through the code that triggers the problem.
       These can be printed by the diagnostics subsystem in various ways,
       controlled by the [51]-fdiagnostics-path-format option, or captured
       in JSON form via [52]-fdiagnostics-format=json.
     * GCC diagnostics can now be associated with [53]CWE weakness
       identifiers, which will appear on the standard error stream, and in
       the JSON output from [54]-fdiagnostics-format=json.

Other significant improvements

     * To allow inline expansion of both memcpy and memmove, the existing
       movmem instruction patterns used for non-overlapping memory copies
       have been renamed to cpymem. The movmem name is now used for
       overlapping memory moves, consistent with the library functions
       memcpy and memmove.
     * For many releases, when GCC emits a warning it prints the option
       controlling that warning. As of GCC 10, that option text is now a
       clickable hyperlink for the documentation of that option (assuming
       a [55]sufficiently capable terminal). This behavior can be
       controlled via a new [56]-fdiagnostics-urls option (along with
       various environment variables and heuristics documented with that
       option).

GCC 10.1

   This is the [57]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 10.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 10.2

   This is the [58]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 10.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 10.3

   This is the [59]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 10.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    AArch64

     * A bug with the Random Number intrinsics in the arm_acle.h header
       that resulted in an incorrect status result being returned has been
       fixed.
     * GCC now supports the Fujitsu A64FX. The associated -mcpu and -mtune
       options are -mcpu=a64fx and -mtune=a64fx respectively. In
       particular, -mcpu=a64fx generates code for Armv8.2-A with SVE and
       tunes the code for the A64FX. This includes tuning the SVE code,
       although by default the code is still length-agnostic and so works
       for all SVE implementations. Adding -msve-vector-bits=512 makes the
       code specific to 512-bit SVE.

  x86-64

     * GCC 10.3 supports AMD CPUs based on the znver3 core via
       -march=znver3.

GCC 10.4

  Target Specific Changes

    x86-64

     * The x86-64 ABI of passing and returning structures with a 64-bit
       integer vector changed in GCC 10.1 when MMX is disabled. Disabling
       MMX no longer changes how they are passed nor returned. This ABI
       change is now diagnosed with -Wpsabi.


    For questions related to the use of GCC, please consult these web
    pages and the [60]GCC manuals. If that fails, the
    [61]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [62]gcc@gcc.gnu.org. All of [63]our lists have public
    archives.

   Copyright (C) [64]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [65]maintained by the GCC team. Last modified
   2021-11-12[66].

References

   1. http://gcc.gnu.org/gcc-10/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. http://gcc.gnu.org/gcc-10/changes.html#empty_base
   4. https://www.mpfr.org/
   5. http://gcc.gnu.org/gcc-10/changes.html#iterator_base
   6. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/cpp/_005f_005fhas_005fbuiltin.html#g_t_005f_005fhas_005fbuiltin
   7. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Optimize-Options.html#index-fno-allocation-dce
   8. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Optimize-Options.html#index-fprofile-partial-training
   9. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Instrumentation-Options.html#index-fprofile-reproducible
  10. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Instrumentation-Options.html#index-fprofile-generate
  11. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Instrumentation-Options.html#index-fprofile-prefix-path
  12. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Static-Analyzer-Options.html
  13. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Optimize-Options.html#index-finline-functions
  14. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/lto-dump.html
  15. https://facebook.github.io/zstd/
  16. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Optimize-Options.html#index-fprofile-values
  17. https://www.openacc.org/
  18. https://gcc.gnu.org/wiki/OpenACC/Implementation Status#status-10
  19. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/libgomp/#toc-Enabling-OpenACC-1
  20. https://www.openmp.org/specifications/
  21. https://gcc.gnu.org/wiki/Offloading
  22. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Wstring-compare
  23. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Wzero-length-bounds
  24. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Warray-bounds
  25. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Wformat-overflow
  26. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Wrestrict
  27. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Wreturn-local-addr
  28. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Wstringop-overflow
  29. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Warning-Options.html#index-Warith-conversion
  30. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wmismatched-tags
  31. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wredundant-tags
  32. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94383
  33. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94711
  34. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94707
  35. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94704
  36. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=94706
  37. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=92285
  38. https://www.openmp.org/specifications/
  39. https://gcc.gnu.org/onlinedocs/jit/topics/compatibility.html#c.gcc_jit_version_major
  40. https://gcc.gnu.org/onlinedocs/jit/topics/compatibility.html#c.gcc_jit_version_minor
  41. https://gcc.gnu.org/onlinedocs/jit/topics/compatibility.html#c.gcc_jit_version_patchlevel
  42. https://gcc.gnu.org/onlinedocs/jit/topics/types.html#c.gcc_jit_context_new_bitfield
  43. https://developer.arm.com/documentation/101028/0009/Data-processing-intrinsics
  44. https://developer.arm.com/architectures/cpu-architecture/m-profile
  45. https://developer.arm.com/architectures/instruction-sets/simd-isas/helium/helium-intrinsics
  46. https://developer.arm.com/documentation/101028/0010/Custom-Datapath-Extension
  47. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/AVR-Options.html#index-nodevicespecs
  48. https://gcc.gnu.org/install/configure.html#avr
  49. https://gcc.gnu.org/wiki/avr-gcc#Libf7
  50. https://openpowerfoundation.org/?resource_lib=64-bit-elf-v2-abi-specification-power-architecture
  51. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-path-format
  52. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  53. https://cwe.mitre.org/
  54. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  55. https://gist.github.com/egmontkob/eb114294efbcd5adb1944c9f3cb5feda
  56. https://gcc.gnu.org/onlinedocs/gcc-10.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-urls
  57. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=10.0
  58. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=10.2
  59. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=10.3
  60. https://gcc.gnu.org/onlinedocs/
  61. mailto:gcc-help@gcc.gnu.org
  62. mailto:gcc@gcc.gnu.org
  63. https://gcc.gnu.org/lists.html
  64. https://www.fsf.org/
  65. https://gcc.gnu.org/about.html
  66. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-9/index.html
                              GCC 9 Release Series

   June 1, 2021

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 9.4.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 9.3 relative to previous releases of GCC.

Release History

   GCC 9.4
          June 1, 2021 ([2]changes, [3]documentation)

   GCC 9.3
          Mar 12, 2020 ([4]changes, [5]documentation)

   GCC 9.2
          Aug 12, 2019 ([6]changes, [7]documentation)

   GCC 9.1
          May 3, 2019 ([8]changes, [9]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [10]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [11]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [12]GCC
   project web site or contact the [13]GCC development mailing list.

   To obtain GCC please use [14]our mirror sites or [15]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [16]GCC manuals. If that fails, the
    [17]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [18]gcc@gcc.gnu.org. All of [19]our lists have public
    archives.

   Copyright (C) [20]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [21]maintained by the GCC team. Last modified
   2021-07-28[22].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-9/changes.html
   3. http://gcc.gnu.org/onlinedocs/9.4.0/
   4. http://gcc.gnu.org/gcc-9/changes.html
   5. http://gcc.gnu.org/onlinedocs/9.3.0/
   6. http://gcc.gnu.org/gcc-9/changes.html
   7. http://gcc.gnu.org/onlinedocs/9.2.0/
   8. http://gcc.gnu.org/gcc-9/changes.html
   9. http://gcc.gnu.org/onlinedocs/9.1.0/
  10. http://gcc.gnu.org/gcc-9/buildstat.html
  11. http://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Contributors.html
  12. http://gcc.gnu.org/index.html
  13. mailto:gcc@gcc.gnu.org
  14. http://gcc.gnu.org/mirrors.html
  15. http://gcc.gnu.org/git.html
  16. https://gcc.gnu.org/onlinedocs/
  17. mailto:gcc-help@gcc.gnu.org
  18. mailto:gcc@gcc.gnu.org
  19. https://gcc.gnu.org/lists.html
  20. https://www.fsf.org/
  21. https://gcc.gnu.org/about.html
  22. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-9/changes.html
                              GCC 9 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 9. You may also want to check out our [1]Porting to
   GCC 9 page and the [2]full GCC documentation.

Caveats

     * On Arm targets (arm*-*-*), [3]a bug in the implementation of the
       procedure call standard (AAPCS) in the GCC 6, 7 and 8 releases has
       been fixed: a structure containing a bit-field based on a 64-bit
       integral type and where no other element in a structure required
       64-bit alignment could be passed incorrectly to functions. This is
       an ABI change. If the option -Wpsabi is enabled (on by default) the
       compiler will emit a diagnostic note for code that might be
       affected.
     * Support for a number of older systems and recently unmaintained or
       untested target ports of GCC has been declared obsolete in GCC 9.
       Unless there is activity to revive them, the next release of GCC
       will have their sources permanently removed.
       The following ports for individual systems on particular
       architectures have been obsoleted:
          + Solaris 10 (*-*-solaris2.10). Details can be found in the
            [4]announcement.
          + Cell Broadband Engine SPU (spu*-*-*). Details can be found in
            the [5]announcement.
     * A change to the C++ std::rotate algorithm in GCC 9.1.0 can cause
       ABI incompatibilities with object files compiled with other
       versions of GCC. If the std::rotate algorithm is called with an
       empty range then it might cause a divide-by-zero error (as a SIGFPE
       signal) and crash. The change has been reverted for GCC 9.2.0 and
       future releases. For more details see [6]Bug 90920. The problem can
       be avoided by recompiling any objects that might call std::rotate
       with an empty range, so that the GCC 9.1.0 definition of
       std::rotate is not used.
     * The automatic template instantiation at link time ([7]-frepo) has
       been deprecated and will be removed in a future release.
     * The --with-default-libstdcxx-abi=gcc4-compatible configure option
       is broken in the 9.1 and 9.2 releases, producing a shared library
       with missing symbols (see [8]Bug 90361). As a workaround, configure
       without that option and build GCC as normal, then edit the
       installed <bits/c++config.h> headers to define the
       _GLIBCXX_USE_CXX11_ABI macro to 0.

General Improvements

   The following GCC command line options have been introduced or
   improved.
     * All command line options that take a byte-size argument accept
       64-bit integers as well as standard SI and IEC suffixes such as kb
       and KiB, MB and MiB, or GB and GiB denoting the corresponding
       multiples of bytes. See [9]Invoking GCC for more.
     * A new option,
       [10]-flive-patching=[inline-only-static|inline-clone], has been
       introduced to provide a safe compilation for live-patching. At the
       same time, provides multiple-level control on the enabled IPA
       optimizations. See the user guide for more details about the
       option.
     * A new option, --completion, has been added to provide more fine
       option completion in a shell. It is intended to be used by
       Bash-completion.
     * GCC's diagnostics now print source code with a left margin showing
       line numbers, configurable with
       [11]-fno-diagnostics-show-line-numbers.
       GCC's diagnostics can also now label regions of the source code to
       show pertinent information, such as the types within an expression.
$ g++ t.cc
t.cc: In function 'int test(const shape&, const shape&)':
t.cc:15:4: error: no match for 'operator+' (operand types are 'boxed_value<doubl
e>' and 'boxed_value<double>')
   14 |   return (width(s1) * height(s1)
      |           ~~~~~~~~~~~~~~~~~~~~~~
      |                     |
      |                     boxed_value<[...]>
   15 |    + width(s2) * height(s2));
      |    ^ ~~~~~~~~~~~~~~~~~~~~~~
      |                |
      |                boxed_value<[...]>

       These labels can be disabled via [12]-fno-diagnostics-show-labels.
     * A new option [13]-fdiagnostics-format=json has been introduced for
       emitting diagnostics in a machine-readable format.
     * The alignment-related options [14]-falign-functions,
       [15]-falign-labels, [16]-falign-loops, and [17]-falign-jumps
       received support for a secondary alignment (e.g.
       -falign-loops=n:m:n2:m2).
     * New pair of profiling options ([18]-fprofile-filter-files and
       [19]-fprofile-exclude-files) has been added. The options help to
       filter which source files are instrumented.
     * AddressSanitizer generates more compact redzones for automatic
       variables. That helps to reduce memory footprint of a sanitized
       binary.
     * Numerous improvements have been made to the output of
       [20]-fopt-info.
       Messages are now prefixed with optimized, missed, or note, rather
       than the old behavior of all being prefixed with note.
       The output from -fopt-info can now contain information on inlining
       decisions:
$ g++ -c inline.cc -O2 -fopt-info-inline-all
inline.cc:24:11: note: Considering inline candidate void foreach(T, T, void (*)(
E)) [with T = char**; E = char*]/2.
inline.cc:24:11: optimized:  Inlining void foreach(T, T, void (*)(E)) [with T =
char**; E = char*]/2 into int main(int, char**)/1.
inline.cc:19:12: missed:   not inlinable: void inline_me(char*)/0 -> int std::pu
ts(const char*)/3, function body not available
inline.cc:13:8: optimized:  Inlined void inline_me(char*)/4 into int main(int, c
har**)/1 which now has time 127.363637 and size 11, net change of +0.
Unit growth for small function inlining: 16->16 (0%)

Inlined 2 calls, eliminated 1 functions


       The output from the vectorizer has been rationalized so that failed
       attempts to vectorize a loop are displayed in the form
    [LOOP-LOCATION]: couldn't vectorize this loop
    [PROBLEM-LOCATION]: because of [REASON]

       rather than an exhaustive log of all decisions made by the
       vectorizer. For example:
$ gcc -c v.c -O3 -fopt-info-all-vec
v.c:7:3: missed: couldn't vectorize loop
v.c:10:7: missed: statement clobbers memory: __asm__ __volatile__("" :  :  : "me
mory");
v.c:3:6: note: vectorized 0 loops in function.
v.c:10:7: missed: statement clobbers memory: __asm__ __volatile__("" :  :  : "me
mory");

       The old behavior can be obtained via a new -internals suboption of
       -fopt-info.
     * A new option, [21]-fsave-optimization-record has been added, which
       writes a SRCFILE.opt-record.json.gz file describing the
       optimization decisions made by GCC. This is similar to the output
       of -fopt-info, but with additional metadata such as the inlining
       chain, and profile information (if available).
     * Inter-procedural propagation of stack alignment can now be
       controlled by [22]-fipa-stack-alignment.
     * Propagation of addressability, readonly and writeonly flags on
       static variables can now be controlled by
       [23]-fipa-reference-addressable.

   The following built-in functions have been introduced.
     * [24]__builtin_expect_with_probability to provide branch prediction
       probability hints to the optimizer.
     * [25]__builtin_has_attribute determines whether a function, type, or
       variable has been declared with some attribute.
     * [26]__builtin_speculation_safe_value can be used to help mitigate
       against unsafe speculative execution.

   The following attributes have been introduced.
     * The [27]copy function attribute has been added. The attribute can
       also be applied to type definitions and to variable declarations.

   A large number of improvements to code generation have been made,
   including but not limited to the following.
     * Switch expansion has been improved by using a different strategy
       (jump table, bit test, decision tree) for a subset of switch cases.
     * A linear function expression defined as a switch statement can be
       transformed by [28]-ftree-switch-conversion. For example:

int
foo (int how)
{
  switch (how) {
    case 2: how = 205; break;
    case 3: how = 305; break;
    case 4: how = 405; break;
    case 5: how = 505; break;
    case 6: how = 605; break;
  }
  return how;
}

       can be transformed into 100 * how + 5 (for values defined in the
       switch statement).
     * Inter-procedural optimization improvements:
          + Inliner defaults was tuned to better suits modern C++
            codebases especially when built with link time optimizations.
            New parameters max-inline-insns-small, max-inline-insns-size,
            uninlined-function-insns, uninlined-function-time,
            uninlined-thunk-insns, and uninlined-thunk-time were added.
          + Hot/cold partitioning is now more precise and aggressive.
          + Improved scalability for very large translation units
            (especially when link-time optimizing large programs).
     * Profile driven optimization improvements:
          + [29]-fprofile-use now enables [30]-fversion-loops-for-strides,
            [31]-floop-interchange, [32]-floop-unroll-and-jam,
            [33]-ftree-loop-distribution.
          + Streaming of counter histograms was removed. This reduces the
            size of profile files. Histogram is computed on the fly with
            link-time optimization. Parameter hot-bb-count-ws-permille was
            reduced from 999 to 990 to account for more precise
            histograms.
     * Link-time optimization improvements:
          + Types are now simplified prior streaming resulting in
            significant reductions of the LTO object files, link-time
            memory use, and improvements of link-time parallelism.
          + Default number of partitions (--param lto-partitions) was
            increased from 32 to 128 enabling effective use of CPUs with
            more than 32 hyperthreads. --param
            lto-max-streaming-parallelism can now be used to control
            number of streaming processes.
          + Warnings on C++ One Decl Rule violations (-Wodr) are now more
            informative and produce fewer redundant results.
       Overall compile time of Firefox 66 and LibreOffice 6.2.3 on an
       8-core machine was reduced by about 5% compared to GCC 8.3, and the
       size of LTO object files by 7%. LTO link-time improves by 11% on an
       8-core machine and scales significantly better for more parallel
       build environments. The serial stage of the link-time optimization
       is 28% faster consuming 20% less memory. The parallel stage now
       scales to up to 128 partitions rather than 32 and reduces memory
       use for every worker by 30%.

   The following improvements to the gcov command-line utility have been
   made.
     * The gcov tool received a new option [34]--use-hotness-colors (-q)
       that can provide perf-like coloring of hot functions.
     * The gcov tool has changed its intermediate format to a new JSON
       format.

New Languages and Language specific improvements

   [35]OpenACC support in C, C++, and Fortran continues to be maintained
   and improved. Most of the OpenACC 2.5 specification is implemented. See
   the [36]implementation status section on the OpenACC wiki page for
   further information.

  C family

     * Version 5.0 of the [37]OpenMP specification is now partially
       supported in the C and C++ compilers. For details which features of
       OpenMP 5.0 are and which are not supported in the GCC 9 release see
       [38]this mail.
     * New extensions:
          + [39]__builtin_convertvector built-in for vector conversions
            has been added.
     * New warnings:
          + [40]-Waddress-of-packed-member, enabled by default, warns
            about an unaligned pointer value from the address of a packed
            member of a struct or union.
     * Enhancements to existing warnings:
          + [41]-Warray-bounds detects more instances of out-of-bounds
            indices.
          + [42]-Wattribute-alias also detects attribute mismatches
            between alias declarations and their targets, in addition to
            mismatches between their types.
          + [43]-Wformat-overflow and [44]-Wformat-truncation have been
            extended to all formatted input/output functions (where
            applicable) and enhanced to detect a subset of instances of
            reading past the end of unterminated constant character arrays
            in %s directives.
          + [45]-Wmissing-attributes detects instances of missing function
            attributes on declarations of aliases and weak references.
          + [46]-Wstringop-truncation also detects a subset of instances
            of reading past the end of unterminated constant character
            arrays,
     * If a macro is used with the wrong argument count, the C and C++
       front ends now show the definition of that macro via a note.
     * The spelling corrector now considers transposed letters, and the
       threshold for similarity has been tightened, to avoid nonsensical
       suggestions.

  C

     * There is now experimental support for -std=c2x, to select support
       for the upcoming C2X revision of the ISO C standard. This standard
       is in the early stages of development and the only feature
       supported in GCC 9 is _Static_assert with a single argument
       (support for _Static_assert with two arguments was added in C11 and
       GCC 4.6). There are also new options -std=gnu2x, for C2X with GNU
       extensions, and -Wc11-c2x-compat, to warn for uses of features
       added in C2X (such warnings are also enabled by use of -Wpedantic
       if not using -std=c2x or -std=gnu2x).
     * New warnings:
          + [47]-Wabsolute-value warns for calls to standard functions
            that compute the absolute value of an argument when a more
            appropriate standard function is available. For example,
            calling abs(3.14) triggers the warning because the appropriate
            function to call to compute the absolute value of a double
            argument is fabs. The option also triggers warnings when the
            argument in a call to such a function has an unsigned type.
            This warning can be suppressed with an explicit type cast and
            it is also enabled by -Wextra.

  C++

     * New warnings:
          + [48]-Wdeprecated-copy, implied by -Wextra, warns about the
            C++11 deprecation of implicitly declared copy constructor and
            assignment operator if one of them is user-provided.
            -Wdeprecated-copy-dtor also warns if the destructor is
            user-provided, as specified in C++11.
          + [49]-Winit-list-lifetime, on by default, warns about uses of
            std::initializer_list that are likely to result in a dangling
            pointer, such as returning or assigning from a temporary list.
          + [50]-Wredundant-move, implied by -Wextra, warns about
            redundant calls to std::move.
          + [51]-Wpessimizing-move, implied by -Wall, warns when a call to
            std::move prevents copy elision.
          + [52]-Wclass-conversion, on by default, warns when a conversion
            function will never be called due to the type it converts to.
     * The C++ front end has experimental support for some of the upcoming
       C++2a draft features with the -std=c++2a or -std=gnu++2a flags,
       including range-based for statements with initializer, default
       constructible and assignable stateless lambdas, lambdas in
       unevaluated contexts, language support for empty data members,
       allowing pack expansion in lambda init-capture, likely and unlikely
       attributes, class types in non-type template parameters, allowing
       virtual function calls in constant expressions, explicit(bool),
       std::is_constant_evaluated, nested inline namespaces, etc. For a
       full list of new features, see [53]the C++ status page.
     * The C++ front end now preserves source locations for literals,
       id-expression, and mem-initializer for longer. For example it is
       now able to pin-point the pertinent locations for bad
       initializations such as these
$ g++ -c bad-inits.cc
bad-inits.cc:10:14: error: cannot convert 'json' to 'int' in initialization
   10 |   { 3, json::object },
      |        ~~~~~~^~~~~~
      |              |
      |              json
bad-inits.cc:14:31: error: initializer-string for array of chars is too long [-f
permissive]
   14 | char buffers[3][5] = { "red", "green", "blue" };
      |                               ^~~~~~~
bad-inits.cc: In constructor 'X::X()':
bad-inits.cc:17:13: error: invalid conversion from 'int' to 'void*' [-fpermissiv
e]
   17 |   X() : one(42), two(42), three(42)
      |             ^~
      |             |
      |             int

       rather than emitting the error at the final closing parenthesis or
       brace.
     * Error-reporting of overload resolution has been special-cased to
       make the case of a single failed candidate easier to read. For
       example:
$ g++ param-type-mismatch.cc
param-type-mismatch.cc: In function 'int test(int, const char*, float)':
param-type-mismatch.cc:8:32: error: cannot convert 'const char*' to 'const char*
*'
    8 |   return foo::member_1 (first, second, third);
      |                                ^~~~~~
      |                                |
      |                                const char*
param-type-mismatch.cc:3:46: note:   initializing argument 2 of 'static int foo:
:member_1(int, const char**, float)'
    3 |   static int member_1 (int one, const char **two, float three);
      |                                 ~~~~~~~~~~~~~^~~

       highlights both the problematic argument, and the parameter that it
       can't be converted to.
     * Diagnostics involving binary operators now use color to distinguish
       the two operands, and label them separately (as per the example of
       source labelling above).
     * Diagnostics involving function calls now highlight the pertinent
       parameter of the declaration in more places.
$ g++ bad-conversion.cc
bad-conversion.cc: In function 'void caller()':
bad-conversion.cc:9:14: error: cannot convert 'bool' to 'void*'
    9 |   callee (0, false, 2);
      |              ^~~~~
      |              |
      |              bool
bad-conversion.cc:3:19: note:   initializing argument 2 of 'void callee(int, voi
d*, int)'
    3 | void callee (int, void *, int)
      |                   ^~~~~~

     * The C++ front end's implementation of [54]-Wformat now shows
       precise locations within string literals, and underlines the
       pertinent arguments at bogus call sites (the C front end has been
       doing this since GCC 7). For example:
$ g++ -c bad-printf.cc -Wall
bad-printf.cc: In function 'void print_field(const char*, float, long int, long
int)':
bad-printf.cc:6:17: warning: field width specifier '*' expects argument of type
'int', but argument 3 has type 'long int' [-Wformat=]
    6 |   printf ("%s: %*ld ", fieldname, column - width, value);
      |                ~^~~               ~~~~~~~~~~~~~~
      |                 |                        |
      |                 int                      long int
bad-printf.cc:6:19: warning: format '%ld' expects argument of type 'long int', b
ut argument 4 has type 'double' [-Wformat=]
    6 |   printf ("%s: %*ld ", fieldname, column - width, value);
      |                ~~~^                               ~~~~~
      |                   |                               |
      |                   long int                        double
      |                %*f

     * The C++ front end has gained new fix-it hints for forgetting the
       return *this; needed by various C++ operators:
$ g++ -c operator.cc
operator.cc: In member function 'boxed_ptr& boxed_ptr::operator=(const boxed_ptr
&)':
operator.cc:7:3: warning: no return statement in function returning non-void [-W
return-type]
    6 |     m_ptr = other.m_ptr;
  +++ |+    return *this;
    7 |   }
      |   ^

       for when the compiler needs a typename:
$ g++ -c template.cc
template.cc:3:3: error: need 'typename' before 'Traits::type' because 'Traits' i
s a dependent scope
    3 |   Traits::type type;
      |   ^~~~~~
      |   typename

       when trying to use an accessor member as if it were a data member:
$ g++ -c fncall.cc
fncall.cc: In function 'void hangman(const mystring&)':
fncall.cc:12:11: error: invalid use of member function 'int mystring::get_length
() const' (did you forget the '()' ?)
   12 |   if (str.get_length > 0)
      |       ~~~~^~~~~~~~~~
      |                     ()

       for C++11's scoped enums:
$ g++ -c enums.cc
enums.cc: In function 'void json::test(const json::value&)':
enums.cc:12:26: error: 'STRING' was not declared in this scope; did you mean 'js
on::kind::STRING'?
   12 |     if (v.get_kind () == STRING)
      |                          ^~~~~~
      |                          json::kind::STRING
enums.cc:3:44: note: 'json::kind::STRING' declared here
    3 |   enum class kind { OBJECT, ARRAY, NUMBER, STRING, TRUE, FALSE, NULL_ };
      |                                            ^~~~~~

       and a tweak to integrate the suggestions about misspelled members
       with that for accessors:
$ g++ -c accessor-fixit.cc
accessor-fixit.cc: In function 'int test(t*)':
accessor-fixit.cc:17:15: error: 'class t' has no member named 'ratio'; did you m
ean 'int t::m_ratio'? (accessible via 'int t::get_ratio() const')
   17 |   return ptr->ratio;
      |               ^~~~~
      |               get_ratio()

       In addition, various diagnostics in the C++ front-end have been
       streamlined by consolidating the suggestion into the initial error,
       rather than emitting a follow-up note:
$ g++ typo.cc
typo.cc:5:13: error: 'BUFSIZE' was not declared in this scope; did you mean 'BUF
_SIZE'?
    5 | uint8_t buf[BUFSIZE];
      |             ^~~~~~~
      |             BUF_SIZE

    Runtime Library (libstdc++)

     * Improved support for C++17, including:
          + The C++17 implementation is no longer experimental.
          + Parallel algorithms and <execution> (requires [55]Thread
            Building Blocks 2018 or newer).
          + <memory_resource>.
          + Using the types and functions in <filesystem> does not require
            linking with -lstdc++fs now.
     * Improved experimental support for C++2a, including:
          + Type traits std::remove_cvref, std::unwrap_reference,
            std::unwrap_decay_ref, std::is_nothrow_convertible, and
            std::type_identity.
          + Headers <bit> and <version>.
          + Uniform container erasure (std::erase_if).
          + contains member of maps and sets.
          + String prefix and suffix checking (starts_with, ends_with).
          + Functions std::midpoint and std::lerp for interpolation.
          + std::bind_front.
          + std::visit<R>.
          + std::assume_aligned.
          + Uses-allocator construction utilities.
          + std::pmr::polymorphic_allocator<std::byte>.
          + Library support for char8_t type.
          + Destroying delete.
          + std::is_constant_evaluated() function.
     * Support for opening file streams with wide character paths on
       Windows
     * Incomplete support for the C++17 Filesystem library and the
       Filesystem TS on Windows.
     * Incomplete, experimental support for the Networking TS.

  D

     * Support for the D programming language has been added to GCC,
       implementing version 2.076 of the language and run-time library.

  Fortran

     * Asynchronous I/O is now fully supported. The program needs to be
       linked against the pthreads library to use it, otherwise the I/O is
       done synchronously. For systems which do not support POSIX
       condition variables, such as AIX, all I/O is still done
       synchronously.
     * The BACK argument for MINLOC and MAXLOC has been implemented.
     * The FINDLOC intrinsic function has been implemented.
     * The IS_CONTIGUOUS intrinsic function has been implemented.
     * Direct access to the real and imaginary parts of a complex variable
       via c%re and c%im has been implemented.
     * Type parameter inquiry via str%len and a%kind has been implemented.
     * C descriptors and the ISO_Fortran_binding.h source file have been
       implemented.
     * The MAX and MIN intrinsics are no longer guaranteed to return any
       particular value in case one of the arguments is a NaN. Note that
       this conforms to the Fortran standard and to what other Fortran
       compilers do. If there is a need to handle that case in some
       specific way, one needs to explicitly check for NaN's before
       calling MAX or MIN, e.g. by using the IEEE_IS_NAN function from the
       intrinsic module IEEE_ARITHMETIC.
     * A new command-line option [56]-fdec-include, set also by the
       [57]-fdec option, has been added to increase compatibility with
       legacy code. With this option, an INCLUDE directive is also parsed
       as a statement, which allows the directive to be spread across
       multiple source lines with line continuations.
     * A new [58]BUILTIN directive, has been added. The purpose of the
       directive is to provide an API between the GCC compiler and the GNU
       C Library which would define vector implementations of math
       routines.

  Go

     * GCC 9 provides a complete implementation of the Go 1.12.2 user
       packages.

libgccjit

     * The libgccjit API gained a new entry point:
       [59]gcc_jit_context_add_driver_option.

New Targets and Target Specific Improvements

  AArch64 & Arm

     * Support has been added for the following processors (GCC
       identifiers in parentheses):
          + Arm Cortex-A76 (cortex-a76).
          + Arm Cortex-A55/Cortex-A76 DynamIQ big.LITTLE
            (cortex-a76.cortex-a55).
          + Arm Neoverse N1 (neoverse-n1).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a76 or
       -mtune=cortex-a76.cortex-a55 or as arguments to the equivalent
       target attributes and pragmas.
     * The Armv8.3-A complex number instructions are now supported via
       intrinsics when the option -march=armv8.3-a or equivalent is
       specified. For the half-precision floating-point variants of these
       instructions use the architecture extension flag +fp16, e.g.
       -march=armv8.3-a+fp16.
       The intrinsics are defined by the ACLE specification.
     * The Armv8.5-A architecture is now supported through the
       -march=armv8.5-a option.
     * The Armv8.5-A architecture also adds some security features that
       are optional to all older architecture versions. These are now
       supported and only affect the assembler.
          + Speculation Barrier instruction through the -march=armv8-a+sb
            option.
          + Execution and Data Prediction Restriction instructions through
            the -march=armv8-a+predres option.
          + Speculative Store Bypass Safe instruction through the
            -march=armv8-a+ssbs option. This does not require a compiler
            option for Arm and thus -march=armv8-a+ssbs is an
            AArch64-specific option.

      AArch64 specific

     * Support has been added for the Arm Neoverse E1 processor
       (-mcpu=neoverse-e1).
     * The AArch64 port now has support for stack clash protection using
       the [60]-fstack-clash-protection option. The probing interval/guard
       size can be set by using --param
       stack-clash-protection-guard-size=12|16. The value of this
       parameter must be in bytes represented as a power of two. The two
       supported values for this parameter are 12 (for a 4KiB size, 2^12)
       and 16 (for a 64KiB size, 2^16). The default value is 16 (64Kb) and
       can be changed at configure time using the flag
       --with-stack-clash-protection-guard-size=12|16.
     * The option -msign-return-address= has been deprecated. This has
       been replaced by the new -mbranch-protection= option. This new
       option can now be used to enable the return address signing as well
       as the new Branch Target Identification feature of Armv8.5-A
       architecture. For more information on the arguments accepted by
       this option, please refer to [61]AArch64-Options.
     * The following optional extensions to Armv8.5-A architecture are now
       supported and only affect the assembler.
          + Random Number Generation instructions through the
            -march=armv8.5-a+rng option.
          + Memory Tagging Extension through the -march=armv8.5-a+memtag
            option.

      Arm specific

     * Support for the deprecated Armv2 and Armv3 architectures and their
       variants has been removed. Their corresponding -march values and
       the -mcpu options that used these architectures have been removed.
     * Support for the Armv5 and Armv5E architectures (which have no known
       implementations) has been removed. Note that Armv5T, Armv5TE and
       Armv5TEJ architectures remain supported.
     * Corrected FPU configurations for Cortex-R7 and Cortex-R8 when using
       their respective -mcpu options.

  AMD GCN

     * A new back end targeting AMD GCN GPUs has been contributed to GCC.
       The implementation is currently limited to compiling
       single-threaded, stand-alone programs. Future versions will add
       support for offloading multi-threaded kernels via OpenMP and
       OpenACC. The following devices are supported (GCC identifiers in
       parentheses):
          + Fiji (fiji).
          + Vega 10 (gfx900).

  ARC

     * LRA is now on by default for the ARC target. This can be controlled
       by -mlra.
     * Add support for frame code-density and branch-and-index
       instructions.

  C-SKY

     * A new back end targeting C-SKY V2 processors has been contributed
       to GCC.

  IA-32/x86-64

     * Support of Intel MPX (Memory Protection Extensions) has been
       removed.
     * New ISA extension support for Intel PTWRITE was added to GCC.
       PTWRITE intrinsics are available via the -mptwrite compiler switch.
     * GCC now supports the Intel CPU named Cascade Lake with AVX512
       extensions through -march=cascadelake. The switch enables the
       following ISA extensions: AVX512F, AVX512VL, AVX512CD, AVX512BW,
       AVX512DQ, AVX512VNNI.

  OpenRISC

     * A new back end targeting OpenRISC processors has been contributed
       to GCC.

  S/390, System z, IBM z Systems

     * Support for the arch13 architecture has been added. When using the
       -march=arch13 option, the compiler will generate code making use of
       the new instructions introduced with the vector enhancement
       facility 2 and the miscellaneous instruction extension facility 2.
       The -mtune=arch13 option enables arch13 specific instruction
       scheduling without making use of new instructions.
     * Builtins for the new vector instructions have been added and can be
       enabled using the -mzvector option.
     * Support for ESA architecture machines g5 and g6 is deprecated since
       GCC 6.1.0 and has been removed now.
     * When compiling with -march=z14 or higher GCC emits alignments hints
       on the vector load/store instructions (8 or 16 byte).
     * Functions now have a default alignment of 16 bytes. This helps with
       branch prediction effects.
     * -mfentry is now supported. As well as the mcount mechanism the
       __fentry__ is called before the function prologue. However, since
       just a single instruction is required to call __fentry__ the call
       sequence imposes a smaller overhead than mcount (4 instructions).
       The produced code is compatible only with newer glibc versions,
       which provide the __fentry__ symbol and do not clobber r0 when
       resolving lazily bound functions. -mfentry is only supported when
       generating 64 bit code and does not work with nested C functions.
     * The -mnop-mcount option can be used to emit NOP instructions
       instead of an mcount or fentry call stub.
     * With the -mrecord-mcount option a __mcount_loc section is generated
       containing pointers to each profiling call stub. This is useful for
       automatically patching in and out calls.

Operating Systems

  Solaris

     * g++ now unconditionally enables large file support when compiling
       32-bit code.
     * Support for the AddressSanitizer and UndefinedBehaviorSanitizer has
       been merged from LLVM. For the moment, this only works for 32-bit
       code on both SPARC and x86.
     * An initial port of the D runtime library has been completed on
       Solaris 11/x86. It requires the use of GNU as. Solaris 11/SPARC
       support is still work-in-progress.

  Windows

     * A C++ Microsoft ABI bitfield layout bug, [62]PR87137 has been
       fixed. A non-field declaration could cause the current bitfield
       allocation unit to be completed, incorrectly placing a following
       bitfield into a new allocation unit. The Microsoft ABI is selected
       for:
          + Mingw targets
          + PowerPC, IA-32 or x86-64 targets when the -mms-bitfields
            option is specified, or __attribute__((ms_struct)) is used
          + SuperH targets when the -mhitachi option is specified, or
            __attribute__((renesas)) is used

Improvements for plugin authors

     * GCC's diagnostic subsystem now has a way to logically group
       together related diagnostics, auto_diagnostic_group. Such
       diagnostics will be nested by the output of
       [63]-fdiagnostics-format=json.
     * GCC now has a set of [64]user experience guidelines for GCC, with
       information and advice on implementing new diagnostics.

Other significant improvements

     * GCC's internal "selftest" suite now runs for C++ as well as C (in
       debug builds of the compiler).

GCC 9.1

   This is the [65]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 9.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 9.2

   This is the [66]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 9.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 9.3

   This is the [67]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 9.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 9.4

   This is the [68]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 9.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    AArch64

     * The option -moutline-atomics has been added to aid deployment of
       the Large System Extensions (LSE) on GNU/Linux systems built with a
       baseline architecture targeting Armv8-A. When the option is
       specified code is emitted to detect the presence of LSE
       instructions at run time and use them for standard atomic
       operations. For more information please refer to the documentation.
     * GCC now supports the Fujitsu A64FX. The associated -mcpu and -mtune
       options are -mcpu=a64fx and -mtune=a64fx respectively. In
       particular, -mcpu=a64fx generates code for Armv8.2-A with SVE and
       tunes the code for the A64FX. This includes tuning the SVE code,
       although by default the code is still length-agnostic and so works
       for all SVE implementations. Adding -msve-vector-bits=512 makes the
       code specific to 512-bit SVE.


    For questions related to the use of GCC, please consult these web
    pages and the [69]GCC manuals. If that fails, the
    [70]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [71]gcc@gcc.gnu.org. All of [72]our lists have public
    archives.

   Copyright (C) [73]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [74]maintained by the GCC team. Last modified
   2021-07-28[75].

References

   1. http://gcc.gnu.org/gcc-9/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88469
   4. https://gcc.gnu.org/ml/gcc/2018-10/msg00139.html
   5. https://gcc.gnu.org/ml/gcc/2019-04/msg00023.html
   6. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=90920
   7. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/C_002b_002b-Dialect-Options.html#index-frepo
   8. https://gcc.gnu.org/PR90361
   9. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Invoking-GCC.html#Invoking-GCC
  10. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-flive-patching
  11. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fno-diagnostics-show-line-numbers
  12. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fno-diagnostics-show-labels
  13. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  14. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-falign-functions
  15. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-falign-labels
  16. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-falign-loops
  17. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-falign-jumps
  18. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Instrumentation-Options.html#index-fprofile-filter-files
  19. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Instrumentation-Options.html#index-fprofile-exclude-files
  20. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Developer-Options.html#index-fopt-info
  21. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Developer-Options.html#index-fsave-optimization-record
  22. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-fipa-stack-alignment
  23. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-fipa-reference-addressable
  24. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Other-Builtins.html#index-_005f_005fbuiltin_005fexpect_005fwith_005fprobability
  25. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Other-Builtins.html#index-_005f_005fbuiltin_005fhas_005fattribute-1
  26. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Other-Builtins.html#index-_005f_005fbuiltin_005fspeculation_005fsafe_005fvalue-1
  27. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Common-Function-Attributes.html#index-copy-function-attribute
  28. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-ftree-switch-conversion
  29. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-fprofile-use
  30. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-fversion-loops-for-strides
  31. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-floop-interchange
  32. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-floop-unroll-and-jam
  33. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Optimize-Options.html#index-ftree-loop-distribution
  34. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Invoking-Gcov.html#Invoking-Gcov
  35. https://www.openacc.org/
  36. https://gcc.gnu.org/wiki/OpenACC/Implementation Status#status-9
  37. https://www.openmp.org/specifications/
  38. https://gcc.gnu.org/ml/gcc-patches/2018-11/msg00628.html
  39. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Vector-Extensions.html#index-_005f_005fbuiltin_005fconvertvector
  40. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Waddress-of-packed-member
  41. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Warray-bounds
  42. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Wattribute-alias
  43. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Wformat-overflow
  44. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Wformat-truncation
  45. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Wmissing-attributes
  46. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Wstringop-truncation
  47. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Wabsolute-value
  48. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wdeprecated-copy
  49. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Winit-list-lifetime
  50. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wredundant-move
  51. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wpessimizing-move
  52. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/C_002b_002b-Dialect-Options.html#index-Wclass-conversion
  53. http://gcc.gnu.org/projects/cxx-status.html#cxx2a
  54. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Warning-Options.html#index-Wformat
  55. https://github.com/oneapi-src/oneTBB
  56. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gfortran/Fortran-Dialect-Options.html#index-fdec-include
  57. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gfortran/Fortran-Dialect-Options.html#index-fdec
  58. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gfortran/BUILTIN-directive.html#BUILTIN-directive
  59. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/jit/topics/contexts.html#gcc_jit_context_add_driver_option
  60. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Instrumentation-Options.html#index-fstack-protector
  61. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/AArch64-Options.html#AArch64-Options
  62. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=87137
  63. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gcc/Diagnostic-Message-Formatting-Options.html#index-fdiagnostics-format
  64. https://gcc.gnu.org/onlinedocs/gcc-9.1.0/gccint/User-Experience-Guidelines.html
  65. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=9.0
  66. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=9.2
  67. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=9.3
  68. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=9.4
  69. https://gcc.gnu.org/onlinedocs/
  70. mailto:gcc-help@gcc.gnu.org
  71. mailto:gcc@gcc.gnu.org
  72. https://gcc.gnu.org/lists.html
  73. https://www.fsf.org/
  74. https://gcc.gnu.org/about.html
  75. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-8/index.html
                              GCC 8 Release Series

   May 14, 2021

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 8.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 8.4 relative to previous releases of GCC.

Release History

   GCC 8.5
          May 14, 2021 ([2]changes, [3]documentation)

   GCC 8.4
          Mar 4, 2020 ([4]changes, [5]documentation)

   GCC 8.3
          Feb 22, 2019 ([6]changes, [7]documentation)

   GCC 8.2
          Jul 26, 2018 ([8]changes, [9]documentation)

   GCC 8.1
          May 2, 2018 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2021-07-28[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-8/changes.html
   3. http://gcc.gnu.org/onlinedocs/8.5.0/
   4. http://gcc.gnu.org/gcc-8/changes.html
   5. http://gcc.gnu.org/onlinedocs/8.4.0/
   6. http://gcc.gnu.org/gcc-8/changes.html
   7. http://gcc.gnu.org/onlinedocs/8.3.0/
   8. http://gcc.gnu.org/gcc-8/changes.html
   9. http://gcc.gnu.org/onlinedocs/8.2.0/
  10. http://gcc.gnu.org/gcc-8/changes.html
  11. http://gcc.gnu.org/onlinedocs/8.1.0/
  12. http://gcc.gnu.org/gcc-8/buildstat.html
  13. http://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/git.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. https://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-8/changes.html
                              GCC 8 Release Series
                        Changes, New Features, and Fixes

   This page is a "brief" summary of some of the huge number of
   improvements in GCC 8. You may also want to check out our [1]Porting to
   GCC 8 page and the [2]full GCC documentation.

Caveats

     * Support for the obsolete SDB/coff debug info format has been
       removed. The option -gcoff no longer does anything.
     * The Cilk+ extensions to the C and C++ languages have been removed.
     * The MPX extensions to the C and C++ languages have been deprecated
       and will be removed in a future release.
     * The extension allowing arithmetic on std::atomic<void*> and types
       like std::atomic<R(*)()> has been deprecated.
     * The non-standard C++0x std::copy_exception function was removed.
       std::make_exception_ptr should be used instead.
     * Support for the powerpc*-*-*spe* target ports which have been
       recently unmaintained and untested in GCC has been declared
       obsolete in GCC 8 as [3]announced. Unless there is activity to
       revive them, the next release of GCC will have their sources
       permanently removed.

General Improvements

     * Inter-procedural optimization improvements:
          + Reworked run-time estimation metrics leading to more realistic
            guesses driving inliner and cloning heuristics.
          + The ipa-pure-const pass is extended to propagate the malloc
            attribute, and the corresponding warning option
            -Wsuggest-attribute=malloc emits a diagnostic for functions
            which can be annotated with the malloc attribute.
     * Profile driven optimization improvements:
          + New infrastructure for representing profiles (both statically
            guessed and profile feedback) which allows propagation of
            additional information about the reliability of the profile.
          + A number of improvements in the profile updating code solving
            problems found by new verification code.
          + Static detection of code which is not executed in a valid run
            of the program. This includes paths which trigger undefined
            behavior as well as calls to functions declared with the cold
            attribute. Newly the noreturn attribute does not imply all
            effects of cold to differentiate between exit (which is
            noreturn) and abort (which is in addition not executed in
            valid runs).
          + -freorder-blocks-and-partition, a pass splitting function
            bodies into hot and cold regions, is now enabled by default at
            -O2 and higher for x86 and x86-64.
     * Link-time optimization improvements:
          + We have significantly improved debug information on ELF
            targets using DWARF by properly preserving language-specific
            information. This allows for example the libstdc++
            pretty-printers to work with LTO optimized executables.
     * A new option -fcf-protection=[full|branch|return|none] is
       introduced to perform code instrumentation to increase program
       security by checking that target addresses of control-flow transfer
       instructions (such as indirect function call, function return,
       indirect jump) are valid. Currently the instrumentation is
       supported on x86 GNU/Linux targets only. See the user guide for
       further information about the option syntax and section "New
       Targets and Target Specific Improvements" for IA-32/x86-64 for more
       details.
     * The -gcolumn-info option is now enabled by default. It includes
       column information in addition to just filenames and line numbers
       in DWARF debugging information.
     * The polyhedral-based loop nest optimization pass
       -floop-nest-optimize has been overhauled. It's still considered
       experimental and may not result in any runtime improvements.
     * Two new classical loop nest optimization passes have been added.
       -floop-unroll-and-jam performs outer loop unrolling and fusing of
       the inner loop copies. -floop-interchange exchanges loops in a loop
       nest to improve data locality. Both passes are enabled by default
       at -O3 and above.
     * The classic loop nest optimization pass -ftree-loop-distribution
       has been improved and enabled by default at -O3 and above. It
       supports loop nest distribution in some restricted scenarios; it
       also supports cancellable innermost loop distribution with loop
       versioning under run-time alias checks.
     * The new option -fstack-clash-protection causes the compiler to
       insert probes whenever stack space is allocated statically or
       dynamically to reliably detect stack overflows and thus mitigate
       the attack vector that relies on jumping over a stack guard page as
       provided by the operating system.
     * A new pragma GCC unroll has been implemented in the C family of
       languages, as well as Fortran and Ada, so as to make it possible
       for the user to have a finer-grained control over the loop
       unrolling optimization.
     * GCC has been enhanced to detect more instances of meaningless or
       mutually exclusive attribute specifications and handle such
       conflicts more consistently. Mutually exclusive attribute
       specifications are ignored with a warning regardless of whether
       they appear on the same declaration or on distinct declarations of
       the same entity. For example, because the noreturn attribute on the
       second declaration below is mutually exclusive with the malloc
       attribute on the first, it is ignored and a warning is issued.
>
      void* __attribute__ ((malloc)) f (unsigned);
      void* __attribute__ ((noreturn)) f (unsigned);

      warning: ignoring attribute 'noreturn' because it conflicts with attribute
 'malloc' [-Wattributes]
     * The gcov tool can distinguish functions that begin on a same line
       in a source file. This can be a different template instantiation or
       a class constructor:

File 'ins.C'
Lines executed:100.00% of 8
Creating 'ins.C.gcov'

        -:    0:Source:ins.C
        -:    0:Graph:ins.gcno
        -:    0:Data:ins.gcda
        -:    0:Runs:1
        -:    0:Programs:1
        -:    1:template<class T>
        -:    2:class Foo
        -:    3:{
        -:    4: public:
        2:    5:   Foo(): b (1000) {}
------------------
Foo<char>::Foo():
        1:    5:   Foo(): b (1000) {}
------------------
Foo<int>::Foo():
        1:    5:   Foo(): b (1000) {}
------------------
        2:    6:   void inc () { b++; }
------------------
Foo<char>::inc():
        1:    6:   void inc () { b++; }
------------------
Foo<int>::inc():
        1:    6:   void inc () { b++; }
------------------
        -:    7:
        -:    8:  private:
        -:    9:   int b;
        -:   10:};
        -:   11:
        1:   12:int main(int argc, char **argv)
        -:   13:{
        1:   14:  Foo<int> a;
        1:   15:  Foo<char> b;
        -:   16:
        1:   17:  a.inc ();
        1:   18:  b.inc ();
        1:   19:}

     * The gcov tool has more accurate numbers for execution of lines in a
       source file.
     * The gcov tool can use TERM colors to provide more readable output.
     * AddressSanitizer gained a new pair of sanitization options,
       -fsanitize=pointer-compare and -fsanitize=pointer-subtract, which
       warn about subtraction (or comparison) of pointers that point to a
       different memory object:

int
main ()
{
  /* Heap allocated memory.  */
  char *heap1 = (char *)__builtin_malloc (42);
  char *heap2 = (char *)__builtin_malloc (42);
  if (heap1 > heap2)
      return 1;

  return 0;
}

==17465==ERROR: AddressSanitizer: invalid-pointer-pair: 0x604000000010 0x6040000
00050
    #0 0x40070f in main /tmp/pointer-compare.c:7
    #1 0x7ffff6a72a86 in __libc_start_main (/lib64/libc.so.6+0x21a86)
    #2 0x400629 in _start (/tmp/a.out+0x400629)

0x604000000010 is located 0 bytes inside of 42-byte region [0x604000000010,0x604
00000003a)
allocated by thread T0 here:
    #0 0x7ffff6efb390 in __interceptor_malloc ../../../../libsanitizer/asan/asan
_malloc_linux.cc:86
    #1 0x4006ea in main /tmp/pointer-compare.c:5
    #2 0x7ffff6a72a86 in __libc_start_main (/lib64/libc.so.6+0x21a86)

0x604000000050 is located 0 bytes inside of 42-byte region [0x604000000050,0x604
00000007a)
allocated by thread T0 here:
    #0 0x7ffff6efb390 in __interceptor_malloc ../../../../libsanitizer/asan/asan
_malloc_linux.cc:86
    #1 0x4006f8 in main /tmp/pointer-compare.c:6
    #2 0x7ffff6a72a86 in __libc_start_main (/lib64/libc.so.6+0x21a86)

SUMMARY: AddressSanitizer: invalid-pointer-pair /tmp/pointer-compare.c:7 in main

     * The store merging pass has been enhanced to handle bit-fields and
       not just constant stores, but also data copying from adjacent
       memory locations into other adjacent memory locations, including
       bitwise logical operations on the data. The pass can also handle
       byte swapping into memory locations.
     * The undefined behavior sanitizer gained two new options included in
       -fsanitize=undefined: -fsanitize=builtin which diagnoses at run
       time invalid arguments to __builtin_clz or __builtin_ctz prefixed
       builtins, and -fsanitize=pointer-overflow which performs cheap run
       time tests for pointer wrapping.
     * A new attribute no_sanitize can be applied to functions to instruct
       the compiler not to do sanitization of the options provided as
       arguments to the attribute. Acceptable values for no_sanitize match
       those acceptable by the -fsanitize command-line option.

void __attribute__ ((no_sanitize ("alignment", "object-size")))
f () { /* Do something. */; }

New Languages and Language specific improvements

  Ada

     * For its internal exception handling used on the host for error
       recovery in the front-end, the compiler now relies on the native
       exception handling mechanism of the host platform, which should be
       more efficient than the former mechanism.

  BRIG (HSAIL)

   In this release cycle, the focus for the BRIGFE was on stabilization
   and performance improvements. Also a couple of completely new features
   were added.
     * Improved support for function and module scope group segment
       variables. PRM specs define function and module scope group segment
       variables as an experimental feature. However, PRM test suite uses
       them. Now group segment is handled by separate book keeping of
       module scope and function (kernel) offsets. Each function has a
       "frame" in the group segment offset to which is given as an
       argument, similar to traditional call stack frame handling.
     * Reduce the number of type conversions due to the untyped HSAIL
       registers. Instead of always representing the HSAIL's untyped
       registers as unsigned int, the gccbrig now pre-analyzes the BRIG
       code and builds the register variables as a type used the most when
       storing or reading data to/from each register. This reduces the
       number of total casts which cannot be always optimized away.
     * Support for BRIG_KIND_NONE directives.
     * Made -O3 the default optimization level for BRIGFE.
     * Fixed illegal addresses generated from address expressions which
       refer only to offset 0.
     * Fixed a bug with reg+offset addressing on 32b segments. In 'large'
       mode, the offset is treated as 32-bit unless it's in global,
       read-only or kernarg address space.
     * Fixed a crash caused sometimes by calls with more than 4 arguments.
     * Fixed a mis-execution issue with kernels that have both unexpanded
       ID functions and calls to subfunctions.
     * Treat HSAIL barrier builtins as setjmp/longjump style functions to
       avoid illegal optimizations.
     * Ensure per WI copies of private variables are aligned correctly.
     * libhsail-rt: Assume the host runtime allocates the work group
       memory.

  C family

     * New command-line options have been added for the C and C++
       compilers:
          + [4]-Wmultistatement-macros warns about unsafe macros expanding
            to multiple statements used as a body of a statement such as
            if, else, while, switch, or for.
          + [5]-Wstringop-truncation warns for calls to bounded string
            manipulation functions such as strncat, strncpy, and stpncpy
            that might either truncate the copied string or leave the
            destination unchanged. For example, the following call to
            strncat is diagnosed because it appends just three of the four
            characters from the source string.
void append (char *buf, size_t bufsize)
{
    strncat (buf, ".txt", 3);
}
warning: 'strncat' output truncated copying 3 bytes from a string of length 4 [-
Wstringop-truncation]
            Similarly, in the following example, the call to strncpy
            specifies the size of the destination buffer as the bound. If
            the length of the source string is equal to or greater than
            this size the result of the copy will not be NUL-terminated.
            Therefore, the call is also diagnosed. To avoid the warning,
            specify sizeof buf - 1 as the bound and set the last element
            of the buffer to NUL.
void copy (const char *s)
{
    char buf[80];
    strncpy (buf, s, sizeof buf);
    …
}
warning: 'strncpy' specified bound 80 equals destination size [-Wstringop-trunca
tion]
            The -Wstringop-truncation option is included in -Wall.
            Note that due to GCC bug [6]82944, defining strncat, strncpy,
            or stpncpy as a macro in a system header as some
            implementations do, suppresses the warning.
          + [7]-Wif-not-aligned controls warnings issued in response to
            invalid uses of objects declared with attribute
            [8]warn_if_not_aligned.
            The -Wif-not-aligned option is included in -Wall.
          + [9]-Wmissing-attributes warns when a declaration of a function
            is missing one or more attributes that a related function is
            declared with and whose absence may adversely affect the
            correctness or efficiency of generated code. For example, in
            C++, the warning is issued when an explicit specialization of
            a primary template declared with attribute alloc_align,
            alloc_size, assume_aligned, format, format_arg, malloc, or
            nonnull is declared without it. Attributes deprecated, error,
            and warning suppress the warning.
            The -Wmissing-attributes option is included in -Wall.
          + [10]-Wpacked-not-aligned warns when a struct or union declared
            with attribute packed defines a member with an explicitly
            specified alignment greater than 1. Such a member will wind up
            under-aligned. For example, a warning will be issued for the
            definition of struct A in the following:
struct __attribute__ ((aligned (8)))
S8 { char a[8]; };

struct __attribute__ ((packed)) A
{
    struct S8 s8;
};
warning: alignment 1 of 'struct S' is less than 8 [-Wpacked-not-aligned]
            The -Wpacked-not-aligned option is included in -Wall.
          + -Wcast-function-type warns when a function pointer is cast to
            an incompatible function pointer. This warning is enabled by
            -Wextra.
          + -Wsizeof-pointer-div warns for suspicious divisions of the
            size of a pointer by the size of the elements it points to,
            which looks like the usual way to compute the array size but
            won't work out correctly with pointers. This warning is
            enabled by -Wall.
          + -Wcast-align=strict warns whenever a pointer is cast such that
            the required alignment of the target is increased. For
            example, warn if a char * is cast to an int * regardless of
            the target machine.
          + -fprofile-abs-path creates absolute path names in the .gcno
            files. This allows gcov to find the correct sources in
            projects where compilations occur with different working
            directories.
     * -fno-strict-overflow is now mapped to -fwrapv -fwrapv-pointer and
       signed integer overflow is now undefined by default at all
       optimization levels. Using -fsanitize=signed-integer-overflow is
       now the preferred way to audit code, -Wstrict-overflow is
       deprecated.
     * The [11]-Warray-bounds option has been improved to detect more
       instances of out-of-bounds array indices and pointer offsets. For
       example, negative or excessive indices into flexible array members
       and string literals are detected.
     * The [12]-Wrestrict option introduced in GCC 7 has been enhanced to
       detect many more instances of overlapping accesses to objects via
       restrict-qualified arguments to standard memory and string
       manipulation functions such as memcpy and strcpy. For example, the
       strcpy call in the function below attempts to truncate the string
       by replacing its initial characters with the last four. However,
       because the function writes the terminating NUL into a[4], the
       copies overlap and the call is diagnosed.
void f (void)
{
    char a[] = "abcd1234";
    strcpy (a, a + 4);
    …
}
warning: 'strcpy' accessing 5 bytes at offsets 0 and 4 overlaps 1 byte at offset
 4 [-Wrestrict]
       The -Wrestrict option is included in -Wall.
     * Several optimizer enhancements have enabled improvements to the
       [13]-Wformat-overflow and [14]-Wformat-truncation options. The
       warnings detect more instances of buffer overflow and truncation
       than in GCC 7 and are better at avoiding certain kinds of false
       positives.
     * When reporting mismatching argument types at a function call, the C
       and C++ compilers now underline both the argument and the pertinent
       parameter in the declaration.
$ gcc arg-type-mismatch.cc
arg-type-mismatch.cc: In function 'int caller(int, int, float)':
arg-type-mismatch.cc:5:24: error: invalid conversion from 'int' to 'const char*'
 [-fpermissive]
   return callee(first, second, third);
                        ^~~~~~
arg-type-mismatch.cc:1:40: note:   initializing argument 2 of 'int callee(int, c
onst char*, float)'
 extern int callee(int one, const char *two, float three);
                            ~~~~~~~~~~~~^~~

     * When reporting on unrecognized identifiers, the C and C++ compilers
       will now emit fix-it hints suggesting #include directives for
       various headers in the C and C++ standard libraries.
$ gcc incomplete.c
incomplete.c: In function 'test':
incomplete.c:3:10: error: 'NULL' undeclared (first use in this function)
   return NULL;
          ^~~~
incomplete.c:3:10: note: 'NULL' is defined in header '<stddef.h>'; did you forge
t to '#include <stddef.h>'?
incomplete.c:1:1:
+#include <stddef.h>
 const char *test(void)
incomplete.c:3:10:
   return NULL;
          ^~~~
incomplete.c:3:10: note: each undeclared identifier is reported only once for ea
ch function it appears in

$ gcc incomplete.cc
incomplete.cc:1:6: error: 'string' in namespace 'std' does not name a type
 std::string s("hello world");
      ^~~~~~
incomplete.cc:1:1: note: 'std::string' is defined in header '<string>'; did you
forget to '#include <string>'?
+#include <string>
 std::string s("hello world");
 ^~~

     * The C and C++ compilers now use more intuitive locations when
       reporting on missing semicolons, and offer fix-it hints:
$ gcc t.c
t.c: In function 'test':
t.c:3:12: error: expected ';' before '}' token
   return 42
            ^
            ;
 }
 ~

     * When reporting on missing '}' and ')' tokens, the C and C++
       compilers will now highlight the corresponding '{' and '(' token,
       issuing a 'note' if it's on a separate line:
$ gcc unclosed.c
unclosed.c: In function 'log_when_out_of_range':
unclosed.c:12:50: error: expected ')' before '{' token
       && (temperature < MIN || temperature > MAX) {
                                                  ^~
                                                  )
unclosed.c:11:6: note: to match this '('
   if (logging_enabled && check_range ()
      ^

       or highlighting it directly if it's on the same line:
$ gcc unclosed-2.c
unclosed-2.c: In function 'test':
unclosed-2.c:8:45: error: expected ')' before '{' token
   if (temperature < MIN || temperature > MAX {
      ~                                      ^~
                                             )

       They will also emit fix-it hints.

  C++

     * GCC 8 (-fabi-version=12) has a couple of corrections to the calling
       convention, which changes the ABI for some uncommon code:
          + Passing an empty class as an argument now takes up no space on
            x86_64, as required by the psABI.
          + Passing or returning a class with only deleted copy and move
            constructors now uses the same calling convention as a class
            with a non-trivial copy or move constructor. This only affects
            C++17 mode, as in earlier standards passing or returning such
            a class was impossible.
          + WARNING: In GCC 8.1 the second change mistakenly also affects
            classes with a deleted copy constructor and defaulted trivial
            move constructor (bug [15]c++/86094). This issue is fixed in
            GCC 8.2 (-fabi-version=13).
       You can test whether these changes affect your code with -Wabi=11
       (or -Wabi=12 in GCC 8.2 for the third issue); if these changes are
       problematic for your project, the GCC 7 ABI can be selected with
       -fabi-version=11.
     * The value of the C++11 alignof operator has been corrected to match
       C _Alignof (minimum alignment) rather than GNU __alignof__
       (preferred alignment); on ia32 targets this means that
       alignof(double) is now 4 rather than 8. Code that wants the
       preferred alignment should use __alignof__ instead.
     * New command-line options have been added for the C++ compiler to
       control warnings:
          + [16]-Wclass-memaccess warns when objects of non-trivial class
            types are manipulated in potentially unsafe ways by raw memory
            functions such as memcpy, or realloc. The warning helps detect
            calls that bypass user-defined constructors or copy-assignment
            operators, corrupt virtual table pointers, data members of
            const-qualified types or references, or member pointers. The
            warning also detects calls that would bypass access controls
            to data members. For example, a call such as:
        memcpy (&std::cout, &std::cerr, sizeof std::cout);
            results in
        warning: 'void* memcpy(void*, const void*, long unsigned int)' writing t
o an object of type 'std::ostream' {aka 'class std::basic_ostream<char>'} with n
o trivial copy-assignment [-Wclass-memaccess]
            The -Wclass-memaccess option is included in -Wall.
     * The C++ front end has experimental support for some of the upcoming
       C++2a draft features with the -std=c++2a or -std=gnu++2a flags,
       including designated initializers, default member initializers for
       bit-fields, __VA_OPT__ (except that #__VA_OPT__ is unsupported),
       lambda [=, this] captures, etc. For a full list of new features,
       see [17]the C++ status page.
     * When reporting on attempts to access private fields of a class or
       struct, the C++ compiler will now offer fix-it hints showing how to
       use an accessor function to get at the field in question, if one
       exists.
$ gcc accessor.cc
accessor.cc: In function 'void test(foo*)':
accessor.cc:12:12: error: 'double foo::m_ratio' is private within this context
   if (ptr->m_ratio >= 0.5)
            ^~~~~~~
accessor.cc:7:10: note: declared private here
   double m_ratio;
          ^~~~~~~
accessor.cc:12:12: note: field 'double foo::m_ratio' can be accessed via 'double
 foo::get_ratio() const'
   if (ptr->m_ratio >= 0.5)
            ^~~~~~~
            get_ratio()

     * The C++ compiler can now give you a hint if you use a macro before
       it was defined (e.g. if you mess up the order of your #include
       directives):
$ gcc ordering.cc
ordering.cc:2:24: error: expected ';' at end of member declaration
   virtual void clone() const OVERRIDE { }
                        ^~~~~
                             ;
ordering.cc:2:30: error: 'OVERRIDE' does not name a type
   virtual void clone() const OVERRIDE { }
                              ^~~~~~~~
ordering.cc:2:30: note: the macro 'OVERRIDE' had not yet been defined
In file included from ordering.cc:5:
c++11-compat.h:2: note: it was later defined here
 #define OVERRIDE override


     * The -Wold-style-cast diagnostic can now emit fix-it hints telling
       you when you can use a static_cast, const_cast, or
       reinterpret_cast.
$ gcc -c old-style-cast-fixits.cc -Wold-style-cast
old-style-cast-fixits.cc: In function 'void test(void*)':
old-style-cast-fixits.cc:5:19: warning: use of old-style cast to 'struct foo*' [
-Wold-style-cast]
   foo *f = (foo *)ptr;
                   ^~~
            ----------
            static_cast<foo *> (ptr)

     * When reporting on problems within extern "C" linkage
       specifications, the C++ compiler will now display the location of
       the start of the extern "C".
$ gcc -c extern-c.cc
extern-c.cc:3:1: error: template with C linkage
 template <typename T> void test (void);
 ^~~~~~~~
In file included from extern-c.cc:1:
unclosed.h:1:1: note: 'extern "C"' linkage started here
 extern "C" {
 ^~~~~~~~~~
extern-c.cc:3:39: error: expected '}' at end of input
 template <typename T> void test (void);
                                       ^
In file included from extern-c.cc:1:
unclosed.h:1:12: note: to match this '{'
 extern "C" {
            ^

     * When reporting on mismatching template types, the C++ compiler will
       now use color to highlight the mismatching parts of the template,
       and will elide the parameters that are common between two
       mismatching templates, printing [...] instead:
$ gcc templates.cc
templates.cc: In function 'void test()':
templates.cc:9:8: error: could not convert 'vector<double>()' from 'vector<doubl
e>' to 'vector<int>'
   fn_1(vector<double> ());
        ^~~~~~~~~~~~~~~~~
templates.cc:10:8: error: could not convert 'map<int, double>()' from 'map<[...]
,double>' to 'map<[...],int>'
   fn_2(map<int, double>());
        ^~~~~~~~~~~~~~~~~~

       Those [...] elided parameters can be seen using -fno-elide-type:
$ gcc templates.cc -fno-elide-type
templates.cc: In function 'void test()':
templates.cc:9:8: error: could not convert 'vector<double>()' from 'vector<doubl
e>' to 'vector<int>'
   fn_1(vector<double> ());
        ^~~~~~~~~~~~~~~~~
templates.cc:10:8: error: could not convert 'map<int, double>()' from 'map<int,d
ouble>' to 'map<int,int>'
   fn_2(map<int, double>());
        ^~~~~~~~~~~~~~~~~~

       The C++ compiler has also gained an option
       -fdiagnostics-show-template-tree which visualizes such mismatching
       templates in a hierarchical form:
$ gcc templates-2.cc -fdiagnostics-show-template-tree
templates-2.cc: In function 'void test()':
templates-2.cc:9:8: error: could not convert 'vector<double>()' from 'vector<dou
ble>' to 'vector<int>'
  vector<
    [double != int]>
   fn_1(vector<double> ());
        ^~~~~~~~~~~~~~~~~
templates-2.cc:10:8: error: could not convert 'map<map<int, vector<double> >, ve
ctor<double> >()' from 'map<map<[...],vector<double>>,vector<double>>' to 'map<m
ap<[...],vector<float>>,vector<float>>'
  map<
    map<
      [...],
      vector<
        [double != float]>>,
    vector<
      [double != float]>>
   fn_2(map<map<int, vector<double>>, vector<double>> ());
        ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

       which again works with -fno-elide-type:
$ gcc templates-2.cc -fdiagnostics-show-template-tree -fno-elide-type
templates-2.cc: In function 'void test()':
templates-2.cc:9:8: error: could not convert 'vector<double>()' from 'vector<dou
ble>' to 'vector<int>'
  vector<
    [double != int]>
   fn_1(vector<double> ());
        ^~~~~~~~~~~~~~~~~
templates-2.cc:10:8: error: could not convert 'map<map<int, vector<double> >, ve
ctor<double> >()' from 'map<map<int,vector<double>>,vector<double>>' to 'map<map
<int,vector<float>>,vector<float>>'
  map<
    map<
      int,
      vector<
        [double != float]>>,
    vector<
      [double != float]>>
   fn_2(map<map<int, vector<double>>, vector<double>> ());
        ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

     * Flowing off the end of a non-void function is considered
       unreachable and may be subject to optimization on that basis. As a
       result of this change, -Wreturn-type warnings are enabled by
       default for C++.

    Runtime Library (libstdc++)

     * Improved experimental support for C++17, including the following
       features:
          + Deduction guides to support class template argument deduction.
          + std::filesystem implementation.
          + std::char_traits<char> and std::char_traits<wchar_t> are
            usable in constant expressions.
          + std::to_chars and std::from_chars (for integers only, not for
            floating point types).
     * Experimental support for C++2a: std::to_address (thanks to Glen
       Fernandes) and std::endian.
     * On GNU/Linux, std::random_device::entropy() accesses the kernel's
       entropy count for the random device, if known (thanks to Xi
       Ruoyao).
     * Support for std::experimental::source_location.
     * AddressSanitizer integration for std::vector, detecting
       out-of-range accesses to the unused capacity of a vector.
     * Extensions __gnu_cxx::airy_ai and __gnu_cxx::airy_bi added to the
       Mathematical Special Functions.

  Fortran

     * The main version of libfortran has been changed to 5.
     * Parameterized derived types, a major feature of Fortran 2003, have
       been implemented.
     * Partial support is provided for Fortran 2018 teams, which are
       hierarchical subsets of images that execute independently of other
       image subsets.
     * The maximum rank for arrays has been increased to 15, conforming to
       the Fortran 2008 standard.
     * Transformational intrinsics are now fully supported in
       initialization expressions.
     * New flag -fc-prototypes to write C prototypes for BIND(C)
       procedures and variables.
     * If -fmax-stack-var-size is honored if given together with -Ofast,
       -fstack-arrays is no longer set in that case.
     * New options -fdefault-real-16 and -fdefault-real-10 to control the
       default kind of REAL variables.
     * A warning is now issued if an array subscript inside a DO loop
       could lead to an out-of-bounds-access. The new option
       -Wdo-subscript, enabled by -Wextra, warns about this even if the
       compiler can not prove that the code will be executed.
     * The Fortran front end now attempts to interchange loops if it is
       deemed profitable. So far, this is restricted to FORALL and DO
       CONCURRENT statements with multiple indices. This behavior be
       controlled with the new flag -ffrontend-loop-interchange, which is
       enabled with optimization by default. The
       -Wfrontend-loop-interchange option warns about such occurrences.
     * When an actual argument contains too few elements for a dummy
       argument, an error is now issued. The -std=legacy option can be
       used to still compile such code.
     * The RECL= argument to OPEN and INQUIRE statements now allows 64-bit
       integers, making records larger than 2GiB possible.
     * The GFORTRAN_DEFAULT_RECL environment variable no longer has any
       effect. The record length for preconnected units is now larger than
       any practical limit, same as for sequential access units opened
       without an explicit RECL= specifier.
     * Character variables longer than HUGE(0) elements are now possible
       on 64-bit targets. Note that this changes the procedure call ABI
       for all procedures with character arguments on 64-bit targets, as
       the type of the hidden character length argument has changed. The
       hidden character length argument is now of type INTEGER(C_SIZE_T).
     * Partial support is provided for Fortran 2018 teams, which are
       hierarchical subsets of images that execute independently of other
       image subsets.

  Go

     * GCC 8 provides a complete implementation of the Go 1.10.1 user
       packages.
     * The garbage collector is now fully concurrent. As before, values
       stored on the stack are scanned conservatively, but value stored in
       the heap are scanned precisely.
     * Escape analysis is fully implemented and enabled by default in the
       Go front end. This significantly reduces the number of heap
       allocations by allocating values on the stack instead.

libgccjit

   The libgccjit API gained four new entry points:
     * [18]gcc_jit_type_get_vector and
     * [19]gcc_jit_context_new_rvalue_from_vector for working with
       vectors,
     * [20]gcc_jit_type_get_aligned
     * [21]gcc_jit_function_get_address

   The C code generated by [22]gcc_jit_context_dump_reproducer_to_file is
   now easier-to-read.

New Targets and Target Specific Improvements

  AArch64

     * The Armv8.4-A architecture is now supported. It can be used by
       specifying the -march=armv8.4-a option.
     * The Dot Product instructions are now supported as an optional
       extension to the Armv8.2-A architecture and newer and are mandatory
       on Armv8.4-A. The extension can be used by specifying the +dotprod
       architecture extension. E.g. -march=armv8.2-a+dotprod.
     * The Armv8-A +crypto extension has now been split into two
       extensions for finer grained control:
          + +aes which contains the Armv8-A AES crytographic instructions.
          + +sha2 which contains the Armv8-A SHA2 and SHA1 cryptographic
            instructions.
       Using +crypto will now enable these two extensions.
     * New Armv8.4-A FP16 Floating Point Multiplication Variant
       instructions have been added. These instructions are mandatory in
       Armv8.4-A but available as an optional extension to Armv8.2-A and
       Armv8.3-A. The new extension can be used by specifying the +fp16fml
       architectural extension on Armv8.2-A and Armv8.3-A. On Armv8.4-A
       the instructions can be enabled by specifying +fp16.
     * New cryptographic instructions have been added as optional
       extensions to Armv8.2-A and newer. These instructions can be
       enabled with:
          + +sha3 New SHA3 and SHA2 instructions from Armv8.4-A. This
            implies +sha2.
          + +sm4 New SM3 and SM4 instructions from Armv8.4-A.
     * The Scalable Vector Extension (SVE) is now supported as an optional
       extension to the Armv8.2-A architecture and newer. This support
       includes automatic vectorization with SVE instructions, but it does
       not yet include the SVE Arm C Language Extensions (ACLE). It can be
       enabled by specifying the +sve architecture extension (for example,
       -march=armv8.2-a+sve). By default, the generated code works with
       all vector lengths, but it can be made specific to N-bit vectors
       using -msve-vector-bits=N.
     * Support has been added for the following processors (GCC
       identifiers in parentheses):
          + Arm Cortex-A75 (cortex-a75).
          + Arm Cortex-A55 (cortex-a55).
          + Arm Cortex-A55/Cortex-A75 DynamIQ big.LITTLE
            (cortex-a75.cortex-a55).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a75 or -mtune=cortex-a75 or as
       arguments to the equivalent target attributes and pragmas.

  ARC

     * Added support for:
          + Fast interrupts.
          + Naked functions.
          + aux variable attributes.
          + uncached type qualifier.
          + Secure functions via sjli instruction.
     * New exception handling implementation.
     * Revamped trampoline implementation.
     * Refactored small data feature implementation, controlled via -G
       command line option.
     * New support for reduced register set ARC architecture
       configurations, controlled via -mrf16 command line option.
     * Refurbished and improved support for zero overhead loops.
       Introduced -mlpc-width command line option to control the width of
       lp_count register.

  ARM

     * The -mfpu option now takes a new option setting of -mfpu=auto. When
       set to this the floating-point and SIMD settings are derived from
       the settings of the -mcpu or -march options. The internal CPU
       configurations have been updated with information about the
       permitted floating-point configurations supported. See the user
       guide for further information about the extended option syntax for
       controlling architectural extensions via the -march option.
       -mfpu=auto is now the default setting unless the compiler has been
       configured with an explicit --with-fpu option.
     * The -march and -mcpu options now accept optional extensions to the
       architecture or CPU option, allowing the user to enable or disable
       any such extensions supported by that architecture or CPU such as
       (but not limited to) floating-point and AdvancedSIMD. For example:
       the option -mcpu=cortex-a53+nofp will generate code for the
       Cortex-A53 processor with no floating-point support. This, in
       combination with the new -mfpu=auto option, provides a
       straightforward way of specifying a valid build target through a
       single -mcpu or -march option. The -mtune option accepts the same
       arguments as -mcpu but only the CPU name has an effect on tuning.
       The architecture extensions do not have any effect. For details of
       what extensions a particular architecture or CPU option supports
       please refer to the [23]documentation.
     * The -mstructure-size-boundary option has been deprecated and will
       be removed in a future release.
     * The default link behavior for Armv6 and Armv7-R targets has been
       changed to produce BE8 format when generating big-endian images. A
       new flag -mbe32 can be used to force the linker to produce legacy
       BE32 format images. There is no change of behavior for Armv6-M and
       other Armv7 or later targets: these already defaulted to BE8
       format. This change brings GCC into alignment with other compilers
       for the ARM architecture.
     * The Armv8-R architecture is now supported. It can be used by
       specifying the -march=armv8-r option.
     * The Armv8.3-A architecture is now supported. It can be used by
       specifying the -march=armv8.3-a option.
     * The Armv8.4-A architecture is now supported. It can be used by
       specifying the -march=armv8.4-a option.
     * The Dot Product instructions are now supported as an optional
       extension to the Armv8.2-A architecture and newer and are mandatory
       on Armv8.4-A. The extension can be used by specifying the +dotprod
       architecture extension. E.g. -march=armv8.2-a+dotprod.
     * Support for setting extensions and architectures using the GCC
       target pragma and attribute has been added. It can be used by
       specifying #pragma GCC target ("arch=..."), #pragma GCC target
       ("+extension"), __attribute__((target("arch=..."))) or
       __attribute__((target("+extension"))).
     * New Armv8.4-A FP16 Floating Point Multiplication Variant
       instructions have been added. These instructions are mandatory in
       Armv8.4-A but available as an optional extension to Armv8.2-A and
       Armv8.3-A. The new extension can be used by specifying the +fp16fml
       architectural extension on Armv8.2-A and Armv8.3-A. On Armv8.4-A
       the instructions can be enabled by specifying +fp16.
     * Support has been added for the following processors (GCC
       identifiers in parentheses):
          + Arm Cortex-A75 (cortex-a75).
          + Arm Cortex-A55 (cortex-a55).
          + Arm Cortex-A55/Cortex-A75 DynamIQ big.LITTLE
            (cortex-a75.cortex-a55).
          + Arm Cortex-R52 for Armv8-R (cortex-r52).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a75 or -mtune=cortex-r52 or as
       arguments to the equivalent target attributes and pragmas.

  AVR

     * The AVR port now supports the following XMEGA-like devices:

     ATtiny212, ATtiny214, ATtiny412, ATtiny414, ATtiny416, ATtiny417,
     ATtiny814, ATtiny816, ATtiny817, ATtiny1614, ATtiny1616, ATtiny1617,
     ATtiny3214, ATtiny3216, ATtiny3217
       The new devices are listed under [24]-mmcu=avrxmega3.
          + These devices see flash memory in the RAM address space, so
            that features like PROGMEM and __flash are not needed any more
            (as opposed to other AVR families for which read-only data
            will be located in RAM except special, non-standard features
            are used to locate and access such data). This requires that
            the compiler is used with Binutils 2.29 or newer so that
            [25]read-only data will be located in flash memory.
          + A new command-line option -mshort-calls is supported. This
            option is used internally for multilib selection of the
            avrxmega3 variants. It is not an optimization option. Do not
            set it by hand.
     * The compiler now generates [26]efficient interrupt service routine
       (ISR) prologues and epilogues. This is achieved by using the new
       [27]AVR pseudo instruction __gcc_isr which is supported and
       resolved by the GNU assembler.
          + As the __gcc_isr pseudo-instruction will be resolved by the
            assembler, inline assembly is transparent to the process. This
            means that when inline assembly uses an instruction like INC
            that clobbers the condition code, then the assembler will
            detect this and generate an appropriate ISR prologue /
            epilogue chunk to save / restore SREG as needed.
          + A new command-line option -mno-gas-isr-prologues disables the
            generation of the __gcc_isr pseudo instruction. Any non-naked
            ISR will save and restore SREG, tmp_reg and zero_reg, no
            matter whether the respective register is clobbered or used.
          + The feature is turned on per default for all optimization
            levels except for -O0 and -Og. It is explicitly enabled by
            means of option -mgas-isr-prologues.
          + Support has been added for a new [28]AVR function attribute
            no_gccisr. It can be used to disable __gcc_isr pseudo
            instruction generation for individual ISRs.
          + This optimization is only available if GCC is configured with
            GNU Binutils 2.29 or newer; or at least with a version of
            Binutils that implements feature [29]PR21683.
     * The compiler no more saves / restores registers in main; the effect
       is the same as if attribute OS_task was specified for main. This
       optimization can be switched off by the new command-line option
       -mno-main-is-OS_task.

  IA-32/x86-64

     * The x86 port now supports the naked function attribute.
     * Better tuning for znver1 and Intel Core based CPUs.
     * Vectorization cost metrics has been reworked leading to significant
       improvements on some benchmarks.
     * GCC now supports the Intel CPU named Cannonlake through
       -march=cannonlake. The switch enables the AVX512VBMI, AVX512IFMA
       and SHA ISA extensions.
     * GCC now supports the Intel CPU named Icelake through
       -march=icelake. The switch enables the AVX512VNNI, GFNI, VAES,
       AVX512VBMI2, VPCLMULQDQ, AVX512BITALG, RDPID and AVX512VPOPCNTDQ
       ISA extensions.
     * GCC now supports the Intel Control-flow Enforcement Technology
       (CET) extension through -fcf-protection option.

  NDS32

     * New command-line options -mext-perf, -mext-perf2, and -mext-string
       have been added for performance extension instructions.

  Nios II

     * The Nios II back end has been improved to generate better-optimized
       code. Changes include switching to LRA, more accurate cost models,
       and more compact code for addressing static variables.
     * New command-line options -mgprel-sec= and -mr0rel-sec= have been
       added.
     * The stack-smashing protection options are now enabled on Nios II.

  PA-RISC

     * The default call ABI on 32-bit linux has been changed from callee
       copies to caller copies. This affects objects larger than eight
       bytes passed by value. The goal is to improve compatibility with
       x86 and resolve issues with OpenMP.
     * Other PA-RISC targets are unchanged.

  PowerPC / PowerPC64 / RS6000

     * The PowerPC SPE support is split off to a separate powerpcspe port.
       The separate port is deprecated and might be removed in a future
       release.
     * The Paired Single support (as used on some PPC750 CPUs, -mpaired,
       powerpc*-*-linux*paired*) is deprecated and will be removed in a
       future release.
     * The Xilinx floating point support (-mxilinx-fpu,
       powerpc-xilinx-eabi*) is deprecated and will be removed in a future
       release.
     * Support for using big-endian AltiVec intrinsics on a little-endian
       target (-maltivec=be) is deprecated and will be removed in a future
       release.

  Tile

     * The TILE-Gx port is deprecated and will be removed in a future
       release.

Operating Systems

  Windows

     * GCC on Microsoft Windows can now be configured via
       --enable-mingw-wildcard or --disable-mingw-wildcard to force a
       specific behavior for GCC itself with regards to supporting the
       wildcard character. Prior versions of GCC would follow the
       configuration of the MinGW runtime. This behavior can still be
       obtained by not using the above options or by using
       --enable-mingw-wildcard=platform.

Improvements for plugin authors

     * Plugins can now register a callback hook for when comments are
       encountered by the C and C++ compilers, e.g. allowing for plugins
       to handle documentation markup in code comments.
     * The gdbinit support script for debugging GCC now has a
       break-on-diagnostic command, providing an easy way to trigger a
       breakpoint whenever a diagnostic is emitted.
     * The API for creating fix-it hints now supports newlines, and for
       emitting mutually incompatible fix-it hints for one diagnostic.

GCC 8.1

   This is the [30]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 8.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 8.2

   This is the [31]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 8.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  General Improvements

     * Fixed LTO link-time performance problems caused by an overflow in
       the partitioning algorithm while building large binaries.

  Language Specific Changes

    C++

   GCC 8.2 fixed a bug introduced in GCC 8.1 affecting passing or
   returning of classes with a deleted copy constructor and defaulted
   trivial move constructor (bug [32]c++/86094). GCC 8.2 introduces
   -fabi-version=13 and makes it the default, ABI incompatibilities
   between GCC 8.1 and 8.2 can be reported with -Wabi=12. See [33]C++
   changes for more details.

  Target Specific Changes

    IA-32/x86-64

     * -mtune=native performance regression [34]PR84413 on Intel Skylake
       processors has been fixed.

GCC 8.3

   This is the [35]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 8.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Windows

     * A C++ Microsoft ABI bitfield layout bug, [36]PR87137 has been
       fixed. A non-field declaration could cause the current bitfield
       allocation unit to be completed, incorrectly placing a following
       bitfield into a new allocation unit. The Microsoft ABI is selected
       for:
          + Mingw targets
          + PowerPC, IA-32 or x86-64 targets when the -mms-bitfields
            option is specified, or __attribute__((ms_struct)) is used
          + SuperH targets when the -mhitachi option is specified, or
            __attribute__((renesas)) is used
       GCC 8 introduced additional cases of this defect, but rather than
       resolve only those regressions, we decided to resolve all the cases
       of this defect in single change.

GCC 8.4

   This is the [37]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 8.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 8.5

   This is the [38]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 8.5 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    AArch64

     * The option -moutline-atomics has been added to aid deployment of
       the Large System Extensions (LSE) on GNU/Linux systems built with a
       baseline architecture targeting Armv8-A. When the option is
       specified code is emitted to detect the presence of LSE
       instructions at run time and use them for standard atomic
       operations. For more information please refer to the documentation.


    For questions related to the use of GCC, please consult these web
    pages and the [39]GCC manuals. If that fails, the
    [40]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [41]gcc@gcc.gnu.org. All of [42]our lists have public
    archives.

   Copyright (C) [43]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [44]maintained by the GCC team. Last modified
   2021-10-01[45].

References

   1. http://gcc.gnu.org/gcc-8/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/ml/gcc/2018-04/msg00102.html
   4. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wmultistatement-macros
   5. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wstringop-truncation
   6. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=82944
   7. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wif-not-aligned
   8. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Common-Variable-Attributes.html#index-warn_005fif_005fnot_005faligned-variable-attribute
   9. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wmissing-attributes
  10. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wpacked-not-aligned
  11. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Warray-bounds
  12. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wrestrict
  13. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wformat-overflow
  14. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/Warning-Options.html#index-Wformat-truncation
  15. https://gcc.gnu.org/PR86094
  16. https://gcc.gnu.org/onlinedocs/gcc/C_002b_002b-Dialect-Options.html#index-Wclass-memaccess
  17. http://gcc.gnu.org/projects/cxx-status.html#cxx2a
  18. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/jit/topics/types.html#gcc_jit_type_get_vector
  19. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/jit/topics/expressions.html#gcc_jit_context_new_rvalue_from_vector
  20. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/jit/topics/types.html#gcc_jit_type_get_aligned
  21. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/jit/topics/function-pointers.html#gcc_jit_function_get_address
  22. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/jit/topics/contexts.html#gcc_jit_context_dump_reproducer_to_file
  23. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/ARM-Options.html#ARM-Options
  24. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/AVR-Options.html
  25. https://sourceware.org/PR21472
  26. https://gcc.gnu.org/PR20296
  27. https://sourceware.org/binutils/docs-2.29/as/AVR-Pseudo-Instructions.html
  28. https://gcc.gnu.org/onlinedocs/gcc-8.1.0/gcc/AVR-Function-Attributes.html
  29. https://sourceware.org/PR21683
  30. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=8.0
  31. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=8.2
  32. https://gcc.gnu.org/PR86094
  33. http://gcc.gnu.org/gcc-8/changes.html#cxx
  34. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=84413
  35. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=8.3
  36. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=87137
  37. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=8.4
  38. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=8.5
  39. https://gcc.gnu.org/onlinedocs/
  40. mailto:gcc-help@gcc.gnu.org
  41. mailto:gcc@gcc.gnu.org
  42. https://gcc.gnu.org/lists.html
  43. https://www.fsf.org/
  44. https://gcc.gnu.org/about.html
  45. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-7/index.html
                              GCC 7 Release Series

   Nov 14, 2019

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 7.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 7.4 relative to previous releases of GCC.

Release History

   GCC 7.5
          Nov 14, 2019 ([2]changes, [3]documentation)

   GCC 7.4
          Dec 6, 2018 ([4]changes, [5]documentation)

   GCC 7.3
          Jan 25, 2018 ([6]changes, [7]documentation)

   GCC 7.2
          Aug 14, 2017 ([8]changes, [9]documentation)

   GCC 7.1
          May 2, 2017 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2021-07-28[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-7/changes.html
   3. http://gcc.gnu.org/onlinedocs/7.5.0/
   4. http://gcc.gnu.org/gcc-7/changes.html
   5. http://gcc.gnu.org/onlinedocs/7.4.0/
   6. http://gcc.gnu.org/gcc-7/changes.html
   7. http://gcc.gnu.org/onlinedocs/7.3.0/
   8. http://gcc.gnu.org/gcc-7/changes.html
   9. http://gcc.gnu.org/onlinedocs/7.2.0/
  10. http://gcc.gnu.org/gcc-7/changes.html
  11. http://gcc.gnu.org/onlinedocs/7.1.0/
  12. http://gcc.gnu.org/gcc-7/buildstat.html
  13. http://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/git.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. https://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-7/changes.html
                              GCC 7 Release Series
                        Changes, New Features, and Fixes

   This page is a brief summary of some of the huge number of improvements
   in GCC 7. For more information, see the [1]Porting to GCC 7 page and
   the [2]full GCC documentation.

Caveats

     * GCC now uses [3]LRA (a new local register allocator) by default for
       new targets.
     * The non-standard C++0x type traits has_trivial_default_constructor,
       has_trivial_copy_constructor and has_trivial_copy_assign have been
       removed.
     * The libstdc++ [4]Profile Mode has been deprecated and will be
       removed in a future version.
     * The Cilk+ extensions to the C and C++ languages have been
       deprecated.
     * On ARM targets (arm*-*-*), [5]a bug introduced in GCC 5 that
       affects conformance to the procedure call standard (AAPCS) has been
       fixed. The bug affects some C++ code where class objects are passed
       by value to functions and could result in incorrect or inconsistent
       code being generated. This is an ABI change. If the option -Wpsabi
       is enabled (on by default) the compiler will emit a diagnostic note
       for code that might be affected.

General Optimizer Improvements

     * GCC 7 can determine the return value or range of return values of
       some calls to the sprintf family of functions and make it available
       to other optimization passes. Some calls to the snprintf function
       with a zero size argument can be folded into constants. This
       optimization is included in -O1 and can be selectively controlled
       by the -fprintf-return-value option.
     * A new store merging pass has been added. It merges constant stores
       to adjacent memory locations into fewer, wider, stores. It is
       enabled by the -fstore-merging option and at the -O2 optimization
       level or higher (and -Os).
     * A new code hoisting optimization has been added to the partial
       redundancy elimination pass. It attempts to move evaluation of
       expressions executed on all paths to the function exit as early as
       possible. This primarily helps improve code size, but can improve
       the speed of the generated code as well. It is enabled by the
       -fcode-hoisting option and at the -O2 optimization level or higher
       (and -Os).
     * A new interprocedural bitwise constant propagation optimization has
       been added, which propagates knowledge about which bits of
       variables are known to be zero (including pointer alignment
       information) across the call graph. It is enabled by the
       -fipa-bit-cp option if -fipa-cp is enabled as well, and is enabled
       at the -O2 optimization level and higher (and -Os). This
       optimization supersedes interprocedural alignment propagation of
       GCC 6, and therefore the option -fipa-cp-alignment is now
       deprecated and ignored.
     * A new interprocedural value range propagation optimization has been
       added, which propagates integral range information across the call
       graph when variable values can be proven to be within those ranges.
       It is enabled by the -fipa-vrp option and at the -O2 optimization
       level and higher (and -Os).
     * A new loop splitting optimization pass has been added. Certain
       loops which contain a condition that is always true on one side of
       the iteration space and always false on the other are split into
       two loops, such that each of the two new loops iterates on just one
       side of the iteration space and the condition does not need to be
       checked inside of the loop. It is enabled by the -fsplit-loops
       option and at the -O3 optimization level or higher.
     * The shrink-wrapping optimization can now separate portions of
       prologues and epilogues to improve performance if some of the work
       done traditionally by prologues and epilogues is not needed on
       certain paths. This is controlled by the -fshrink-wrap-separate
       option, enabled by default. It requires target support, which is
       currently only implemented in the PowerPC and AArch64 ports.
     * AddressSanitizer gained a new sanitization option,
       -fsanitize-address-use-after-scope, which enables sanitization of
       variables whose address is taken and used after a scope where the
       variable is defined:

int
main (int argc, char **argv)
{
  char *ptr;
    {
      char my_char;
      ptr = &my_char;
    }

  *ptr = 123;
  return *ptr;
}

==28882==ERROR: AddressSanitizer: stack-use-after-scope on address 0x7fffb8dba99
0 at pc 0x0000004006d5 bp 0x7fffb8dba960 sp 0x7fffb8dba958
WRITE of size 1 at 0x7fffb8dba990 thread T0
    #0 0x4006d4 in main /tmp/use-after-scope-1.c:10
    #1 0x7f9c71943290 in __libc_start_main (/lib64/libc.so.6+0x20290)
    #2 0x400739 in _start (/tmp/a.out+0x400739)

Address 0x7fffb8dba990 is located in stack of thread T0 at offset 32 in frame
    #0 0x40067f in main /tmp/use-after-scope-1.c:3

  This frame has 1 object(s):
    [32, 33) 'my_char' <== Memory access at offset 32 is inside this variable

       The option is enabled by default with -fsanitize=address and
       disabled by default with -fsanitize=kernel-address. Compared to the
       LLVM compiler, where the option already exists, the implementation
       in the GCC compiler has some improvements and advantages:
          + Complex uses of gotos and case labels are properly handled and
            should not report any false positive or false negatives.
          + C++ temporaries are sanitized.
          + Sanitization can handle invalid memory stores that are
            optimized out by the LLVM compiler when optimization is
            enabled.
     * The -fsanitize=signed-integer-overflow suboption of the
       UndefinedBehavior Sanitizer now diagnoses arithmetic overflows even
       on arithmetic operations with generic vectors.
     * Version 5 of the DWARF debugging information standard is supported
       through the -gdwarf-5 option. The DWARF version 4 debugging
       information remains the default until consumers of debugging
       information are adjusted.

New Languages and Language specific improvements

   OpenACC support in C, C++, and Fortran continues to be maintained and
   improved. See the [6]OpenACC and [7]Offloading wiki pages for further
   information.

  Ada

     * On mainstream native platforms, Ada programs no longer require the
       stack to be made executable in order to run properly.

  BRIG (HSAIL)

   Support for processing BRIG 1.0 files was added in this release. BRIG
   is a binary format for HSAIL (Heterogeneous System Architecture
   Intermediate Language). The BRIG front end can be used for implementing
   HSAIL "finalizers" (compilation of HSAIL to a native ISA) for
   GCC-supported targets. An implementation of an HSAIL runtime library,
   libhsail-rt is also included.

  C family

     * New command-line options have been added for the C and C++
       compilers:
          + -Wimplicit-fallthrough warns when a switch case falls through.
            This warning has five different levels. The compiler is able
            to parse a wide range of fallthrough comments, depending on
            the level. It also handles control-flow statements, such as
            ifs. It's possible to suppress the warning by either adding a
            fallthrough comment, or by using a null statement:
            __attribute__ ((fallthrough)); (C, C++), or [[fallthrough]];
            (C++17), or [[gnu::fallthrough]]; (C++11/C++14). This warning
            is enabled by -Wextra.
          + -Wpointer-compare warns when a pointer is compared with a zero
            character constant. Such code is now invalid in C++11 and GCC
            rejects it. This warning is enabled by default.
          + -Wduplicated-branches warns when an if-else has identical
            branches.
          + -Wrestrict warns when an argument passed to a
            restrict-qualified parameter aliases with another argument.
          + -Wmemset-elt-size warns for memset calls, when the first
            argument references an array, and the third argument is a
            number equal to the number of elements of the array, but not
            the size of the array. This warning is enabled by -Wall.
          + -Wint-in-bool-context warns about suspicious uses of integer
            values where boolean values are expected. This warning is
            enabled by -Wall.
          + -Wswitch-unreachable warns when a switch statement has
            statements between the controlling expression and the first
            case label which will never be executed. This warning is
            enabled by default.
          + -Wexpansion-to-defined warns when defined is used outside #if.
            This warning is enabled by -Wextra or -Wpedantic.
          + -Wregister warns about uses of the register storage specifier.
            In C++17 this keyword has been removed and for C++17 this is a
            pedantic warning enabled by default. The warning is not
            emitted for the GNU Explicit Register Variables extension.
          + -Wvla-larger-than=N warns about unbounded uses of
            variable-length arrays, and about bounded uses of
            variable-length arrays whose bound can be larger than N bytes.
          + -Wduplicate-decl-specifier warns when a declaration has
            duplicate const, volatile, restrict or _Atomic specifier. This
            warning is enabled by -Wall.
     * GCC 6's C and C++ front ends were able to offer suggestions for
       misspelled field names:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~

       GCC 7 greatly expands the scope of these suggestions. Firstly, it
       adds fix-it hints to such suggestions:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~
               color

       The suggestions now cover many other things, such as misspelled
       function names:

spellcheck-identifiers.c:11:3: warning: implicit declaration of function 'gtk_wi
dget_showall'; did you mean 'gtk_widget_show_all'? [-Wimplicit-function-declarat
ion]
   gtk_widget_showall (w);
   ^~~~~~~~~~~~~~~~~~
   gtk_widget_show_all

       misspelled macro names and enum values:

spellcheck-identifiers.cc:85:11: error: 'MAX_ITEM' undeclared here (not in a fun
ction); did you mean 'MAX_ITEMS'?
 int array[MAX_ITEM];
           ^~~~~~~~
           MAX_ITEMS

       misspelled type names:

spellcheck-typenames.c:7:14: error: unknown type name 'singed'; did you mean 'si
gned'?
 void test (singed char e);
            ^~~~~~
            signed

       and, in the C front end, named initializers:

test.c:7:20: error: 'struct s' has no member named 'colour'; did you mean 'color
'?
 struct s test = { .colour = 3 };
                    ^~~~~~
                    color

     * The preprocessor can now offer suggestions for misspelled
       directives, e.g.:

test.c:5:2: error:invalid preprocessing directive #endfi; did you mean #endif?
 #endfi
  ^~~~~
  endif

     * Warnings about format strings now underline the pertinent part of
       the string, and can offer suggested fixes. In some cases, the
       pertinent argument is underlined.

test.c:51:29: warning: format '%s' expects argument of type 'char *', but argume
nt 3 has type 'int' [-Wformat=]
   printf ("foo: %d  bar: %s baz: %d", 100, i + j, 102);
                          ~^                ~~~~~
                          %d

     * The new -Wdangling-else command-line option has been split out of
       -Wparentheses and warns about dangling else.
     * The -Wshadow warning has been split into three variants.
       -Wshadow=global warns for any shadowing. This is the default when
       using -Wshadow without any argument. -Wshadow=local only warns for
       a local variable shadowing another local variable or parameter.
       -Wshadow=compatible-local only warns for a local variable shadowing
       another local variable or parameter whose type is compatible (in
       C++ compatible means that the type of the shadowing variable can be
       converted to that of the shadowed variable).
       The following example shows the different kinds of shadow warnings:

enum operation { add, count };
struct container { int nr; };

int
container_count (struct container c, int count)
{
  int r = 0;
  for (int count = 0; count > 0; count--)
    {
      struct container count = c;
      r += count.nr;
    }
  return r;
}

       -Wshadow=compatible-local will warn for the parameter being
       shadowed with the same type:

warn-test.c:8:12: warning: declaration of 'count' shadows a parameter [-Wshadow=
compatible-local]
   for (int count = 0; count > 0; count--)
            ^~~~~
warn-test.c:5:42: note: shadowed declaration is here
 container_count (struct container c, int count)
                                          ^~~~~

       -Wshadow=local will warn for the above and for the shadowed
       declaration with incompatible type:

warn-test.c:10:24: warning: declaration of 'count' shadows a previous local [-Ws
hadow=local]
       struct container count = c;
                        ^~~~~
warn-test.c:8:12: note: shadowed declaration is here
   for (int count = 0; count > 0; count--)
            ^~~~~

       -Wshadow=global will warn for all of the above and the shadowing of
       the global declaration:

warn-test.c:5:42: warning: declaration of 'count' shadows a global declaration [
-Wshadow]
 container_count (struct container c, int count)
                                          ^~~~~
warn-test.c:1:23: note: shadowed declaration is here
 enum operation { add, count };
                       ^~~~~

     * GCC 7 contains a number of enhancements that help detect buffer
       overflow and other forms of invalid memory accesses.
          + The -Walloc-size-larger-than=size option detects calls to
            standard and user-defined memory allocation functions
            decorated with attribute alloc_size whose argument exceeds the
            specified size (PTRDIFF_MAX by default). The option also
            detects arithmetic overflow in the computation of the size in
            two-argument allocation functions like calloc where the total
            size is the product of the two arguments. Since calls with an
            excessive size cannot succeed they are typically the result of
            programming errors. Such bugs have been known to be the source
            of security vulnerabilities and a target of exploits.
            -Walloc-size-larger-than=PTRDIFF_MAX is included in -Wall.
            For example, the following call to malloc incorrectly tries to
            avoid passing a negative argument to the function and instead
            ends up unconditionally invoking it with an argument less than
            or equal to zero. Since after conversion to the type of the
            argument of the function (size_t) a negative argument results
            in a value in excess of the maximum PTRDIFF_MAX the call is
            diagnosed.

void* f (int n)
{
  return malloc (n > 0 ? 0 : n);
}

warning: argument 1 range [2147483648, 4294967295] exceeds maximum object size 2
147483647 [-Walloc-size-larger-than=]

          + The -Walloc-zero option detects calls to standard and
            user-defined memory allocation functions decorated with
            attribute alloc_size with a zero argument. -Walloc-zero is not
            included in either -Wall or -Wextra and must be explicitly
            enabled.
          + The -Walloca option detects all calls to the alloca function
            in the program. -Walloca is not included in either -Wall or
            -Wextra and must be explicitly enabled.
          + The -Walloca-larger-than=size option detects calls to the
            alloca function whose argument either may exceed the specified
            size, or that is not known to be sufficiently constrained to
            avoid exceeding it. -Walloca-larger-than is not included in
            either -Wall or -Wextra and must be explicitly enabled.
            For example, compiling the following snippet with
            -Walloca-larger-than=1024 results in a warning because even
            though the code appears to call alloca only with sizes of 1kb
            and less, since n is signed, a negative value would result in
            a call to the function well in excess of the limit.

void f (int n)
{
  char *d;
  if (n < 1025)
    d = alloca (n);
  else
    d = malloc (n);
  …
}

warning: argument to 'alloca may be too large due to conversion from 'int' to 'l
ong unsigned int' [-Walloca-larger-than=]

            In contrast, a call to alloca that isn't bounded at all such
            as in the following function will elicit the warning below
            regardless of the size argument to the option.

void f (size_t n)
{
  char *d = alloca (n);
  …
}

warning: unbounded use of 'alloca' [-Walloca-larger-than=]

          + The -Wformat-overflow=level option detects certain and likely
            buffer overflow in calls to the sprintf family of formatted
            output functions. Although the option is enabled even without
            optimization it works best with -O2 and higher.
            For example, in the following snippet the call to sprintf is
            diagnosed because even though its output has been constrained
            using the modulo operation it could result in as many as three
            bytes if mday were negative. The solution is to either
            allocate a larger buffer or make sure the argument is not
            negative, for example by changing mday's type to unsigned or
            by making the type of the second operand of the modulo
            expression unsigned: 100U.

void* f (int mday)
{
  char *buf = malloc (3);
  sprintf (buf, "%02i", mday % 100);
  return buf;
}

warning: 'sprintf may write a terminating nul past the end of the destination [-
Wformat-overflow=]
note: 'sprintf' output between 3 and 4 bytes into a destination of size 3

          + The -Wformat-truncation=level option detects certain and
            likely output truncation in calls to the snprintf family of
            formatted output functions. -Wformat-truncation=1 is included
            in -Wall and enabled without optimization but works best with
            -O2 and higher.
            For example, the following function attempts to format an
            integer between 0 and 255 in hexadecimal, including the 0x
            prefix, into a buffer of four characters. But since the
            function must always terminate output by the null character
            ('\0') such a buffer is only big enough to fit just one digit
            plus the prefix. Therefore the snprintf call is diagnosed. To
            avoid the warning either use a bigger buffer or handle the
            function's return value which indicates whether or not its
            output has been truncated.

void f (unsigned x)
{
  char d[4];
  snprintf (d, sizeof d, "%#02x", x & 0xff);
  …
}

warning: 'snprintf' output may be truncated before the last format character [-W
format-truncation=]
note: 'snprintf' output between 3 and 5 bytes into a destination of size 4

          + The -Wnonnull option has been enhanced to detect a broader set
            of cases of passing null pointers to functions that expect a
            non-null argument (those decorated with attribute nonnull). By
            taking advantage of optimizations the option can detect many
            more cases of the problem than in prior GCC versions.
          + The -Wstringop-overflow=type option detects buffer overflow in
            calls to string handling functions like memcpy and strcpy. The
            option relies on [8]Object Size Checking and has an effect
            similar to defining the _FORTIFY_SOURCE macro.
            -Wstringop-overflow=2 is enabled by default.
            For example, in the following snippet, because the call to
            strncat specifies a maximum that allows the function to write
            past the end of the destination, it is diagnosed. To correct
            the problem and avoid the overflow the function should be
            called with a size of at most sizeof d - strlen(d) - 1.

void f (const char *fname)
{
  char d[8];
  strncpy (d, "/tmp/", sizeof d);
  strncat (d, fname, sizeof d);
  …
}

warning: specified bound 8 equals the size of the destination [-Wstringop-overfl
ow=]

     * The <limits.h> header provided by GCC defines macros such as
       INT_WIDTH for the width in bits of integer types, if
       __STDC_WANT_IEC_60559_BFP_EXT__ is defined before the header is
       included. The <stdint.h> header defines such macros as SIZE_WIDTH
       and INTMAX_WIDTH for the width of some standard typedef names for
       integer types, again if __STDC_WANT_IEC_60559_BFP_EXT__ is defined
       before the header is included; note that GCC's implementation of
       this header is only used for freestanding compilations, not hosted
       compilations, on most systems. These macros come from ISO/IEC TS
       18661-1:2014.
     * The <float.h> header provided by GCC defines the macro
       CR_DECIMAL_DIG, from ISO/IEC TS 18661-1:2014, if
       __STDC_WANT_IEC_60559_BFP_EXT__ is defined before the header is
       included. This represents the number of decimal digits for which
       conversions between decimal character strings and binary formats,
       in both directions, are correctly rounded, and currently has the
       value of UINTMAX_MAX on all systems, reflecting that GCC's
       compile-time conversions are correctly rounded for any number of
       digits.
     * New __builtin_add_overflow_p, __builtin_sub_overflow_p,
       __builtin_mul_overflow_p built-in functions have been added. These
       work similarly to their siblings without the _p suffix, but do not
       actually store the result of the arithmetics anywhere, just return
       whether the operation would overflow. Calls to these built-ins with
       integer constant arguments evaluate to integer constants
       expressions.
       For example, in the following, c is assigned the result of a * b
       only if the multiplication does not overflow, otherwise it is
       assigned the value zero. The multiplication is performed at
       compile-time and without triggering a -Woverflow warning.

enum {
  a = 12345678,
  b = 87654321,
  c = __builtin_mul_overflow_p (a, b, a) ? 0 : a * b
};

  C

     * The C front end now supports type names _FloatN for floating-point
       types with IEEE interchange formats and _FloatNx for floating-point
       types with IEEE extended formats. These type names come from
       ISO/IEC TS 18661-3:2015.
       The set of types supported depends on the target for which GCC is
       configured. Most targets support _Float32, _Float32x and _Float64.
       _Float128 is supported on targets where IEEE binary128 encoding was
       already supported as long double or __float128. _Float64x is
       supported on targets where a type with either binary128 or Intel
       extended precision format is available.
       Constants with these types are supported using suffixes fN, FN, fNx
       and FNx (e.g., 1.2f128 or 2.3F64x). Macros such as FLT128_MAX are
       defined in <float.h> if __STDC_WANT_IEC_60559_TYPES_EXT__ is
       defined before it is included.
       These new types are always distinct from each other and from float,
       double and long double, even if they have the same encoding.
       Complex types such as _Complex _Float128 are also supported.
       Type-generic built-in functions such as __builtin_isinf support the
       new types, and the following type-specific built-in functions have
       versions (suffixed fN or fNx) for the new types:
       __builtin_copysign, __builtin_fabs, __builtin_huge_val,
       __builtin_inf, __builtin_nan, __builtin_nans.
     * Compilation with -fopenmp is now compatible with the C11 _Atomic
       keyword.

  C++

     * The C++ front end has experimental support for all of the current
       C++17 draft with the -std=c++1z or -std=gnu++1z flags, including if
       constexpr, class template argument deduction, auto template
       parameters, and structured bindings. For a full list of new
       features, see [9]the C++ status page.
     * C++17 support for new of over-aligned types can be enabled in other
       modes with the -faligned-new flag.
     * The C++17 evaluation order requirements can be selected in other
       modes with the -fstrong-eval-order flag, or disabled in C++17 mode
       with -fno-strong-eval-order.
     * The default semantics of inherited constructors has changed in all
       modes, following [10]P0136. Essentially, overload resolution
       happens as if calling the inherited constructor directly, and the
       compiler fills in construction of the other bases and members as
       needed. Most uses should not need any changes. The old behavior can
       be restored with -fno-new-inheriting-ctors, or -fabi-version less
       than 11.
     * The resolution of DR 150 on matching of template template
       parameters, allowing default template arguments to make a template
       match a parameter, is currently enabled by default in C++17 mode
       only. The default can be overridden with -f{no-,}new-ttp-matching.
     * The C++ front end will now provide fix-it hints for some missing
       semicolons, allowing for automatic fixes by IDEs:

test.cc:4:11: error: expected ';' after class definition
 class a {}
           ^
           ;

     * -Waligned-new has been added to the C++ front end. It warns about
       new of type with extended alignment without -faligned-new.

    Runtime Library (libstdc++)

     * The type of exception thrown by iostreams, std::ios_base::failure,
       now uses the [11]cxx11 ABI.
     * Experimental support for C++17, including the following new
       features:
          + std::string_view;
          + std::any, std::optional, and std::variant;
          + std::invoke, std::is_invocable, std::is_nothrow_invocable, and
            invoke_result;
          + std::is_swappable, and std::is_nothrow_swappable;
          + std::apply, and std::make_from_tuple;
          + std::void_t, std::bool_constant, std::conjunction,
            std::disjunction, and std::negation;
          + Variable templates for type traits;
          + Mathematical Special Functions;
          + std::chrono::floor, std::chrono::ceil, std::chrono::round, and
            std::chrono::abs;
          + std::clamp, std::gcd, std::lcm, 3-dimensional std::hypot;
          + std::scoped_lock, std::shared_mutex,
            std::atomic<T>::is_always_lock_free;
          + std::sample, std::default_searcher, std::boyer_moore_searcher
            and std::boyer_moore_horspool_searcher;
          + Extraction and re-insertion of map and set nodes, try_emplace
            members for maps, and functions for accessing containers
            std::size, std::empty, and std::data;
          + std::shared_ptr support for arrays,
            std::shared_ptr<T>::weak_type,
            std::enable_shared_from_this<T>::weak_from_this(), and
            std::owner_less<void>;
          + std::byte;
          + std::as_const, std::not_fn,
            std::has_unique_object_representations, constexpr
            std::addressof.
       Thanks to Daniel Krügler, Tim Shen, Edward Smith-Rowland, and Ville
       Voutilainen for work on the C++17 support.
     * A new power-of-two rehashing policy for use with the _Hashtable
       internals, thanks to François Dumont.

  Fortran

     * Support for a number of extensions for compatibility with legacy
       code with new flags:
          + -fdec-structure Support for DEC STRUCTURE and UNION
          + -fdec-intrinsic-ints Support for new integer intrinsics with
            B/I/J/K prefixes such as BABS, JIAND...
          + -fdec-math Support for additional math intrinsics, including
            COTAN and degree-valued trigonometric functions such as TAND,
            ASIND...
          + -fdec Enable the -fdec-* family of extensions.
     * New flag -finit-derived to allow default initialization of
       derived-type variables.
     * Improved DO loops with step equal to 1 or -1, generates faster code
       without a loop preheader. A new warning, -Wundefined-do-loop, warns
       when a loop iterates either to HUGE(i) (with step equal to 1), or
       to -HUGE(i) (with step equal to -1). Invalid behavior can be caught
       at run time with -fcheck=do enabled:

program test
  implicit none
  integer(1) :: i
  do i = -HUGE(i)+10, -HUGE(i)-1, -1
    print *, i
  end do
end program test

At line 8 of file do_check_12.f90
Fortran runtime error: Loop iterates infinitely

     * Version 4.5 of the [12]OpenMP specification is now partially
       supported in the Fortran compiler; the largest missing item is
       structure element mapping.
     * User-defined derived-type input/output (UDTIO) is added.
     * Derived type coarrays with allocatable and pointer components are
       partially supported.
     * Non-constant stop codes and error stop codes (Fortran 2015
       feature).
     * Derived types with allocatable components of recursive type.
     * Intrinsic assignment to polymorphic variables.
     * Improved submodule support.
     * Improved diagnostics (polymorphic results in pure functions).
     * Coarray: Support for failed images (Fortan 2015 feature).

  Go

     * GCC 7 provides a complete implementation of the Go 1.8.1 user
       packages.
     * Compared to the Go 1.8.1 toolchain, the garbage collector is more
       conservative and less concurrent.
     * Escape analysis is available for experimental use via the
       -fgo-optimize-allocs option. The -fgo-debug-escape prints
       information useful for debugging escape analysis choices.

  Java (GCJ)

   The GCC Java front end and associated libjava runtime library have been
   removed from GCC.

libgccjit

   The libgccjit API gained support for marking calls as requiring
   tail-call optimization via a new entry point:
   [13]gcc_jit_rvalue_set_bool_require_tail_call.

   libgccjit performs numerous checks at the API boundary, but if these
   succeed, it previously ignored errors and other diagnostics emitted
   within the core of GCC, and treated the compile of a gcc_jit_context as
   having succeeded. As of GCC 7 it now ensures that if any diagnostics
   are emitted, they are visible from the libgccjit API, and that the the
   context is flagged as having failed.

New Targets and Target Specific Improvements

  AArch64

     * GCC has been updated to the latest revision of the procedure call
       standard (AAPCS64) to provide support for parameter passing when
       data types have been over-aligned.
     * The ARMv8.3-A architecture is now supported. It can be used by
       specifying the -march=armv8.3-a option.
     * The option -msign-return-address= is supported to enable return
       address protection using ARMv8.3-A Pointer Authentication
       Extensions. For more information on the arguments accepted by this
       option, please refer to [14]AArch64-Options.
     * The ARMv8.2-A architecture and the ARMv8.2-A 16-bit Floating-Point
       Extensions are now supported. They can be used by specifying the
       -march=armv8.2-a or -march=armv8.2-a+fp16 options. The 16-bit
       Floating-Point Extensions introduce new half-precision data
       processing floating-point instructions.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A73 (cortex-a73), Broadcom
       Vulcan (vulcan), Cavium ThunderX CN81xx (thunderxt81), Cavium
       ThunderX CN83xx (thunderxt83), Cavium ThunderX CN88xx
       (thunderxt88), Cavium ThunderX CN88xx pass 1.x (thunderxt88p1),
       Cavium ThunderX 2 CN99xx (thunderx2t99), Qualcomm Falkor (falkor).
       The GCC identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a73 or -mtune=vulcan or as
       arguments to the equivalent target attributes and pragmas.

  ARC

     * Added support for ARC HS and ARC EM processors.
     * Added support for ARC EM variation found in Intel QuarkSE SoCs.
     * Added support for NPS400 ARC700 based CPUs.
     * Thread Local Storage is now supported by ARC CPUs.
     * Fixed errors for ARC600 when using 32x16 multiplier option.
     * Fixed PIE for ARC CPUs.
     * New CPU templates are supported via multilib.

  ARM

     * Support for the ARMv5 and ARMv5E architectures has been deprecated
       (which have no known implementations) and will be removed in a
       future GCC release. Note that ARMv5T, ARMv5TE and ARMv5TEJ
       architectures remain supported. The values armv5 and armv5e of
       -march are thus deprecated.
     * The ARMv8.2-A architecture and the ARMv8.2-A 16-bit Floating-Point
       Extensions are now supported. They can be used by specifying the
       -march=armv8.2-a or -march=armv8.2-a+fp16 options. The 16-bit
       Floating-Point Extensions introduce new half-precision data
       processing floating-point instructions.
     * The ARMv8-M architecture is now supported in its two architecture
       profiles: ARMv8-M Baseline and ARMv8-M Mainline with its DSP and
       Floating-Point Extensions. They can be used by specifying the
       -march=armv8-m.base, armv8-m.main or armv8-m.main+dsp options.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A73 (cortex-a73), ARM
       Cortex-M23 (cortex-m23) and ARM Cortex-M33 (cortex-m33). The GCC
       identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a73 or -mtune=cortex-m33.
     * A new command-line option -mpure-code has been added. It does not
       allow constant data to be placed in code sections. This option is
       only available when generating non-PIC code for ARMv7-M targets.
     * Support for the ACLE Coprocessor Intrinsics has been added. This
       enables the generation of coprocessor instructions through the use
       of intrinsics such as cdp, ldc, and others.
     * The configure option --with-multilib-list now accepts the value
       rmprofile to build multilib libraries for a range of embedded
       targets. See our [15]installation instructions for details.

  AVR

     * On the reduced Tiny cores, the progmem [16]variable attribute is
       now properly supported. Respective read-only variables are located
       in flash memory in section .progmem.data. No special code is needed
       to access such variables; the compiler automatically adds an offset
       of 0x4000 to all addresses, which is needed to access variables in
       flash memory. As opposed to ordinary cores where it is sufficient
       to specify the progmem attribute with definitions, on the reduced
       Tiny cores the attribute also has to be specified with (external)
       declarations:

extern const int array[] __attribute__((__progmem__));

int get_value2 (void)
{
  /* Access via addresses array + 0x4004 and array + 0x4005. */
  return array[2];
}

const int* get_address (unsigned idx)
{
  /* Returns array + 0x4000 + 2 * idx. */
  return &array[idx];
}

     * A new command-line option -Wmisspelled-isr has been added. It turns
       off — or turns into errors — warnings that are reported for
       interrupt service routines (ISRs) which don't follow AVR-LibC's
       naming convention of prefixing ISR names with __vector.
     * __builtin_avr_nops(n) is a new [17]built-in function that inserts n
       NOP instructions into the instruction stream. n must be a value
       known at compile time.

  IA-32/x86-64

     * Support for the AVX-512 Fused Multiply Accumulation Packed Single
       precision (4FMAPS), AVX-512 Vector Neural Network Instructions Word
       variable precision (4VNNIW), AVX-512 Vector Population Count
       (VPOPCNTDQ) and Software Guard Extensions (SGX) ISA extensions has
       been added.

  NVPTX

     * OpenMP target regions can now be offloaded to NVidia PTX GPGPUs.
       See the [18]Offloading Wiki on how to configure it.

  PowerPC / PowerPC64 / RS6000

     * The PowerPC port now uses LRA by default.
     * GCC now diagnoses inline assembly that clobbers register r2. This
       has always been invalid code, and is no longer quietly tolerated.
     * The PowerPC port's support for ISA 3.0 (-mcpu=power9) has been
       enhanced to generate more of the new instructions by default, and
       to provide more built-in functions to generate code for other new
       instructions.
     * The configuration option --enable-gnu-indirect-function is now
       enabled by default on PowerPC GNU/Linux builds.
     * The PowerPC port will now allow 64-bit and 32-bit integer types to
       be allocated to the VSX vector registers (ISA 2.06 and above). In
       addition, on ISA 3.0, 16-bit and 8-bit integer types can be
       allocated in the vector registers. Previously, only 64-bit integer
       types were allowed in the traditional floating point registers.
     * New options -mstack-protector-guard=global,
       -mstack-protector-guard=tls, -mstack-protector-guard-reg=, and
       -mstack-protector-guard-offset= change how the stack protector gets
       the value to use as canary.

  S/390, System z, IBM z Systems, IBM Z

     * Support for the IBM z14 processor has been added. When using the
       -march=z14 option, the compiler will generate code making use of
       the new instructions introduced with the vector enhancement
       facility and the miscellaneous instruction extension facility 2.
       The -mtune=z14 option enables z14 specific instruction scheduling
       without making use of new instructions.
     * Builtins for the new vector instructions have been added and can be
       enabled using the -mzvector option.

  RISC-V

     * Support for the RISC-V instruction set has been added.

  RX

   Basic support for atomic built-in function has been added. It is
   currently implemented by flipping interrupts off and on as needed.

  SH

     * Support for SH5/SH64 has been removed.
     * Improved utilization of delay slots on SH2A.
     * Improved utilization of zero-displacement conditional branches.
     * The following deprecated options have been removed
          + -mcbranchdi
          + -mcmpeqdi
          + -minvalid-symbols
          + -msoft-atomic
          + -mspace
          + -madjust-unroll
     * Support for the following SH2A instructions has been added
          + mov.b @-Rm,R0
          + mov.w @-Rm,R0
          + mov.l @-Rm,R0
          + mov.b R0,@Rn+
          + mov.w R0,@Rn+
          + mov.l R0,@Rn+

  SPARC

     * The SPARC port now uses LRA by default.
     * Support for the new Subtract-Extended-with-Carry instruction
       available in SPARC M7 (Niagara 7) has been added.

Operating Systems

  AIX

     * Visibility support has been enabled for AIX 7.1 and above.

  Fuchsia

     * Support has been added for the [19]Fuchsia OS.

  RTEMS

     * The ABI changes on ARM so that no short enums are used by default.

Other significant improvements

     * -fverbose-asm previously emitted information on the meanings of
       assembly expressions. This has been extended so that it now also
       prints comments showing the source lines that correspond to the
       assembly, making it easier to read the generated assembly
       (especially with larger functions). For example, given this C
       source file:

int test (int n)
{
  int i;
  int total = 0;

  for (i = 0; i < n; i++)
    total += i * i;
  return total;
}

       -fverbose-asm now gives output similar to this for the function
       body (when compiling for x86_64, with -Os):

       .text
       .globl  test
       .type   test, @@function
test:
.LFB0:
       .cfi_startproc
# example.c:4:   int total = 0;
       xorl    %eax, %eax      # <retval>
# example.c:6:   for (i = 0; i < n; i++)
       xorl    %edx, %edx      # i
.L2:
# example.c:6:   for (i = 0; i < n; i++)
       cmpl    %edi, %edx      # n, i
       jge     .L5     #,
# example.c:7:     total += i * i;
       movl    %edx, %ecx      # i, tmp92
       imull   %edx, %ecx      # i, tmp92
# example.c:6:   for (i = 0; i < n; i++)
       incl    %edx    # i
# example.c:7:     total += i * i;
       addl    %ecx, %eax      # tmp92, <retval>
       jmp     .L2     #
.L5:
# example.c:10: }
       ret
       .cfi_endproc

     * Two new options have been added for printing fix-it hints:
          + -fdiagnostics-parseable-fixits allows for fix-it hints to be
            emitted in a machine-readable form, suitable for consumption
            by IDEs. For example, given:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~
               color

            it will emit:

fix-it:"spellcheck-fields.cc":{52:13-52:19}:"color"

          + -fdiagnostics-generate-patch will print a patch in "unified"
            format after any diagnostics are printed, showing the result
            of applying all fix-it hints. For the above example it would
            emit:

--- spellcheck-fields.cc
+++ spellcheck-fields.cc
@@ -49,5 +49,5 @@

 color get_color(struct s *ptr)
 {
-  return ptr->colour;
+  return ptr->color;
 }

     * The gcc and g++ driver programs will now provide suggestions for
       misspelled arguments to command-line options.

$ gcc -c test.c -ftls-model=global-dinamic
gcc: error: unknown TLS model 'global-dinamic'
gcc: note: valid arguments to '-ftls-model=' are: global-dynamic initial-exec lo
cal-dynamic local-exec; did you mean 'global-dynamic'?

     * The compiler will now provide suggestions for misspelled
       parameters.

$ gcc -c test.c --param max-early-inliner-iteration=3
cc1: error: invalid --param name 'max-early-inliner-iteration'; did you mean 'ma
x-early-inliner-iterations'?

     * Profile-guided optimization (PGO) instrumentation, as well as test
       coverage (GCOV), can newly instrument constructors (functions marks
       with __attribute__((constructor))), destructors and C++
       constructors (and destructors) of classes that are used as the type
       of a global variable.
     * A new option -fprofile-update=atomic prevents creation of corrupted
       profiles created during an instrumentation run (-fprofile=generate)
       of an application. The downside of the option is a speed penalty.
       Providing -pthread on the command line selects atomic profile
       updating (when supported by the target).
     * GCC's already extensive testsuite has gained some new capabilities,
       to further improve the reliability of the compiler:
          + GCC now has an internal unit-testing API and a suite of tests
            for programmatic self-testing of subsystems.
          + GCC's C front end has been extended so that it can parse dumps
            of GCC's internal representations, allowing for DejaGnu tests
            that more directly exercise specific optimization passes. This
            covers both the [20]GIMPLE representation (for testing
            higher-level optimizations) and the [21]RTL representation,
            allowing for more direct testing of lower-level details, such
            as register allocation and instruction selection.

GCC 7.1

   This is the [22]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.1 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 7.2

   This is the [23]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    SPARC

     * Support for the SPARC M8 processor has been added.
     * The switches -mfix-ut700 and -mfix-gr712rc have been added to work
       around an erratum in LEON3FT processors.
     * Use of the Floating-point Multiply Single to Double (FsMULd)
       instruction can now be controlled by the -mfsmuld and -fno-fsmuld
       options.

  Operating Systems

    RTEMS

     * The Ada run-time support uses now thread-local storage (TLS).
     * Support for RISC-V has been added.
     * Support for 64-bit PowerPC using the ELFv2 ABI with 64-bit long
       double has been added.

GCC 7.3

   This is the [24]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

  Target Specific Changes

    SPARC

     * Workarounds for the four [25]LEON3FT errata GRLIB-TN-0010..0013
       have been added. Relevant errata are activated by the target
       specific -mfix-ut699, -mfix-ut700 and -mfix-gr712rc switches.

  Operating Systems

    RTEMS

     * Support has been added for Epiphany target.

GCC 7.4

   This is the [26]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

GCC 7.5

   This is the [27]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 7.5 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [28]GCC manuals. If that fails, the
    [29]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [30]gcc@gcc.gnu.org. All of [31]our lists have public
    archives.

   Copyright (C) [32]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [33]maintained by the GCC team. Last modified
   2021-10-17[34].

References

   1. http://gcc.gnu.org/gcc-7/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/wiki/LRAIsDefault
   4. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/libstdc++/manual/manual/profile_mode.html
   5. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77728
   6. https://gcc.gnu.org/wiki/OpenACC
   7. https://gcc.gnu.org/wiki/Offloading
   8. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/Object-Size-Checking.html
   9. https://gcc.gnu.org/projects/cxx-status.html#cxx1z
  10. https://wg21.link/p0136
  11. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/libstdc++/manual/using_dual_abi.html
  12. https://www.openmp.org/specifications/
  13. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/jit/topics/expressions.html#gcc_jit_rvalue_set_bool_require_tail_call
  14. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/AArch64-Options.html#AArch64-Options
  15. https://gcc.gnu.org/install/configure.html
  16. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/AVR-Variable-Attributes.html
  17. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gcc/AVR-Built-in-Functions.html
  18. https://gcc.gnu.org/wiki/Offloading
  19. https://fuchsia.googlesource.com/
  20. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gccint/GIMPLE-Tests.html
  21. https://gcc.gnu.org/onlinedocs/gcc-7.1.0/gccint/RTL-Tests.html
  22. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.0
  23. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.2
  24. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.3
  25. https://www.gaisler.com/index.php/information/app-tech-notes
  26. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.4
  27. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=7.5
  28. https://gcc.gnu.org/onlinedocs/
  29. mailto:gcc-help@gcc.gnu.org
  30. mailto:gcc@gcc.gnu.org
  31. https://gcc.gnu.org/lists.html
  32. https://www.fsf.org/
  33. https://gcc.gnu.org/about.html
  34. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-6/index.html
                              GCC 6 Release Series

   (This release series is no longer supported.)

   October 26, 2018

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 6.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 6.4 relative to previous releases of GCC.

Release History

   GCC 6.5
          October 26, 2018 ([2]changes, [3]documentation)

   GCC 6.4
          July 4, 2017 ([4]changes, [5]documentation)

   GCC 6.3
          December 21, 2016 ([6]changes, [7]documentation)

   GCC 6.2
          August 22, 2016 ([8]changes, [9]documentation)

   GCC 6.1
          April 27, 2016 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2021-07-28[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-6/changes.html
   3. http://gcc.gnu.org/onlinedocs/6.5.0/
   4. http://gcc.gnu.org/gcc-6/changes.html
   5. http://gcc.gnu.org/onlinedocs/6.4.0/
   6. http://gcc.gnu.org/gcc-6/changes.html
   7. http://gcc.gnu.org/onlinedocs/6.3.0/
   8. http://gcc.gnu.org/gcc-6/changes.html
   9. http://gcc.gnu.org/onlinedocs/6.2.0/
  10. http://gcc.gnu.org/gcc-6/changes.html
  11. http://gcc.gnu.org/onlinedocs/6.1.0/
  12. http://gcc.gnu.org/gcc-6/buildstat.html
  13. http://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/git.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. https://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-6/changes.html
                              GCC 6 Release Series
                        Changes, New Features, and Fixes

   This page is a brief summary of some of the huge number of improvements
   in GCC 6. For more information, see the [1]Porting to GCC 6 page and
   the [2]full GCC documentation.

Caveats

     * The default mode for C++ is now -std=gnu++14 instead of
       -std=gnu++98.
     * Support for a number of older systems and recently unmaintained or
       untested target ports of GCC has been declared obsolete in GCC 6.
       Unless there is activity to revive them, the next release of GCC
       will have their sources permanently removed.
       The following ports for individual systems on particular
       architectures have been obsoleted:
          + SH5 / SH64 (sh64-*-*) as announced [3]here.
     * The AVR port requires binutils version 2.26.1 or later for the fix
       for [4]PR71151 to work.
     * The GCC 6.5 release has an accidental ABI incompatibility for
       nested std::pair objects, for more details see [5]PR 87822. The bug
       causes a layout change for pairs where the first member is also a
       pair, e.g. std::pair<std::pair<X, Y>, Z>. The GCC 6 release series
       is closed so the bug in GCC 6.5 will not be fixed upstream, but
       there is a patch in the bug report to allow it to be fixed by
       anybody packaging GCC 6.5 or installing it themselves.

General Optimizer Improvements

     * UndefinedBehaviorSanitizer gained a new sanitization option,
       -fsanitize=bounds-strict, which enables strict checking of array
       bounds. In particular, it enables -fsanitize=bounds as well as
       instrumentation of flexible array member-like arrays.
     * Type-based alias analysis now disambiguates accesses to different
       pointers. This improves precision of the alias oracle by about
       20-30% on higher-level C++ programs. Programs doing invalid type
       punning of pointer types may now need -fno-strict-aliasing to work
       correctly.
     * Alias analysis now correctly supports the weakref and alias
       attributes. This allows accessing both a variable and its alias in
       one translation unit which is common with link-time optimization.
     * Value range propagation now assumes that the this pointer in C++
       member functions is non-null. This eliminates common null pointer
       checks but also breaks some non-conforming code-bases (such as
       Qt-5, Chromium, KDevelop). As a temporary work-around
       -fno-delete-null-pointer-checks can be used. Wrong code can be
       identified by using -fsanitize=undefined.
     * Link-time optimization improvements:
          + warning and error attributes are now correctly preserved by
            declaration linking and thus -D_FORTIFY_SOURCE=2 is now
            supported with -flto.
          + Type merging was fixed to handle C and Fortran
            interoperability rules as defined by the Fortran 2008 language
            standard.
            As an exception, CHARACTER(KIND=C_CHAR) is not inter-operable
            with char in all cases because it is an array while char is
            scalar. INTEGER(KIND=C_SIGNED_CHAR) should be used instead. In
            general, this inter-operability cannot be implemented, for
            example on targets where the argument passing convention for
            arrays differs from scalars.
          + More type information is now preserved at link time, reducing
            the loss of accuracy of the type-based alias analysis compared
            to builds without link-time optimization.
          + Invalid type punning on global variables and declarations is
            now reported with -Wodr-type-mismatch.
          + The size of LTO object files was reduced by about 11%
            (measured by compiling Firefox 46.0).
          + Link-time parallelization (enabled using -flto=n) was
            significantly improved by decreasing the size of streamed data
            when partitioning programs. The size of streamed IL while
            compiling Firefox 46.0 was reduced by 66%.
          + The linker plugin was extended to pass information about the
            type of binary produced to the GCC back end. (That can also be
            controlled manually by -flinker-output.) This makes it
            possible to properly configure the code generator and support
            incremental linking. Incremental linking of LTO objects by gcc
            -r is now supported for plugin-enabled setups.
            There are two ways to perform incremental linking:
              1. Linking by ld -r will result in an object file with all
                 sections from individual object files mechanically
                 merged. This delays the actual link-time optimization to
                 the final linking step and thus permits whole program
                 optimization. Linking the final binary with such object
                 files is however slower.
              2. Linking by gcc -r will lead to link-time optimization and
                 emit the final binary into the object file. Linking such
                 an object file is fast but avoids any benefits from whole
                 program optimization.
            GCC 7 will support incremental link-time optimization with gcc
            -r.
     * Inter-procedural optimization improvements:
          + Basic jump threading is now performed before profile
            construction and inline analysis, resulting in more realistic
            size and time estimates that drive the heuristics of the
            inliner and function cloning passes.
          + Function cloning now more aggressively eliminates unused
            function parameters.

New Languages and Language specific improvements

   Compared to GCC 5, the GCC 6 release series includes a much improved
   implementation of the [6]OpenACC 2.0a specification. Highlights are:
     * In addition to single-threaded host-fallback execution, offloading
       is supported for nvptx (Nvidia GPUs) on x86_64 and PowerPC 64-bit
       little-endian GNU/Linux host systems. For nvptx offloading, with
       the OpenACC parallel construct, the execution model allows for an
       arbitrary number of gangs, up to 32 workers, and 32 vectors.
     * Initial support for parallelized execution of OpenACC kernels
       constructs:
          + Parallelization of a kernels region is switched on by
            -fopenacc combined with -O2 or higher.
          + Code is offloaded onto multiple gangs, but executes with just
            one worker, and a vector length of 1.
          + Directives inside a kernels region are not supported.
          + Loops with reductions can be parallelized.
          + Only kernels regions with one loop nest are parallelized.
          + Only the outer-most loop of a loop nest can be parallelized.
          + Loop nests containing sibling loops are not parallelized.
       Typically, using the OpenACC parallel construct gives much better
       performance, compared to the initial support of the OpenACC kernels
       construct.
     * The device_type clause is not supported. The bind and nohost
       clauses are not supported. The host_data directive is not supported
       in Fortran.
     * Nested parallelism (cf. CUDA dynamic parallelism) is not supported.
     * Usage of OpenACC constructs inside multithreaded contexts (such as
       created by OpenMP, or pthread programming) is not supported.
     * If a call to the acc_on_device function has a compile-time constant
       argument, the function call evaluates to a compile-time constant
       value only for C and C++ but not for Fortran.

   See the [7]OpenACC and [8]Offloading wiki pages for further
   information.

  C family

     * Version 4.5 of the [9]OpenMP specification is now supported in the
       C and C++ compilers.
     * The C and C++ compilers now support attributes on enumerators. For
       instance, it is now possible to mark enumerators as deprecated:

enum {
  newval,
  oldval __attribute__ ((deprecated ("too old")))
};

     * Source locations for the C and C++ compilers are now tracked as
       ranges, rather than just points, making it easier to identify the
       subexpression of interest within a complicated expression. For
       example:

test.cc: In function 'int test(int, int, foo, int, int)':
test.cc:5:16: error: no match for 'operator*' (operand types are 'int' and 'foo'
)
   return p + q * r * s + t;
              ~~^~~

       In addition, there is now initial support for precise diagnostic
       locations within strings:

format-strings.c:3:14: warning: field width specifier '*' expects a matching 'in
t' argument [-Wformat=]
   printf("%*d");
            ^

     * Diagnostics can now contain "fix-it hints", which are displayed in
       context underneath the relevant source code. For example:

fixits.c: In function 'bad_deref':
fixits.c:11:13: error: 'ptr' is a pointer; did you mean to use '->'?
   return ptr.x;
             ^
             ->

     * The C and C++ compilers now offer suggestions for misspelled field
       names:

spellcheck-fields.cc:52:13: error: 'struct s' has no member named 'colour'; did
you mean 'color'?
   return ptr->colour;
               ^~~~~~

     * New command-line options have been added for the C and C++
       compilers:
          + -Wshift-negative-value warns about left shifting a negative
            value.
          + -Wshift-overflow warns about left shift overflows. This
            warning is enabled by default. -Wshift-overflow=2 also warns
            about left-shifting 1 into the sign bit.
          + -Wtautological-compare warns if a self-comparison always
            evaluates to true or false. This warning is enabled by -Wall.
          + -Wnull-dereference warns if the compiler detects paths that
            trigger erroneous or undefined behavior due to dereferencing a
            null pointer. This option is only active when
            -fdelete-null-pointer-checks is active, which is enabled by
            optimizations in most targets. The precision of the warnings
            depends on the optimization options used.
          + -Wduplicated-cond warns about duplicated conditions in an
            if-else-if chain.
          + -Wmisleading-indentation warns about places where the
            indentation of the code gives a misleading idea of the block
            structure of the code to a human reader. For example, given
            [10]CVE-2014-1266:

sslKeyExchange.c: In function 'SSLVerifySignedServerKeyExchange':
sslKeyExchange.c:629:3: warning: this 'if' clause does not guard... [-Wmisleadin
g-indentation]
    if ((err = SSLHashSHA1.update(&hashCtx, &signedParams)) != 0)
    ^~
sslKeyExchange.c:631:5: note: ...this statement, but the latter is misleadingly
indented as if it is guarded by the 'if'
        goto fail;
        ^~~~

            This warning is enabled by -Wall.
     * The C and C++ compilers now emit saner error messages if
       merge-conflict markers are present in a source file.

test.c:3:1: error: version control conflict marker in file
 <<<<<<< HEAD
 ^~~~~~~

  C

     * It is possible to disable warnings when an initialized field of a
       structure or a union with side effects is being overridden when
       using designated initializers via a new warning option
       -Woverride-init-side-effects.
     * A new type attribute scalar_storage_order applying to structures
       and unions has been introduced. It specifies the storage order (aka
       endianness) in memory of scalar fields in structures or unions.

  C++

     * The default mode has been changed to -std=gnu++14.
     * [11]C++ Concepts are now supported when compiling with -fconcepts.
     * -flifetime-dse is more aggressive in dead-store elimination in
       situations where a memory store to a location precedes a
       constructor to that memory location.
     * G++ now supports [12]C++17 fold expressions, u8 character literals,
       extended static_assert, and nested namespace definitions.
     * G++ now allows constant evaluation for all non-type template
       arguments.
     * G++ now supports C++ Transactional Memory when compiling with
       -fgnu-tm.

    Runtime Library (libstdc++)

     * Extensions to the C++ Library to support mathematical special
       functions (ISO/IEC 29124:2010), thanks to Edward Smith-Rowland.
     * Experimental support for C++17, including the following new
       features:
          + std::uncaught_exceptions function (this is also available for
            -std=gnu++NN modes);
          + new member functions try_emplace and insert_or_assign for
            unique_key maps;
          + non-member functions std::size, std::empty, and std::data for
            accessing containers and arrays;
          + std::invoke;
          + std::shared_mutex;
          + std::void_t and std::bool_constant metaprogramming utilities.
       Thanks to Ville Voutilainen for contributing many of the C++17
       features.
     * An experimental implementation of the File System TS.
     * Experimental support for most features of the second version of the
       Library Fundamentals TS. This includes polymorphic memory resources
       and array support in shared_ptr, thanks to Fan You.
     * Some assertions checked by Debug Mode can now also be enabled by
       _GLIBCXX_ASSERTIONS. The subset of checks enabled by the new macro
       have less run-time overhead than the full _GLIBCXX_DEBUG checks and
       don't affect the library ABI, so can be enabled per-translation
       unit.
     * Timed mutex types are supported on more targets, including Darwin.
     * Improved std::locale support for DragonFly and FreeBSD, thanks to
       John Marino and Andreas Tobler.

  Fortran

     * Fortran 2008 SUBMODULE support.
     * Fortran 2015 EVENT_TYPE, EVENT_POST, EVENT_WAIT, and EVENT_QUERY
       support.
     * Improved support for Fortran 2003 deferred-length character
       variables.
     * Improved support for OpenMP and OpenACC.
     * The MATMUL intrinsic is now inlined for straightforward cases if
       front-end optimization is active. The maximum size for inlining can
       be set to n with the -finline-matmul-limit=n option and turned off
       with -finline-matmul-limit=0.
     * The -Wconversion-extra option will warn about REAL constants which
       have excess precision for their kind.
     * The -Winteger-division option has been added, which warns about
       divisions of integer constants which are truncated. This option is
       included in -Wall by default.

libgccjit

     * The driver code is now run in-process within libgccjit, providing a
       small speed-up of the compilation process.
     * The API has gained entrypoints for
          + [13]timing how long was spent in different parts of code,
          + [14]creating switch statements,
          + [15]allowing unreachable basic blocks in a function, and
          + [16]adding arbitrary command-line options to a compilation.

New Targets and Target Specific Improvements

  AArch64

     * A number of AArch64-specific options have been added. The most
       important ones are summarised in this section; for more detailed
       information please refer to the documentation.
     * The command-line options -march=native, -mcpu=native and
       -mtune=native are now available on native AArch64 GNU/Linux
       systems. Specifying these options causes GCC to auto-detect the
       host CPU and choose the optimal setting for that system.
     * -fpic is now supported when generating code for the small code
       model (-mcmodel=small). The size of the global offset table (GOT)
       is limited to 28KiB under the LP64 SysV ABI, and 15KiB under the
       ILP32 SysV ABI.
     * The AArch64 port now supports target attributes and pragmas. Please
       refer to the [17]documentation for details of available attributes
       and pragmas as well as usage instructions.
     * Link-time optimization across translation units with different
       target-specific options is now supported.
     * The option -mtls-size= is now supported. It can be used to specify
       the bit size of TLS offsets, allowing GCC to generate better TLS
       instruction sequences.
     * The option -fno-plt is now fully functional.
     * The ARMv8.1-A architecture and the Large System Extensions are now
       supported. They can be used by specifying the -march=armv8.1-a
       option. Additionally, the +lse option extension can be used in a
       similar fashion to other option extensions. The Large System
       Extensions introduce new instructions that are used in the
       implementation of atomic operations.
     * The ACLE half-precision floating-point type __fp16 is now supported
       in the C and C++ languages.
     * The ARM Cortex-A35 processor is now supported via the
       -mcpu=cortex-a35 and -mtune=cortex-a35 options as well as the
       equivalent target attributes and pragmas.
     * The Qualcomm QDF24xx processor is now supported via the
       -mcpu=qdf24xx and -mtune=qdf24xx options as well as the equivalent
       target attributes and pragmas.
     * Code generation for the ARM Cortex-A57 processor is improved. Among
       general code generation improvements, a better algorithm is added
       for allocating registers to floating-point multiply-accumulate
       instructions offering increased performance when compiling with
       -mcpu=cortex-a57 or -mtune=cortex-a57.
     * Code generation for the ARM Cortex-A53 processor is improved. A
       more accurate instruction scheduling model for the processor is now
       used, and a number of compiler tuning parameters have been set to
       offer increased performance when compiling with -mcpu=cortex-a53 or
       -mtune=cortex-a53.
     * Code generation for the Samsung Exynos M1 processor is improved. A
       more accurate instruction scheduling model for the processor is now
       used, and a number of compiler tuning parameters have been set to
       offer increased performance when compiling with -mcpu=exynos-m1 or
       -mtune=exynos-m1.
     * Improvements in the generation of conditional branches and literal
       pools allow the compiler to compile functions of a large size.
       Constant pools are now placed into separate rodata sections. The
       new option -mpc-relative-literal-loads generates per-function
       literal pools, limiting the maximum size of functions to 1MiB.
     * Several correctness issues generating Advanced SIMD instructions
       for big-endian targets have been fixed resulting in improved code
       generation for ACLE intrinsics with -mbig-endian.

  ARM

     * Support for revisions of the ARM architecture prior to ARMv4t has
       been deprecated and will be removed in a future GCC release. The
       -mcpu and -mtune values that are deprecated are: arm2, arm250,
       arm3, arm6, arm60, arm600, arm610, arm620, arm7, arm7d, arm7di,
       arm70, arm700, arm700i, arm710, arm720, arm710c, arm7100, arm7500,
       arm7500fe, arm7m, arm7dm, arm7dmi, arm8, arm810, strongarm,
       strongarm110, strongarm1100, strongarm1110, fa526, fa626. The value
       arm7tdmi is still supported. The values of -march that are
       deprecated are: armv2,armv2a,armv3,armv3m,armv4.
     * The ARM port now supports target attributes and pragmas. Please
       refer to the [18]documentation for details of available attributes
       and pragmas as well as usage instructions.
     * Support has been added for the following processors (GCC
       identifiers in parentheses): ARM Cortex-A32 (cortex-a32), ARM
       Cortex-A35 (cortex-a35) and ARM Cortex-R8 (cortex-r8). The GCC
       identifiers can be used as arguments to the -mcpu or -mtune
       options, for example: -mcpu=cortex-a32 or -mtune=cortex-a35.

  Heterogeneous Systems Architecture

     * GCC can now generate HSAIL (Heterogeneous System Architecture
       Intermediate Language) for simple OpenMP device constructs if
       configured with --enable-offload-targets=hsa. A new libgomp plugin
       then runs the HSA GPU kernels implementing these constructs on HSA
       capable GPUs via a standard HSA run time.
       If the HSA compilation back end determines it cannot output HSAIL
       for a particular input, it gives a warning by default. These
       warnings can be suppressed with -Wno-hsa. To give a few examples,
       the HSA back end does not implement compilation of code using
       function pointers, automatic allocation of variable sized arrays,
       functions with variadic arguments as well as a number of other less
       common programming constructs.
       When compilation for HSA is enabled, the compiler attempts to
       compile composite OpenMP constructs

#pragma omp target teams distribute parallel for

       into parallel HSA GPU kernels.

  IA-32/x86-64

     * GCC now supports the Intel CPU named Skylake with AVX-512
       extensions through -march=skylake-avx512. The switch enables the
       following ISA extensions: AVX-512F, AVX512VL, AVX-512CD, AVX-512BW,
       AVX-512DQ.
     * Support for new AMD instructions monitorx and mwaitx has been
       added. This includes new intrinsic and built-in support. It is
       enabled through option -mmwaitx. The instructions monitorx and
       mwaitx implement the same functionality as the old monitor and
       mwait instructions. In addition mwaitx adds a configurable timer.
       The timer value is received as third argument and stored in
       register %ebx.
     * x86-64 targets now allow stack realignment from a word-aligned
       stack pointer using the command-line option -mstackrealign or
       __attribute__ ((force_align_arg_pointer)). This allows functions
       compiled with a vector-aligned stack to be invoked from objects
       that keep only word-alignment.
     * Support for address spaces __seg_fs, __seg_gs, and __seg_tls. These
       can be used to access data via the %fs and %gs segments without
       having to resort to inline assembly. Please refer to the
       [19]documentation for usage instructions.
     * Support for AMD Zen (family 17h) processors is now available
       through the -march=znver1 and -mtune=znver1 options.

  MeP

     * Support for the MeP (mep-elf) architecture has been deprecated and
       will be removed in a future GCC release.

  MSP430

     * The MSP430 compiler now has the ability to automatically distribute
       code and data between low memory (addresses below 64K) and high
       memory. This only applies to parts that actually have both memory
       regions and only if the linker script for the part has been
       specifically set up to support this feature.
       A new attribute of either can be applied to both functions and
       data, and this tells the compiler to place the object into low
       memory if there is room and into high memory otherwise. Two other
       new attributes - lower and upper - can be used to explicitly state
       that an object should be placed in the specified memory region. If
       there is not enough left in that region the compilation will fail.
       Two new command-line options - -mcode-region=[lower|upper|either]
       and -mdata-region=[lower|upper|either] - can be used to tell the
       compiler what to do with objects that do not have one of these new
       attributes.

  PowerPC / PowerPC64 / RS6000

     * PowerPC64 now supports IEEE 128-bit floating-point using the
       __float128 data type. In GCC 6, this is not enabled by default, but
       you can enable it with -mfloat128. The IEEE 128-bit floating-point
       support requires the use of the VSX instruction set. IEEE 128-bit
       floating-point values are passed and returned as a single vector
       value. The software emulator for IEEE 128-bit floating-point
       support is only built on PowerPC GNU/Linux systems where the
       default CPU is at least power7. On future ISA 3.0 systems (POWER 9
       and later), you will be able to use the -mfloat128-hardware option
       to use the ISA 3.0 instructions that support IEEE 128-bit
       floating-point. An additional type (__ibm128) has been added to
       refer to the IBM extended double type that normally implements long
       double. This will allow for a future transition to implementing
       long double with IEEE 128-bit floating-point.
     * Basic support has been added for POWER9 hardware that will use the
       recently published OpenPOWER ISA 3.0 instructions. The following
       new switches are available:
          + -mcpu=power9: Implement all of the ISA 3.0 instructions
            supported by the compiler.
          + -mtune=power9: In the future, apply tuning for POWER9 systems.
            Currently, POWER8 tunings are used.
          + -mmodulo: Generate code using the ISA 3.0 integer instructions
            (modulus, count trailing zeros, array index support, integer
            multiply/add).
          + -mpower9-fusion: Generate code to suitably fuse instruction
            sequences for a POWER9 system.
          + -mpower9-dform: Generate code to use the new D-form
            (register+offset) memory instructions for the vector
            registers.
          + -mpower9-vector: Generate code using the new ISA 3.0 vector
            (VSX or Altivec) instructions.
          + -mpower9-minmax: Reserved for future development.
          + -mtoc-fusion: Keep TOC entries together to provide more fusion
            opportunities.
     * New constraints have been added to support IEEE 128-bit
       floating-point and ISA 3.0 instructions:
          + wb: Altivec register if -mpower9-dform is enabled.
          + we: VSX register if -mpower9-vector is enabled for 64-bit code
            generation.
          + wo: VSX register if -mpower9-vector is enabled.
          + wp: Reserved for future use if long double is implemented with
            IEEE 128-bit floating-point instead of IBM extended double.
          + wq: VSX register if -mfloat128 is enabled.
          + wF: Memory operand suitable for POWER9 fusion load/store.
          + wG: Memory operand suitable for TOC fusion memory references.
          + wL: Integer constant identifying the element number mfvsrld
            accesses within a vector.
     * Support has been added for __builtin_cpu_is() and
       __builtin_cpu_supports(), allowing for very fast access to
       AT_PLATFORM, AT_HWCAP, and AT_HWCAP2 values. This requires use of
       glibc 2.23 or later.
     * All hardware transactional memory builtins now correctly behave as
       memory barriers. Programmers can use #ifdef __TM_FENCE__ to
       determine whether their "old" compiler treats the builtins as
       barriers.
     * Split-stack support has been added for gccgo on PowerPC64 for both
       big- and little-endian (but not for 32-bit). The gold linker from
       at least binutils 2.25.1 must be available in the PATH when
       configuring and building gccgo to enable split stack. (The
       requirement for binutils 2.25.1 applies to PowerPC64 only.) The
       split-stack feature allows a small initial stack size to be
       allocated for each goroutine, which increases as needed.
     * GCC on PowerPC now supports the standard lround function.
     * A new configuration option ---with-advance-toolchain=at was added
       for PowerPC 64-bit GNU/Linux systems to use the header files,
       library files, and the dynamic linker from a specific Advance
       Toolchain release instead of the default versions that are provided
       by the GNU/Linux distribution. In general, this option is intended
       for the developers of GCC, and it is not intended for general use.
     * The "q", "S", "T", and "t" asm-constraints have been removed.
     * The "b", "B", "m", "M", and "W" format modifiers have been removed.

  S/390, System z, IBM z Systems

     * Support for the IBM z13 processor has been added. When using the
       -march=z13 option, the compiler will generate code making use of
       the new instructions and registers introduced with the vector
       extension facility. The -mtune=z13 option enables z13 specific
       instruction scheduling without making use of new instructions.
       Compiling code with -march=z13 reduces the default alignment of
       vector types bigger than 8 bytes to 8. This is an ABI change and
       care must be taken when linking modules compiled with different
       arch levels which interchange variables containing vector type
       values. For newly compiled code the GNU linker will emit a warning.
     * The -mzvector option enables a C/C++ language extension. This
       extension provides a new keyword vector which can be used to define
       vector type variables. (Note: This is not available when enforcing
       strict standard compliance e.g. with -std=c99. Either enable GNU
       extensions with e.g. -std=gnu99 or use __vector instead of vector.)
       Additionally a set of overloaded builtins is provided which is
       partially compatible to the PowerPC Altivec builtins. In order to
       make use of these builtins the vecintrin.h header file needs to be
       included.
     * The new command-line options -march=native, and -mtune=native are
       now available on native IBM z Systems. Specifying these options
       causes GCC to auto-detect the host CPU and choose the optimal
       setting for that system. If GCC is unable to detect the host CPU
       these options have no effect.
     * The IBM z Systems port now supports target attributes and pragmas.
       Please refer to the [20]documentation for details of available
       attributes and pragmas as well as usage instructions.
     * -fsplit-stack is now supported as part of the IBM z Systems port.
       This feature requires a recent gold linker to be used.
     * Support for the g5 and g6 -march=/-mtune= CPU level switches has
       been deprecated and will be removed in a future GCC release. -m31
       from now on defaults to -march=z900 if not specified otherwise.
       -march=native on a g5/g6 machine will default to -march=z900.

  SH

     * Support for SH5 / SH64 has been declared obsolete and will be
       removed in future releases.
     * Support for the FDPIC ABI has been added. It can be enabled using
       the new -mfdpic target option and --enable-fdpic configure option.

  SPARC

     * An ABI bug has been fixed in 64-bit mode. Unfortunately, this
       change will break binary compatibility with earlier releases for
       code it affects, but this should be pretty rare in practice. The
       conditions are: a 16-byte structure containing a double or a 8-byte
       vector in the second half is passed to a subprogram in slot #15,
       for example as 16th parameter if the first 15 ones have at most 8
       bytes. The double or vector was wrongly passed in floating-point
       register %d32 in lieu of on the stack as per the SPARC calling
       conventions.

Operating Systems

  AIX

     * DWARF debugging support for AIX 7.1 has been enabled as an optional
       debugging format. A more recent Technology Level (TL) and GCC built
       with that level are required for full exploitation of DWARF
       debugging capabilities.

  Linux

     * Support for the [21]musl C library was added for the AArch64, ARM,
       MicroBlaze, MIPS, MIPS64, PowerPC, PowerPC64, SH, i386, x32 and
       x86_64 targets. It can be selected using the new -mmusl option in
       case musl is not the default libc. GCC defaults to musl libc if it
       is built with a target triplet matching the *-linux-musl* pattern.

  RTEMS

     * The RTEMS thread model implementation changed. Mutexes now use
       self-contained objects defined in Newlib <sys/lock.h> instead of
       Classic API semaphores. The keys for thread specific data and the
       once function are directly defined via <pthread.h>. Self-contained
       condition variables are provided via Newlib <sys/lock.h>. The RTEMS
       thread model also supports C++11 threads.
     * OpenMP support now uses self-contained objects provided by Newlib
       <sys/lock.h> and offers a significantly better performance compared
       to the POSIX configuration of libgomp. It is possible to configure
       thread pools for each scheduler instance via the environment
       variable GOMP_RTEMS_THREAD_POOLS.

  Solaris

     * Solaris 12 is now fully supported. Minimal support had already been
       present in GCC 5.3.
     * Solaris 12 provides a full set of startup files (crt1.o, crti.o,
       crtn.o), which GCC now prefers over its own ones.
     * Position independent executables (PIE) are now supported on Solaris
       12.
     * Constructor priority is now supported on Solaris 12 with the system
       linker.
     * libvtv has been ported to Solaris 11 and up.

  Windows

     * The option -mstackrealign is now automatically activated in 32-bit
       mode whenever the use of SSE instructions is requested.

Other significant improvements

     * The gcc and g++ driver programs will now provide suggestions for
       misspelled command-line options.

$ gcc -static-libfortran test.f95
gcc: error: unrecognized command line option '-static-libfortran'; did you mean
'-static-libgfortran'?

     * The --enable-default-pie configure option enables generation of PIE
       by default.

                                    GCC 6.2

   This is the [22]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 6.2 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Target Specific Changes

  SPARC

     * Support for --with-cpu-32 and --with-cpu-64 configure options has
       been added on bi-architecture platforms.
     * Support for the SPARC M7 (Niagara 7) processor has been added.
     * Support for the VIS 4.0 instruction set has been added.

                                    GCC 6.3

   This is the [23]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 6.3 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Target Specific Changes

  IA-32/x86-64

     * Support for the [24]deprecated pcommit instruction has been
       removed.

                                    GCC 6.4

   This is the [25]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 6.4 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).

Operating Systems

  RTEMS

     * The ABI changes on ARM so that no short enums are used by default.

                                    GCC 6.5

   This is the [26]list of problem reports (PRs) from GCC's bug tracking
   system that are known to be fixed in the 6.5 release. This list might
   not be complete (that is, it is possible that some PRs that have been
   fixed are not listed here).


    For questions related to the use of GCC, please consult these web
    pages and the [27]GCC manuals. If that fails, the
    [28]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [29]gcc@gcc.gnu.org. All of [30]our lists have public
    archives.

   Copyright (C) [31]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [32]maintained by the GCC team. Last modified
   2021-10-31[33].

References

   1. http://gcc.gnu.org/gcc-6/porting_to.html
   2. http://gcc.gnu.org/onlinedocs/index.html#current
   3. https://gcc.gnu.org/ml/gcc/2015-08/msg00101.html
   4. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=71151
   5. https://gcc.gnu.org/bugzilla/show_bug.cgi?id=87822
   6. https://www.openacc.org/
   7. https://gcc.gnu.org/wiki/OpenACC
   8. https://gcc.gnu.org/wiki/Offloading
   9. https://www.openmp.org/specifications/
  10. https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2014-1266
  11. http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2015/n4377.pdf
  12. https://gcc.gnu.org/projects/cxx-status.html#cxx1z
  13. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/performance.html
  14. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/functions.html#gcc_jit_block_end_with_switch
  15. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/contexts.html#gcc_jit_context_set_bool_allow_unreachable_blocks
  16. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/jit/topics/contexts.html#gcc_jit_context_add_command_line_option
  17. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/AArch64-Function-Attributes.html#AArch64-Function-Attributes
  18. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/ARM-Function-Attributes.html#ARM-Function-Attributes
  19. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/Named-Address-Spaces.html#Named-Address-Spaces
  20. https://gcc.gnu.org/onlinedocs/gcc-6.1.0/gcc/S_002f390-Function-Attributes.html#S_002f390-Function-Attributes
  21. http://www.musl-libc.org/
  22. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=6.2
  23. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=6.3
  24. https://www.intel.com/content/www/us/en/developer/articles/technical/deprecate-pcommit-instruction.html
  25. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=6.4
  26. https://gcc.gnu.org/bugzilla/buglist.cgi?bug_status=RESOLVED&resolution=FIXED&target_milestone=6.5
  27. https://gcc.gnu.org/onlinedocs/
  28. mailto:gcc-help@gcc.gnu.org
  29. mailto:gcc@gcc.gnu.org
  30. https://gcc.gnu.org/lists.html
  31. https://www.fsf.org/
  32. https://gcc.gnu.org/about.html
  33. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-5/index.html
                              GCC 5 Release Series

   (This release series is no longer supported.)

   October 10, 2017

   The [1]GNU project and the GCC developers are pleased to announce the
   release of GCC 5.5.

   This release is a bug-fix release, containing fixes for regressions in
   GCC 5.4 relative to previous releases of GCC.

Release History

   GCC 5.5
          October 10, 2017 ([2]changes, [3]documentation)

   GCC 5.4
          June 3, 2016 ([4]changes, [5]documentation)

   GCC 5.3
          December 4, 2015 ([6]changes, [7]documentation)

   GCC 5.2
          July 16, 2015 ([8]changes, [9]documentation)

   GCC 5.1
          April 22, 2015 ([10]changes, [11]documentation)

References and Acknowledgements

   GCC used to stand for the GNU C Compiler, but since the compiler
   supports several other languages aside from C, it now stands for the
   GNU Compiler Collection.

   A list of [12]successful builds is updated as new information becomes
   available.

   The GCC developers would like to thank the numerous people that have
   contributed new features, improvements, bug fixes, and other changes as
   well as test results to GCC. This [13]amazing group of volunteers is
   what makes GCC successful.

   For additional information about GCC please refer to the [14]GCC
   project web site or contact the [15]GCC development mailing list.

   To obtain GCC please use [16]our mirror sites or [17]our version
   control system.


    For questions related to the use of GCC, please consult these web
    pages and the [18]GCC manuals. If that fails, the
    [19]gcc-help@gcc.gnu.org mailing list might help. Comments on these
    web pages and the development of GCC are welcome on our developer
    list at [20]gcc@gcc.gnu.org. All of [21]our lists have public
    archives.

   Copyright (C) [22]Free Software Foundation, Inc. Verbatim copying and
   distribution of this entire article is permitted in any medium,
   provided this notice is preserved.

   These pages are [23]maintained by the GCC team. Last modified
   2021-07-28[24].

References

   1. http://www.gnu.org/
   2. http://gcc.gnu.org/gcc-5/changes.html
   3. http://gcc.gnu.org/onlinedocs/5.5.0/
   4. http://gcc.gnu.org/gcc-5/changes.html
   5. http://gcc.gnu.org/onlinedocs/5.4.0/
   6. http://gcc.gnu.org/gcc-5/changes.html
   7. http://gcc.gnu.org/onlinedocs/5.3.0/
   8. http://gcc.gnu.org/gcc-5/changes.html
   9. http://gcc.gnu.org/onlinedocs/5.2.0/
  10. http://gcc.gnu.org/gcc-5/changes.html
  11. http://gcc.gnu.org/onlinedocs/5.1.0/
  12. http://gcc.gnu.org/gcc-5/buildstat.html
  13. http://gcc.gnu.org/onlinedocs/gcc/Contributors.html
  14. http://gcc.gnu.org/index.html
  15. mailto:gcc@gcc.gnu.org
  16. http://gcc.gnu.org/mirrors.html
  17. http://gcc.gnu.org/git.html
  18. https://gcc.gnu.org/onlinedocs/
  19. mailto:gcc-help@gcc.gnu.org
  20. mailto:gcc@gcc.gnu.org
  21. https://gcc.gnu.org/lists.html
  22. https://www.fsf.org/
  23. https://gcc.gnu.org/about.html
  24. http://validator.w3.org/check/referer
======================================================================
http://gcc.gnu.org/gcc-5/changes.html
                              GCC 5 Release Series
                        Changes, New Features, and Fixes

Caveats

     * The default mode for C is now -std=gnu11 instead of -std=gnu89.
     * The C++ runtime library (libstdc++) uses a new ABI by default (see
       [1]below).
     * The Graphite framework for loop optimizations no longer requires
       the CLooG library, only ISL version 0.14 (recommended) or 0.12.2.
       The installation manual contains more information about
       requirements to build GCC.
     * The non-standard C++0x type traits has_trivial_default_constructor,
       has_trivial_copy_constructor and has_trivial_copy_assign have been
       deprecated and will be removed in a future version. The standard
       C++11 traits is_trivially_default_constructible,
       is_trivially_copy_constructible and is_trivially_copy_assignable
       should be used instead.
     * On AVR, support has been added for the devices
       ATtiny4/5/9/10/20/40. This requires Binutils 2.25 or newer.
     * The AVR port uses a new scheme to describe supported devices: For
       each supported device the compiler provides a device-specific
       [2]spec file. If the compiler is used together with AVR-LibC, this
       requires at least GCC 5.2 and a version of AVR-LibC which
       implements [3]feature #44574.

General Optimizer Improvements

     * Inter-procedural optimization improvements:
          + An Identical Code Folding (ICF) pass (controlled via
            -fipa-icf) has been added. Compared to the identical code
            folding performed by the Gold linker this pass does not
            require function sections. It also performs merging before
            inlining, so inter-procedural optimizations are aware of the
            code re-use. On the other hand not all unifications performed
            by a linker are doable by GCC which must honor aliasing
            information. During link-time optimization of Firefox, this
            pass unifies about 31000 functions, that is 14% overall.
          + The devirtualization pass was significantly improved by adding
            better support for speculative devirtualization and dynamic
            type detection. About 50% of virtual calls in Firefox are now
            speculatively devirtualized during link-time optimization.
          + A new comdat localization pass allows the linker to eliminate
            more dead code in presence of C++ inline functions.
          + Virtual tables are now optimized. Local aliases are used to
            reduce dynamic linking time of C++ virtual tables on ELF
            targets and data alignment has been reduced to limit data
            segment bloat.
          + A new -fno-semantic-interposition option can be used to
            improve code quality of shared libraries where interposition
            of exported symbols is not allowed.
          + Write-only variables are now detected and optimized out.
          + With profile feedback the function inliner can now bypass
            --param inline-insns-auto and --param inline-insns-single
            limits for hot calls.
          + The IPA reference pass was significantly sped up making it
            feasible to enable -fipa-reference with -fprofile-generate.
            This also solves a bottleneck seen when building Chromium with
            link-time optimization.
          + The symbol table and call-graph API was reworked to C++ and
            simplified.
          + The interprocedural propagation of constants now also
            propagates alignments of pointer parameters. This for example
            means that the vectorizer often does not need to generate loop
            prologues and epilogues to make up for potential
            misalignments.
     * Link-time optimization improvements:
          + One Definition Rule based merging of C++ types has been
            implemented. Type merging enables better devirtualization and
            alias analysis. Streaming extra information needed to merge
            types adds about 2-6% of memory size and object size increase.
            This can be controlled by -flto-odr-type-merging.
          + Command-line optimization and target options are now streamed
            on a per-function basis and honored by the link-time
            optimizer. This change makes link-time optimization a more
            transparent replacement of per-file optimizations. It is now
            possible to build projects that require different optimization
            settings for different translation units (such as -ffast-math,
            -mavx, or -finline). Contrary to earlier GCC releases, the
            optimization and target options passed on the link command
            line are ignored.
            Note that this applies only to those command-line options that
            can be passed to optimize and target attributes. Command-line
            options affecting global code generation (such as -fpic),
            warnings (such as -Wodr), optimizations affecting the way
            static variables are optimized (such as -fcommon), debug
